'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * IronCollapse component implementation.
 */
var IronCollapse = function (_React$Component) {
  _inherits(IronCollapse, _React$Component);

  function IronCollapse(props) {
    _classCallCheck(this, IronCollapse);

    var _this = _possibleConstructorReturn(this, (IronCollapse.__proto__ || Object.getPrototypeOf(IronCollapse)).call(this, props));

    _this.state = {
      noAnimation: props.noAnimation || false,
      horizontal: props.horizontal || false,
      opened: props.opened || false,
      style: null
    };
    _this._handleRef = _this._handleRef.bind(_this);
    _this._transitionEndBound = _this._transitionEnd.bind(_this);
    return _this;
  }

  _createClass(IronCollapse, [{
    key: '_calcSize',

    /* eslint-ignore-stop */
    value: function _calcSize() {
      return this.base.getBoundingClientRect()[this.dimension] + 'px';
    }
  }, {
    key: 'toggleClass',
    value: function toggleClass(name, bool) {
      if (bool) {
        this.base.classList.add(name);
      } else {
        this.base.classList.remove(name);
      }
    }
  }, {
    key: '_transitionEnd',
    value: function _transitionEnd() {
      if (this.state.opened) {
        this.base.style[this.dimension] = 'auto';
      }
      this._updateTransition(false);
      this.toggleClass('iron-collapse-closed', !this.state.opened);
    }
  }, {
    key: '_updateTransition',
    value: function _updateTransition(enabled) {
      this.base.style.transitionDuration = enabled && !this.state.noAnimation ? '' : '0s';
    }
  }, {
    key: 'focus',
    value: function focus() {
      this.base.focus();
    }
  }, {
    key: 'updateSize',
    value: function updateSize(size, animated) {
      var newSize = size;
      if (this.base.style[this.dimension] === size) {
        return;
      }
      this._updateTransition(false);
      if (animated && !this.state.noAnimation && this._isDisplayed) {
        var startSize = this._calcSize();

        // For `auto` we must calculate what is the final size for the animation.
        // After the transition is done, _transitionEnd will set the size back to `auto`.
        if (size === 'auto') {
          this.base.style[this.dimension] = size;
          newSize = this._calcSize();
        }
        this.base.style[this.dimension] = startSize;
        this.base.style.height = this.base.offsetHeight;
        this._updateTransition(true);
      }
      this.base.style[this.dimension] = newSize;
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      if (this.state.opened) {
        this.hide();
      } else {
        this.show();
      }
    }

    /** Show content */

  }, {
    key: 'show',
    value: function show() {
      this.setState({ opened: true });
    }

    /** Hide content */

  }, {
    key: 'hide',
    value: function hide() {
      this.setState({ opened: false });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.opened !== this.state.opened) {
        this.setState({ opened: nextProps.opened });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.updateSize(this.state.opened ? 'auto' : '0px', true);
      if (this.state.opened) {
        this.focus();
      }
      if (this.state.noAnimation) {
        this._transitionEnd();
      }
      if (this.props.onChange) {
        this.props.onChange(this.state);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.base) {
        this.base.addEventListener('transitionend', this._transitionEndBound);
        this._transitionEnd();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.base) {
        this.base.removeEventListener('transitionend', this._transitionEndBound);
      }
    }
  }, {
    key: '_handleRef',
    value: function _handleRef(el) {
      this.base = el;
    }
  }, {
    key: 'render',
    value: function render() {
      var opened = this.state.opened;
      var children = this.props.children;

      var baseClassnames = (0, _classnames2.default)('iron-collapse');

      return _react2.default.createElement(
        'div',
        {
          className: baseClassnames,
          ref: this._handleRef,
          'aria-hidden': !opened,
          'aria-expanded': opened
        },
        children,
        _react2.default.createElement(
          'style',
          null,
          '\n        .iron-collapse {\n          display: block;\n          -webkit-transition-duration: 300ms;\n          -moz-transition-duration: 300ms;\n          transition-duration: 300ms;\n          overflow: visible;\n        }\n        .iron-collapse:not(.iron-collapse-opened) {\n          overflow: hidden;\n        }\n      '
        )
      );
    }
  }, {
    key: 'dimension',
    get: function get() {
      return this.state.horizontal ? 'width' : 'height';
    }

    /* eslint-ignore-start */

  }, {
    key: '_isDisplayed',
    get: function get() {
      var rect = this.base.getBoundingClientRect();
      Object.keys(rect).forEach(function (key) {
        if (rect[key] !== 0) {
          return true;
        }
        return false;
      });
      return false;
    }
  }]);

  return IronCollapse;
}(_react2.default.Component);

IronCollapse.defaultProps = {
  horizontal: false,
  onChange: null,
  noAnimation: null,
  opened: false,
  children: null
};

IronCollapse.propTypes = process.env.NODE_ENV !== "production" ? {
  onChange: _propTypes2.default.func,
  horizontal: _propTypes2.default.bool,
  noAnimation: _propTypes2.default.bool,
  opened: _propTypes2.default.bool,
  children: _propTypes2.default.node
} : {};

exports.default = IronCollapse;