'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable */


/**
 * @description Base component class that all ui components extend.
 * @class BaseComponent
 */
var BaseComponent = function (_Component) {
  _inherits(BaseComponent, _Component);

  /**
   * constructor - description
   *
   * @param  {type} props description
   * @return {type}       description
   */
  function BaseComponent(props) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
      displayName: 'base-component',
      log: true
    };

    _classCallCheck(this, BaseComponent);

    var _this = _possibleConstructorReturn(this, (BaseComponent.__proto__ || Object.getPrototypeOf(BaseComponent)).call(this, props));

    _this.displayName = options.name || options.displayName;

    // TODO: Find a way to flag on or off
    options.log = true;
    if (options && options.log) {
      // eslint-disable-next-line no-console
      _this._log = function () {};
    } else {
      _this._log = function () {};
    }
    return _this;
  }

  _createClass(BaseComponent, [{
    key: 'setBaseRef',
    value: function setBaseRef(el) {
      this.base = el;
    }
  }, {
    key: '$$',
    value: function $$(slctr) {
      if (this.base) {
        return this.base.querySelector(slctr);
      }
    }
  }, {
    key: 'transform',
    value: function transform(_transform, node) {
      node = node || this.base;
      node.style.webkitTransform = _transform;
      node.style.transform = _transform;
    }
  }, {
    key: 'translate3d',
    value: function translate3d(x, y, z, node) {
      node = node || this.base;
      this.transform('translate3d(' + x + ', ' + y + ', ' + z + ')', node);
    }

    /**
     * componentWillMount - https://reactjs.org/docs/react-component.html#componentWillMount
     *
     * @return {type}  description
     */

  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {}
    // this._log('componentWillMount', this);


    /**
     * render - https://reactjs.org/docs/react-component.html#render
     *
     * @return {type}  description
     */

  }, {
    key: 'render',
    value: function render() {}
    // this._log('render', this);
    // return (<div>base-component</div>);


    /**
     * componentDidMount - https://reactjs.org/docs/react-component.html#componentDidMount
     *
     * @return {type}  description
     */

  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {}
    // this._log('componentDidMount', this);


    /**
     * Updating
     An update can be caused by changes to props or state.
     These methods are called when a component is being re-rendered:
     */

    /**
     * componentWillReceiveProps - https://reactjs.org/docs/react-component.html#componentWillReceiveProps
     *
     * @param  {type} nextProps description
     * @return {type}           description
     */

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {}
    // this._log('componentWillReceiveProps', nextProps);


    /**
     * shouldComponentUpdate - https://reactjs.org/docs/react-component.html#shouldComponentUpdate
     *
     * @param  {type} nextProps description
     * @param  {type} nextState description
     * @return {type}           description
     */

  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      // this._log('shouldComponentUpdate', nextProps, nextState);
      return true;
    }

    /**
     * componentWillUpdate - https://reactjs.org/docs/react-component.html#componentwillupdate
     *
     * @param  {type} nextProps description
     * @param  {type} nextState description
     * @return {type}           description
     */

  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      // this._log('shouldComponentUpdate', nextProps, nextState);
      return true;
    }

    /**
     * componentWillUnmount -  https://reactjs.org/docs/react-component.html#componentWillUnmount
     *
     * @return {type}  description
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // this._log('componentWillUnmount');
    }
  }]);

  return BaseComponent;
}(_react.Component);

exports.default = BaseComponent;