'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  display         : flex;\n  align-items     : center;\n  width           : inherit;\n  justify-content : space-between;\n  height          : var(--px-branding-bar-height, 30px);\n  max-height      : 67px;\n  min-height      : 30px;\n  background-color: var(--px-branding-bar-background-color, black);\n  font-size       : var(--px-branding-bar-font-size, 15px);\n  color           : var(--px-branding-bar-logo-and-title-text-color, gray);\n  padding         : 0 1rem;\n\n  ', '\n'], ['\n  display         : flex;\n  align-items     : center;\n  width           : inherit;\n  justify-content : space-between;\n  height          : var(--px-branding-bar-height, 30px);\n  max-height      : 67px;\n  min-height      : 30px;\n  background-color: var(--px-branding-bar-background-color, black);\n  font-size       : var(--px-branding-bar-font-size, 15px);\n  color           : var(--px-branding-bar-logo-and-title-text-color, gray);\n  padding         : 0 1rem;\n\n  ', '\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n      @media (max-width: ', ') {\n        display   : none !important;\n        visibility: hidden;\n    }\n  '], ['\n      @media (max-width: ', ') {\n        display   : none !important;\n        visibility: hidden;\n    }\n  ']),
    _templateObject3 = _taggedTemplateLiteral(['\n  margin-left: .5rem;\n'], ['\n  margin-left: .5rem;\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  font-size: 12px;\n  margin-right: .3rem;\n'], ['\n  font-size: 12px;\n  margin-right: .3rem;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _pxPredixSvgLogo = require('./px-predix-svg-logo');

var _pxPredixSvgLogo2 = _interopRequireDefault(_pxPredixSvgLogo);

var _pxGeSvgLogo = require('./px-ge-svg-logo');

var _pxGeSvgLogo2 = _interopRequireDefault(_pxGeSvgLogo);

var _flex = require('../../../styles/flex');

var _flex2 = _interopRequireDefault(_flex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var BrandingBar = _styledComponents2.default.div(_templateObject, function (props) {
  return props.responsiveWidth && (0, _styledComponents.css)(_templateObject2, props.responsiveWidth);
});
BrandingBar.displayName = 'BrandingBar';
BrandingBar.defaultProps = {
  responsiveWidth: '768px'
};

var BrandingBarTitle = _styledComponents2.default.div(_templateObject3);
BrandingBarTitle.displayName = 'BrandingBarTitle';

var BrandingBarPoweredBy = _styledComponents2.default.div(_templateObject4);
BrandingBarPoweredBy.displayName = 'BrandingBarPoweredBy';

var Component = function Component(_ref) {
  var title = _ref.title,
      powered = _ref.powered,
      hideLogo = _ref.hideLogo,
      customLogo = _ref.customLogo,
      hidePowered = _ref.hidePowered,
      responsiveWidth = _ref.responsiveWidth,
      children = _ref.children;
  return _react2.default.createElement(
    BrandingBar,
    { responsiveWidth: responsiveWidth },
    _react2.default.createElement(
      _flex2.default,
      { middle: true, flex: 1 },
      _react2.default.createElement(
        _flex2.default,
        { middle: true },
        !customLogo && !hideLogo && _react2.default.createElement(_pxGeSvgLogo2.default, null),
        customLogo && customLogo()
      ),
      _react2.default.createElement(
        _flex2.default,
        { middle: true },
        _react2.default.createElement(
          BrandingBarTitle,
          null,
          title
        )
      )
    ),
    children && _react2.default.createElement(
      'div',
      null,
      children
    ),
    !hidePowered && _react2.default.createElement(
      _flex2.default,
      { middle: true },
      _react2.default.createElement(
        BrandingBarPoweredBy,
        null,
        powered
      ),
      _react2.default.createElement(_pxPredixSvgLogo2.default, { size: 10 })
    )
  );
};

Component.propTypes = process.env.NODE_ENV !== "production" ? {
  title: _propTypes2.default.string,
  powered: _propTypes2.default.string,
  responsiveWidth: _propTypes2.default.string,
  hideLogo: _propTypes2.default.bool,
  hidePowered: _propTypes2.default.bool,
  customLogo: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};

Component.defaultProps = {
  title: 'App Name',
  responsiveWidth: '500px',
  powered: 'Powered by React',
  hideLogo: false,
  hidePowered: false,
  customLogo: null,
  children: null
};

Component.displayName = 'BrandingBarComponent';

exports.default = Component;