'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Icon = require('../IconSet/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _flex = require('../../../styles/flex');

var _flex2 = _interopRequireDefault(_flex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BreadcrumbsComponent = function (_React$Component) {
  _inherits(BreadcrumbsComponent, _React$Component);

  function BreadcrumbsComponent(props) {
    _classCallCheck(this, BreadcrumbsComponent);

    var _this = _possibleConstructorReturn(this, (BreadcrumbsComponent.__proto__ || Object.getPrototypeOf(BreadcrumbsComponent)).call(this, props));

    _this.clickOnlyMode = props.clickOnlyMode || false;
    //  this._assetGraph = new AssetGraph(props.items || []);

    _this.keys = props.keys;

    _this.handleRef = _this.handleRef.bind(_this);
    _this._getItemProp = _this._getItemProp.bind(_this);
    _this._isLabel = _this._isLabel.bind(_this);
    _this._isDropdown = _this._isDropdown.bind(_this);
    _this._doesItemHaveSiblings = _this._doesItemHaveSiblings.bind(_this);
    _this._isNotFirstItemInData = _this._isNotFirstItemInData.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(BreadcrumbsComponent, [{
    key: 'handleClick',
    value: function handleClick(e, index, item) {
      if (this.props.onClick) {
        this.props.onClick(e, index, item);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.root) {
        /*
          this.refs.root,
          this._assetGraph,
          this.clickOnlyMode,
          this.props.items,
          this.keys
        ); */
      }
    }
  }, {
    key: 'handleRef',
    value: function handleRef(el) {
      this.root = el;
    }
    /**
     * Fetches an item's property at the configured key. Used to dynamically
     * fetch the item's label, icon, children, etc. based on the configured
     * `keys` for the component.
     */
    /* eslint-disable*/

  }, {
    key: '_getItemProp',
    value: function _getItemProp(item, key) {
      if (item && (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && typeof key === 'string' && item[key]) {
        return item[key];
      }
      return null;
    }
  }, {
    key: '_isNotFirstItemInData',
    value: function _isNotFirstItemInData(index) {
      return index !== 0;
    }
    /**
     * This function checks whether the item in question has siblings.
     * If the item is an overflow item, we return a false,
     * since it's not going to be in the graph anyway.
     */

  }, {
    key: '_doesItemHaveSiblings',
    value: function _doesItemHaveSiblings(itemInPath) {
      var graph = this._assetGraph;
      var source = itemInPath.source ? itemInPath.source : itemInPath;
      var isItemOverflow = this._getItemProp(itemInPath, this.keys.label) === '...';
      return isItemOverflow ? true : graph.hasSiblings(source);
    }
    /**
     * These three methods are used to determine which type of node to render.
     * Returns true if clickOnlyMode is turned on and its not the overflow node.
     */

  }, {
    key: '_isLabel',
    value: function _isLabel(item, clickOnlyMode) {
      return clickOnlyMode && this._getItemProp(item, this.keys.label) !== '...' || !clickOnlyMode && !this._doesItemHaveSiblings(item);
    }
    /**
     * These three methods are used to determine which type of node to render.
     * Returns true if clickOnlyMode is turned off and its not the overflow node.
     */

  }, {
    key: '_isDropdown',
    value: function _isDropdown(item, clickOnlyMode) {
      return !clickOnlyMode && this._getItemProp(item, this.keys.label) !== '...' && this._doesItemHaveSiblings(item);
    }
    /**
     * These three methods are used to determine which type of node to render.
     * Returns true if this is the overflow node.
     */

  }, {
    key: '_isOverflow',
    value: function _isOverflow(item) {
      return this._getItemProp(item, this.keys.label) === '...';
    }
    /**
     * Determines whether to display small or large chevrons based on whether
     * `clickOnlyMode` is enabled.
     */

  }, {
    key: '_getSeparatorSize',
    value: function _getSeparatorSize(clickOnlyMode) {
      return clickOnlyMode ? 'small' : 'large';
    }
    /**
    * Returns a disabled class if the item is set as non-selectable.
    */

  }, {
    key: '_getDisabled',
    value: function _getDisabled(item) {
      return item.isSelectable === false ? 'disabled' : '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var selectedRoute = this.props.selectedRoute;


      return _react2.default.createElement(
        'div',
        { ref: this.handleRef },
        _react2.default.createElement(
          _flex2.default,
          { middle: true },
          selectedRoute && selectedRoute.map(function (label, index) {
            return _react2.default.createElement(
              'div',
              { 'data-index': index, className: 'breadcrumbTopItem', key: label },
              _react2.default.createElement(
                _flex2.default,
                { middle: true },
                _this2._isNotFirstItemInData(index, selectedRoute) && _react2.default.createElement(_Icon2.default, { icon: 'px-utl:chevron-right', size: 24, viewBox: '0 0 16 16' }),
                _react2.default.createElement(
                  'span',
                  {
                    className: 'actionable actionable--action u-ph-',
                    onClick: _this2.handleClick.bind(_this2, index, selectedRoute) /* eslint-ignore-line */
                  },
                  label
                )
              )
            );
          })
        )
      );
    }
  }]);

  return BreadcrumbsComponent;
}(_react2.default.Component);

BreadcrumbsComponent.defaultProps = {
  clickOnlyMode: false,
  onClick: null,
  selectedRoute: null,
  keys: {
    id: 'id',
    label: 'label',
    children: 'children'
  }
};

var shape = _propTypes2.default.shape({
  id: _propTypes2.default.string,
  label: _propTypes2.default.string,
  children: _propTypes2.default.arrayOf(shape)
});

BreadcrumbsComponent.propTypes = process.env.NODE_ENV !== "production" ? {
  clickOnlyMode: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  selectedRoute: _propTypes2.default.arrayOf(_propTypes2.default.string),
  keys: _propTypes2.default.shape({
    id: _propTypes2.default.string,
    label: _propTypes2.default.string,
    children: _propTypes2.default.string
  })
} : {};

exports.default = BreadcrumbsComponent;