'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  display         : inline-block;\n  align-items     : center;\n  height          : 20px;\n  padding-left    : 10px;\n  padding-right   : 10px;\n  background-color: var(--px-chip-background-color, white);\n  border          : 1px solid var(--px-chip-border-color, gray);\n\n  &:hover {\n    cursor          : pointer;\n    background-color: var(--px-chip-background-color--hover, rgba(gray, 0.2));\n    border          : 1px solid var(--px-chip-border-color--hover, gray);\n  }\n\n  ', '\n\n'], ['\n  display         : inline-block;\n  align-items     : center;\n  height          : 20px;\n  padding-left    : 10px;\n  padding-right   : 10px;\n  background-color: var(--px-chip-background-color, white);\n  border          : 1px solid var(--px-chip-border-color, gray);\n\n  &:hover {\n    cursor          : pointer;\n    background-color: var(--px-chip-background-color--hover, rgba(gray, 0.2));\n    border          : 1px solid var(--px-chip-border-color--hover, gray);\n  }\n\n  ', '\n\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n    background-color: var(--px-chip-background-color--selected, white);\n    border          : 1px solid var(--px-chip-border-color--selected, blue);\n  '], ['\n    background-color: var(--px-chip-background-color--selected, white);\n    border          : 1px solid var(--px-chip-border-color--selected, blue);\n  ']),
    _templateObject3 = _taggedTemplateLiteral(['\n  line-height: 18px;\n  display    : inline-block;\n  min-width  : 0;\n  max-width  : var(--px-chip-max-width, 120px);\n  color      : var(--px-chip-text-color, gray);\n'], ['\n  line-height: 18px;\n  display    : inline-block;\n  min-width  : 0;\n  max-width  : var(--px-chip-max-width, 120px);\n  color      : var(--px-chip-text-color, gray);\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  height: 12px;\n  width : 12px;\n  &:hover{\n    color: var(--px-chip-icon-color--hover, blue);\n  }\n'], ['\n  height: 12px;\n  width : 12px;\n  &:hover{\n    color: var(--px-chip-icon-color--hover, blue);\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Chip = _styledComponents2.default.div(_templateObject, function (props) {
  return props.selected && (0, _styledComponents.css)(_templateObject2);
});

var ChipContent = _styledComponents2.default.div(_templateObject3);

var ChipIcon = _styledComponents2.default.div(_templateObject4);

/**
 * Chip component
 */
var Component = function Component(_ref) {
  var icon = _ref.icon,
      selected = _ref.selected,
      showIcon = _ref.showIcon,
      children = _ref.children;
  return _react2.default.createElement(
    Chip,
    { selected: selected },
    _react2.default.createElement(
      ChipContent,
      null,
      children,
      showIcon && _react2.default.createElement(
        ChipIcon,
        null,
        icon
      )
    )
  );
};

Component.defaultProps = {
  icon: null,
  selected: null,
  showIcon: false,
  children: null
};

Component.propTypes = process.env.NODE_ENV !== "production" ? {
  icon: _propTypes2.default.string,
  selected: _propTypes2.default.bool,
  showIcon: _propTypes2.default.bool,
  children: _propTypes2.default.node
} : {};

exports.default = Component;