'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  color: var(--iron-icon-stroke-color, inherit);\n  fill: var(--iron-icon-fill-color, none);\n  stroke: var(--iron-icon-stroke-color, currentColor);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  position: relative;\n  vertical-align: middle;\n  width: var(--iron-icon-width);\n  height: var(--iron-icon-height);\n  > svg {\n    color         : var(--iron-icon-stroke-color, inherit);\n    fill          : var(--iron-icon-fill-color, none);\n    stroke        : var(--iron-icon-stroke-color, currentColor);\n    position      : relative;\n    vertical-align: middle;\n  }\n  ', '\n  &.hidden {\n    display: none;\n  }\n'], ['\n  color: var(--iron-icon-stroke-color, inherit);\n  fill: var(--iron-icon-fill-color, none);\n  stroke: var(--iron-icon-stroke-color, currentColor);\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  position: relative;\n  vertical-align: middle;\n  width: var(--iron-icon-width);\n  height: var(--iron-icon-height);\n  > svg {\n    color         : var(--iron-icon-stroke-color, inherit);\n    fill          : var(--iron-icon-fill-color, none);\n    stroke        : var(--iron-icon-stroke-color, currentColor);\n    position      : relative;\n    vertical-align: middle;\n  }\n  ', '\n  &.hidden {\n    display: none;\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n    color: ', ' !important;\n  '], ['\n    color: ', ' !important;\n  ']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _ = require('./');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var PxIcon = _styledComponents2.default.i(_templateObject, function (props) {
  return props.color !== null && (0, _styledComponents.css)(_templateObject2, props.color);
});

var IconSizes = {
  doc: 16,
  utl: 16,
  nav: 22,
  vis: 22,
  com: 32,
  fea: 32,
  obj: 32
};

var getIconSetSize = function getIconSetSize() {
  var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var iconSet = name && name.replace(':', '-').split('-')[1];
  return IconSizes[iconSet];
};

var Icon = function (_React$Component) {
  _inherits(Icon, _React$Component);

  function Icon(props) {
    _classCallCheck(this, Icon);

    var _this = _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).call(this, props));

    _this.createMarkup = _this.createMarkup.bind(_this);
    return _this;
  }

  _createClass(Icon, [{
    key: 'createMarkup',
    value: function createMarkup(icon) {
      var name = icon && icon.replace(':', '-');
      var html = this.getIcon(name);
      return { __html: html };
    }
  }, {
    key: 'getIcon',
    value: function getIcon(name) {
      this.name = name;
      if (_2.default[name]) {
        return _2.default[name];
      }
      return name;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          icon = _props.icon,
          size = _props.size,
          style = _props.style,
          className = _props.className,
          viewBox = _props.viewBox,
          color = _props.color;


      var iconSetSize = getIconSetSize(icon);

      var styles = {
        width: size || iconSetSize,
        height: size || iconSetSize
      };

      var svgStyles = Object.assign({
        pointerEvents: 'none',
        display: 'block'
      }, styles);

      var _viewBox = viewBox || '0 0 ' + size + ' ' + size;
      return _react2.default.createElement(
        PxIcon,
        { className: (0, _classnames2.default)('px-icon', className, icon.replace(':', '-')), style: styles, color: color },
        _react2.default.createElement('svg', {
          viewBox: _viewBox,
          preserveAspectRatio: 'xMidYMid meet',
          dangerouslySetInnerHTML: this.createMarkup(icon) /* eslint-disable-line */,
          style: Object.assign({}, svgStyles, style)
        })
      );
    }
  }]);

  return Icon;
}(_react2.default.Component);

Icon.defaultProps = {
  size: null,
  icon: '',
  viewBox: null,
  color: null,
  className: null,
  style: null
};

Icon.propTypes = process.env.NODE_ENV !== "production" ? {
  size: _propTypes2.default.number,
  icon: _propTypes2.default.string,
  viewBox: _propTypes2.default.string,
  color: _propTypes2.default.string,
  className: _propTypes2.default.string,
  style: _propTypes2.default.func
} : {};

exports.default = Icon;