'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  font-size: .8rem;\n  line-height: 1.66667;\n  color: var(--px-headings-label-color,gray);\n'], ['\n  font-size: .8rem;\n  line-height: 1.66667;\n  color: var(--px-headings-label-color,gray);\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  color: var(--px-headings-value-color, black);\n  margin-top: -4px;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n'], ['\n  color: var(--px-headings-value-color, black);\n  margin-top: -4px;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n    margin-top: -10px;\n  '], ['\n    margin-top: -10px;\n  ']),
    _templateObject4 = _taggedTemplateLiteral(['\n    margin-top: -6px;\n  '], ['\n    margin-top: -6px;\n  ']),
    _templateObject5 = _taggedTemplateLiteral(['\n    margin-top:-12px;\n  '], ['\n    margin-top:-12px;\n  ']),
    _templateObject6 = _taggedTemplateLiteral(['\n    margin-top: -8px;\n  '], ['\n    margin-top: -8px;\n  ']),
    _templateObject7 = _taggedTemplateLiteral(['\n    margin-top: -2px;\n  '], ['\n    margin-top: -2px;\n  ']),
    _templateObject8 = _taggedTemplateLiteral(['\n  margin-left: 0px;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n'], ['\n  margin-left: 0px;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n']),
    _templateObject9 = _taggedTemplateLiteral(['\n    font-size: 1rem;\n  '], ['\n    font-size: 1rem;\n  ']),
    _templateObject10 = _taggedTemplateLiteral(['\n    margin-left: -12px;\n  '], ['\n    margin-left: -12px;\n  ']),
    _templateObject11 = _taggedTemplateLiteral(['\n    margin-left: -10px;\n  '], ['\n    margin-left: -10px;\n  ']),
    _templateObject12 = _taggedTemplateLiteral(['\n    margin-left: -8px;\n  '], ['\n    margin-left: -8px;\n  ']),
    _templateObject13 = _taggedTemplateLiteral(['\n    margin-left: -4px;\n  '], ['\n    margin-left: -4px;\n  ']),
    _templateObject14 = _taggedTemplateLiteral(['\n    margin-left: -2px;\n  '], ['\n    margin-left: -2px;\n  ']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var KvpLabel = _styledComponents2.default.div(_templateObject);
KvpLabel.displayName = 'KvpLabel';
KvpLabel.defaultProps = {
  className: 'kvp-label',
  size: null
};
KvpLabel.propTypes = {
  className: _propTypes2.default.string,
  size: _propTypes2.default.string
};

var KvpValue = _styledComponents2.default.span(_templateObject2, function (props) {
  return props.size === 'alpha' && (0, _styledComponents.css)(_templateObject3);
}, function (props) {
  return props.size === 'beta' && (0, _styledComponents.css)(_templateObject4);
}, function (props) {
  return props.size === 'gamma' && (0, _styledComponents.css)(_templateObject5);
}, function (props) {
  return props.size === 'delta' && (0, _styledComponents.css)(_templateObject6);
}, function (props) {
  return props.size === 'epsilon' && (0, _styledComponents.css)(_templateObject7);
});
KvpValue.displayName = 'KvpValue';
KvpValue.defaultProps = {
  className: 'kvp-value',
  size: null
};
KvpValue.propTypes = {
  className: _propTypes2.default.string,
  size: _propTypes2.default.string
};

var KvpUom = _styledComponents2.default.span(_templateObject8, function (props) {
  return props.size === 'value' && (0, _styledComponents.css)(_templateObject9);
}, function (props) {
  return props.size === 'alpha' && (0, _styledComponents.css)(_templateObject10);
}, function (props) {
  return props.size === 'beta' && (0, _styledComponents.css)(_templateObject11);
}, function (props) {
  return props.size === 'gamma' && (0, _styledComponents.css)(_templateObject12);
}, function (props) {
  return props.size === 'delta' && (0, _styledComponents.css)(_templateObject13);
}, function (props) {
  return props.size === 'epsilon' && (0, _styledComponents.css)(_templateObject14);
});
KvpUom.displayName = 'KvpUom';
KvpUom.defaultProps = {
  className: 'kvp-uom',
  size: null
};
KvpUom.propTypes = {
  className: _propTypes2.default.string,
  size: _propTypes2.default.string
};

/* eslint-disable */
var _getAdjustedSize = function _getAdjustedSize(s) {
  return s === 'alpha' ? 'delta' : s === 'beta' ? 'epsilon' : s === 'gamma' ? 'value' : s === 'delta' ? 'value' : 'zeta';
};
/* eslint-enable */

var Component = function Component(_ref) {
  var label = _ref.label,
      value = _ref.value,
      size = _ref.size,
      uom = _ref.uom,
      children = _ref.children;
  return _react2.default.createElement(
    'div',
    { className: 'px-key-value-pair' },
    _react2.default.createElement(
      KvpLabel,
      null,
      label
    ),
    _react2.default.createElement(
      KvpValue,
      { size: _getAdjustedSize(size), className: size },
      value,
      uom && _react2.default.createElement(
        KvpUom,
        { size: _getAdjustedSize(size), className: _getAdjustedSize(size) },
        uom
      )
    ),
    children
  );
};

Component.defaultProps = {
  label: null,
  value: null,
  size: null,
  uom: null,
  children: null
};

Component.propTypes = process.env.NODE_ENV !== "production" ? {
  label: _propTypes2.default.string,
  value: _propTypes2.default.string,
  size: _propTypes2.default.string,
  uom: _propTypes2.default.string,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
} : {};

exports.default = Component;