'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  color: var(--px-tabs-color, black);\n  border: 0;\n  padding: 0;\n  &:focus {\n    outline: var(--px-tab-outline-style, none);\n  }\n'], ['\n  color: var(--px-tabs-color, black);\n  border: 0;\n  padding: 0;\n  &:focus {\n    outline: var(--px-tab-outline-style, none);\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  font: inherit;\n  margin: 0;\n  border-bottom: 1px solid var(--px-tab-border-color, gray);\n  padding: 0 1rem 0;\n  display: flex;\n'], ['\n  font: inherit;\n  margin: 0;\n  border-bottom: 1px solid var(--px-tab-border-color, gray);\n  padding: 0 1rem 0;\n  display: flex;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  color: var(--px-tab-color, black);\n  cursor: pointer;\n  text-decoration: none;\n  user-select: none;\n\n  &:hover {\n    color: var(--px-tab-color--hover, black);\n  }\n\n  &:active {\n    color: var(--px-tab-color--active, black);\n  }\n'], ['\n  color: var(--px-tab-color, black);\n  cursor: pointer;\n  text-decoration: none;\n  user-select: none;\n\n  &:hover {\n    color: var(--px-tab-color--hover, black);\n  }\n\n  &:active {\n    color: var(--px-tab-color--active, black);\n  }\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  list-style-type: none;\n  line-height: 1.3;\n  font: inherit;\n  text-align: center;\n  vertical-align: middle;\n  padding-bottom: 10px;\n  margin: 1px 20px 0 0;\n  color: var(--px-tab-color, black);\n\n  ', '\n'], ['\n  list-style-type: none;\n  line-height: 1.3;\n  font: inherit;\n  text-align: center;\n  vertical-align: middle;\n  padding-bottom: 10px;\n  margin: 1px 20px 0 0;\n  color: var(--px-tab-color, black);\n\n  ', '\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n    color: var(--px-tab-color--selected, black);\n    border-bottom: 2px solid var(--px-tab-color--selected, black);\n    font-weight: bold;\n  '], ['\n    color: var(--px-tab-color--selected, black);\n    border-bottom: 2px solid var(--px-tab-color--selected, black);\n    font-weight: bold;\n  ']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// Container
var TabsContainer = _styledComponents2.default.div(_templateObject);
TabsContainer.displayName = 'TabsContainer';

// Nav
var TabsContainerNav = _styledComponents2.default.ul(_templateObject2);
TabsContainerNav.displayName = 'TabsContainerNav';

// Tab Title
var TabTitle = _styledComponents2.default.span(_templateObject3);

TabTitle.displayName = 'TabTitle';

var TabItem = _styledComponents2.default.li(_templateObject4, function (props) {
  return props.active && (0, _styledComponents.css)(_templateObject5);
});

/**
 * Tabs component
 */

var Tabs = function (_React$Component) {
  _inherits(Tabs, _React$Component);

  function Tabs(props) {
    _classCallCheck(this, Tabs);

    var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

    _this.state = {
      selected: props.selected || 0
    };

    _this._items = [];
    _this._keys = [];
    return _this;
  }

  _createClass(Tabs, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.selected !== undefined) {
        // const index = this._getIndexForValue(nextProps.selected);
        var selected = this._getIndexForValue(nextProps.selected);
        this.setState({
          selected: selected
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.selected !== this.props.selected || nextState.selected !== this.state.selected) {
        return true;
      }
      return false;
    }
  }, {
    key: '_getIndexForValue',
    value: function _getIndexForValue(val) {
      var index = this._keys.indexOf(val);
      return index;
    }
  }, {
    key: '_getValueForIndex',
    value: function _getValueForIndex(index) {
      var val = this._keys[index];
      return val;
    }
  }, {
    key: 'handleClick',
    value: function handleClick(i, event) {
      var index = this._getIndexForValue(i);
      // const val = this._getValueForIndex(i);
      this.setState({
        selected: index
      });
      if (this.props.onChange) {
        this.props.onChange(i, event);
      }
    }
  }, {
    key: '_renderTitles',
    value: function _renderTitles() {
      this._keys = [];

      function labels(child, index) {
        var propForSelect = index;
        this._items[index] = child;
        if (this.props.propForSelect) {
          propForSelect = child.props[this.props.propForSelect];
        }
        this._keys[index] = propForSelect;
        var selected = this.state.selected === (this.props.propForSelect ? this._getIndexForValue(propForSelect) : index);
        var baseClasses = (0, _classnames2.default)({ 'iron-selected': selected });
        return _react2.default.createElement(
          TabItem,
          {
            key: index,
            className: baseClasses,
            active: selected,
            'aria-controls': 'panel-' + index,
            role: 'tab'
          },
          _react2.default.createElement(
            TabTitle,
            _extends({}, child.props, {
              onClick: this.handleClick.bind(this, propForSelect) /* eslint-disable-line */
            }),
            child.props.label
          )
        );
      }

      var children = this.props.children;

      return _react2.default.Children.map(children, labels.bind(this));
    }
  }, {
    key: '_renderContent',
    value: function _renderContent() {
      return this.props.children && this.props.children[this.state.selected];
    }
  }, {
    key: 'render',
    value: function render() {
      var style = this.props.style;

      return _react2.default.createElement(
        TabsContainer,
        { style: style, className: 'px-tabs__container' },
        _react2.default.createElement(
          TabsContainerNav,
          { className: 'px-tabs__nav', role: 'tablist' },
          this._renderTitles()
        ),
        this._renderContent()
      );
    }
  }]);

  return Tabs;
}(_react2.default.Component);

Tabs.defaultProps = {
  selected: 0,
  onChange: null,
  style: null,
  children: null,
  propForSelect: null
};

Tabs.propTypes = process.env.NODE_ENV !== "production" ? {
  selected: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  style: _propTypes2.default.objectOf(_propTypes2.default.string),
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  propForSelect: _propTypes2.default.string
} : {};

Tabs.displayName = 'Tabs';

exports.default = Tabs;