'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  max-width: var(--px-tile-width, 20rem);\n  max-height: var(--px-tile-height, 20rem);\n'], ['\n  max-width: var(--px-tile-width, 20rem);\n  max-height: var(--px-tile-height, 20rem);\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  position: relative;\n  width: var(--px-tile-width, 20rem);\n  max-width: var(--px-tile-width, 20rem);\n  max-height: var(--px-tile-height, 20rem);\n  overflow: hidden;\n'], ['\n  position: relative;\n  width: var(--px-tile-width, 20rem);\n  max-width: var(--px-tile-width, 20rem);\n  max-height: var(--px-tile-height, 20rem);\n  overflow: hidden;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  max-width: var(--px-tile-width, 20rem);\n  max-height: var(--px-tile-height, 20rem);\n  position: absolute; \n  top: 0; \n  background-color: var(--px-tile-overlay-background-color, black); \n  color: var(--px-tile-overlay-text-color, white); \n  opacity: 0; \n  transition: opacity 0.4s cubic-bezier(0.78, 0.13, 0.16, 0.87); \n  display: flex; \n  flex-direction: column; \n  justify-content: space-between; \n'], ['\n  max-width: var(--px-tile-width, 20rem);\n  max-height: var(--px-tile-height, 20rem);\n  position: absolute; \n  top: 0; \n  background-color: var(--px-tile-overlay-background-color, black); \n  color: var(--px-tile-overlay-text-color, white); \n  opacity: 0; \n  transition: opacity 0.4s cubic-bezier(0.78, 0.13, 0.16, 0.87); \n  display: flex; \n  flex-direction: column; \n  justify-content: space-between; \n']),
    _templateObject4 = _taggedTemplateLiteral([''], ['']),
    _templateObject5 = _taggedTemplateLiteral(['\n  width: var(--px-tile-thumbnail-width, 100%);\n  height: var(--px-tile-thumbnail-height, 11.66667rem);\n  background-color: var(--px-tile-thumbnail-background-color, white);\n'], ['\n  width: var(--px-tile-thumbnail-width, 100%);\n  height: var(--px-tile-thumbnail-height, 11.66667rem);\n  background-color: var(--px-tile-thumbnail-background-color, white);\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Tile = _styledComponents2.default.div(_templateObject);

var TileContainer = _styledComponents2.default.div(_templateObject2);

var TileOverlay = _styledComponents2.default.div(_templateObject3);
var TileTitle = _styledComponents2.default.div(_templateObject4);
var TileSubTitle = _styledComponents2.default.div(_templateObject4);
var TileThumbnail = _styledComponents2.default.div(_templateObject5);

/**
 * Tile component
 */
var Component = function Component(_ref) {
  var title = _ref.title,
      subtitle = _ref.subtitle,
      description = _ref.description,
      overlayDescription = _ref.overlayDescription,
      image = _ref.image,
      className = _ref.className,
      actionButtons = _ref.actionButtons,
      children = _ref.children;
  return _react2.default.createElement(
    Tile,
    { className: className },
    _react2.default.createElement(
      TileContainer,
      { className: 'tile__container' },
      image && _react2.default.createElement(
        TileThumbnail,
        null,
        _react2.default.createElement('img', { src: image, alt: title })
      ),
      title && _react2.default.createElement(
        TileTitle,
        null,
        title
      ),
      subtitle && _react2.default.createElement(
        TileSubTitle,
        null,
        subtitle
      ),
      _react2.default.createElement(
        TileOverlay,
        { id: 'overlay', className: 'overlay' },
        _react2.default.createElement(
          'header',
          { className: 'title epsilon' },
          _react2.default.createElement(
            'span',
            { className: 'title-span truncate' },
            title
          )
        ),
        _react2.default.createElement(
          'section',
          { className: 'text' },
          overlayDescription && overlayDescription,
          description && description,
          children && children
        ),
        actionButtons && _react2.default.createElement(
          'footer',
          { className: 'footer' },
          actionButtons
        )
      )
    )
  );
};

Component.defaultProps = {
  title: null,
  subtitle: null,
  description: null,
  overlayDescription: null,
  image: null,
  className: null,
  actionButtons: null,
  children: null
};
Component.propTypes = process.env.NODE_ENV !== "production" ? {
  title: _propTypes2.default.string,
  subtitle: _propTypes2.default.string,
  description: _propTypes2.default.string,
  overlayDescription: _propTypes2.default.string,
  image: _propTypes2.default.string,
  className: _propTypes2.default.string,
  actionButtons: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
} : {};

exports.default = Component;