'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TreeNodeIcon = function TreeNodeIcon(_ref) {
  var open = _ref.open;
  return _react2.default.createElement(
    'svg',
    {
      viewBox: '0 0 16 16',
      preserveAspectRatio: 'xMidYMid meet',
      focusable: 'false',
      width: 16,
      height: 16
    },
    _react2.default.createElement(
      'defs',
      null,
      _react2.default.createElement(
        'g',
        { id: 'open' },
        _react2.default.createElement('path', { d: 'M2.4 6.2l5.5 5.5 5.5-5.5', fill: 'black' })
      ),
      _react2.default.createElement(
        'g',
        { id: 'closed' },
        _react2.default.createElement('path', { strokeLinejoin: 'round', d: 'M6.2 13.2l5.4-5.5-5.5-5.5', fill: 'black' })
      )
    ),
    open && _react2.default.createElement('use', { href: '#open' }),
    !open && _react2.default.createElement('use', { href: '#closed' })
  );
};

TreeNodeIcon.defaultProps = {
  open: false
};

TreeNodeIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  open: _propTypes2.default.bool
} : {};

exports.default = TreeNodeIcon;