'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TreeNode = require('./TreeNode');

var _TreeNode2 = _interopRequireDefault(_TreeNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tree = function (_React$Component) {
  _inherits(Tree, _React$Component);

  function Tree(props) {
    _classCallCheck(this, Tree);

    var _this = _possibleConstructorReturn(this, (Tree.__proto__ || Object.getPrototypeOf(Tree)).call(this, props, { displayName: 'Tree' }));

    _this.state = {
      selectedNode: props.selectedNode || null,
      selected: props.selected || null
    };
    _this.onSelect = _this.onSelect.bind(_this);
    return _this;
  }

  _createClass(Tree, [{
    key: 'onSelect',
    value: function onSelect(node) {
      var _this2 = this;

      if (this.state.selected) {
        this.state.selected.setState({ selected: false });
      }
      node.setState({ selected: !node.state.selected }, function () {
        _this2.setState({ selectedNode: node }, function () {
          if (_this2.props.onChange) {
            _this2.props.onChange(_this2.state);
          }
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var items = this.props.items;

      var treeStyle = {
        margin: 0,
        padding: 0
      };
      return _react2.default.createElement(
        'ul',
        { className: 'px-tree', style: treeStyle },
        items && items.map(function (item) {
          return _react2.default.createElement(_TreeNode2.default, _extends({
            key: item.id,
            data: item
          }, item, {
            onCategorySelect: _this3.onSelect
          }));
        })
      );
    }
  }]);

  return Tree;
}(_react2.default.Component);

Tree.defaultProps = {
  items: null,
  children: null,
  style: null,
  onChange: null,
  selectedNode: null,
  selected: null
};
var treeItem = _propTypes2.default.shape({
  id: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  label: _propTypes2.default.string,
  children: _propTypes2.default.arrayOf(treeItem)
});

Tree.propTypes = process.env.NODE_ENV !== "production" ? {
  items: _propTypes2.default.arrayOf(_propTypes2.default.objectOf(_propTypes2.default.string)),
  onChange: _propTypes2.default.func,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  style: _propTypes2.default.objectOf(_propTypes2.default.string),
  selectedNode: _propTypes2.default.objectOf(_propTypes2.default.string),
  selected: _propTypes2.default.number
} : {};

exports.default = Tree;