'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  height          : 4rem;\n  background-color: var(--px-view-header-background-color, whitesmoke);\n  padding-left    : 1rem;\n  padding-right   : 1rem;\n  display         : flex;\n  align-items     : center;\n  flex-direction  : row;\n  position: relative;\n  user-select:none;\n'], ['\n  height          : 4rem;\n  background-color: var(--px-view-header-background-color, whitesmoke);\n  padding-left    : 1rem;\n  padding-right   : 1rem;\n  display         : flex;\n  align-items     : center;\n  flex-direction  : row;\n  position: relative;\n  user-select:none;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  padding-left : 1rem;\n  padding-right: 1rem;\n  flex         : initial;\n  min-width    : 0;\n  margin-left  : auto;\n  margin-right : auto;\n  min-width: 1px;\n'], ['\n  padding-left : 1rem;\n  padding-right: 1rem;\n  flex         : initial;\n  min-width    : 0;\n  margin-left  : auto;\n  margin-right : auto;\n  min-width: 1px;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  text-align: center;\n  color     : var(--px-view-header-title-color, black);\n  overflow     : hidden;\n  text-overflow: ellipsis;\n  white-space  : nowrap;\n'], ['\n  text-align: center;\n  color     : var(--px-view-header-title-color, black);\n  overflow     : hidden;\n  text-overflow: ellipsis;\n  white-space  : nowrap;\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  text-align: center;\n  color     : var(--px-view-header-subtitle-color, gray);\n  font-size  : 0.8rem;\n  line-height: 1.66667;\n  font-weight: 400;\n  overflow     : hidden;\n  text-overflow: ellipsis;\n  white-space  : nowrap;\n'], ['\n  text-align: center;\n  color     : var(--px-view-header-subtitle-color, gray);\n  font-size  : 0.8rem;\n  line-height: 1.66667;\n  font-weight: 400;\n  overflow     : hidden;\n  text-overflow: ellipsis;\n  white-space  : nowrap;\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  position: absolute;\n  left: 1rem;\n'], ['\n  position: absolute;\n  left: 1rem;\n']),
    _templateObject6 = _taggedTemplateLiteral(['\n  position: absolute;\n  right: 1rem;\n'], ['\n  position: absolute;\n  right: 1rem;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var VHeader = _styledComponents2.default.div(_templateObject);
VHeader.displayName = 'ViewHeader';

var VHeaderText = _styledComponents2.default.div(_templateObject2);
VHeaderText.displayName = 'ViewHeaderText';

var VHeaderTitle = _styledComponents2.default.div(_templateObject3);
VHeaderTitle.displayName = 'ViewHeaderTitle';

var VHeaderSubTitle = _styledComponents2.default.div(_templateObject4);
VHeaderSubTitle.displayName = 'ViewHeaderSubTitle';

var VHeaderLeft = _styledComponents2.default.div(_templateObject5);
VHeaderLeft.displayName = 'ViewHeaderLeft';

var VHeaderRight = _styledComponents2.default.div(_templateObject6);
VHeaderRight.displayName = 'ViewHeaderRight';

var ViewHeader = function ViewHeader(_ref) {
  var title = _ref.title,
      subtitle = _ref.subtitle,
      leftContent = _ref.leftContent,
      rightContent = _ref.rightContent,
      children = _ref.children;
  return _react2.default.createElement(
    VHeader,
    null,
    _react2.default.createElement(
      VHeaderLeft,
      null,
      leftContent,
      children && _react2.default.Children.map(children[0], function (child) {
        return child;
      })
    ),
    _react2.default.createElement(
      VHeaderText,
      null,
      _react2.default.createElement(
        VHeaderTitle,
        null,
        title
      ),
      subtitle && _react2.default.createElement(
        VHeaderSubTitle,
        null,
        subtitle
      )
    ),
    _react2.default.createElement(
      VHeaderRight,
      null,
      rightContent,
      children && _react2.default.Children.map(children[1], function (child) {
        return child;
      })
    )
  );
};

ViewHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  title: _propTypes2.default.string,
  subtitle: _propTypes2.default.string,
  rightContent: _propTypes2.default.node,
  leftContent: _propTypes2.default.node,
  children: _propTypes2.default.node
} : {};

ViewHeader.defaultProps = {
  title: null,
  subtitle: null,
  rightContent: null,
  leftContent: null,
  children: null
};

exports.default = ViewHeader;