(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'classnames'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('classnames'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.classnames);
    global.IronPages = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _classnames) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var IronPages = function (_React$Component) {
    _inherits(IronPages, _React$Component);

    function IronPages() {
      _classCallCheck(this, IronPages);

      return _possibleConstructorReturn(this, (IronPages.__proto__ || Object.getPrototypeOf(IronPages)).apply(this, arguments));
    }

    _createClass(IronPages, [{
      key: '_renderChildren',
      value: function _renderChildren() {
        var _props = this.props,
            selected = _props.selected,
            selectedClassName = _props.selectedClassName;

        var len = _react2.default.Children.count(this.props.children);
        var child = null;
        if (selected > len - 1) {
          var _props$children = _slicedToArray(this.props.children, 1);

          child = _props$children[0];
        } else {
          child = this.props.children[selected];
        }
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(selectedClassName) },
          child
        );
      }
    }, {
      key: 'render',
      value: function render() {
        var className = this.props.className;


        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(className) },
          this._renderChildren()
        );
      }
    }]);

    return IronPages;
  }(_react2.default.Component);

  IronPages.defaultProps = {
    selected: 0,
    children: null,

    selectedClassName: 'iron-selected',
    className: 'iron-selector'
  };

  IronPages.propTypes = process.env.NODE_ENV !== "production" ? {
    children: _propTypes2.default.node,

    selected: _propTypes2.default.number,

    selectedClassName: _propTypes2.default.string,
    className: _propTypes2.default.string
  } : {};

  IronPages.displayName = 'IronPages';

  exports.default = IronPages;
});