(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', './IronCollapse', './IronPages', './IronMediaQuery', './IronSelection', './IronSelector', './IronMultiSelectable', './IronSelectable'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('./IronCollapse'), require('./IronPages'), require('./IronMediaQuery'), require('./IronSelection'), require('./IronSelector'), require('./IronMultiSelectable'), require('./IronSelectable'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.IronCollapse, global.IronPages, global.IronMediaQuery, global.IronSelection, global.IronSelector, global.IronMultiSelectable, global.IronSelectable);
    global.index = mod.exports;
  }
})(this, function (exports, _IronCollapse, _IronPages, _IronMediaQuery, _IronSelection, _IronSelector, _IronMultiSelectable, _IronSelectable) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _IronCollapse2 = _interopRequireDefault(_IronCollapse);

  var _IronPages2 = _interopRequireDefault(_IronPages);

  var _IronMediaQuery2 = _interopRequireDefault(_IronMediaQuery);

  var _IronSelection2 = _interopRequireDefault(_IronSelection);

  var _IronSelector2 = _interopRequireDefault(_IronSelector);

  var _IronMultiSelectable2 = _interopRequireDefault(_IronMultiSelectable);

  var _IronSelectable2 = _interopRequireDefault(_IronSelectable);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var IronComponents = {
    IronCollapse: _IronCollapse2.default,
    IronPages: _IronPages2.default,
    IronMediaQuery: _IronMediaQuery2.default,
    IronSelection: _IronSelection2.default,
    IronSelector: _IronSelector2.default,
    IronSelectable: _IronSelectable2.default,
    IronMultiSelectable: _IronMultiSelectable2.default
  };

  exports.default = IronComponents;
});