(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'classnames', 'styled-components', '../../iron/IronCollapse', '../../../styles/flex', '../IconSet/Icon'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('classnames'), require('styled-components'), require('../../iron/IronCollapse'), require('../../../styles/flex'), require('../IconSet/Icon'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.classnames, global.styledComponents, global.IronCollapse, global.flex, global.Icon);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _classnames, _styledComponents, _IronCollapse, _flex, _Icon) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _IronCollapse2 = _interopRequireDefault(_IronCollapse);

  var _flex2 = _interopRequireDefault(_flex);

  var _Icon2 = _interopRequireDefault(_Icon);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var styles = {
    width: '16px',
    height: '16px'
  };
  var svgStyles = {
    pointerEvents: 'none',
    display: 'block',
    height: '16px',
    width: '16px',
    fill: 'none',
    stroke: 'currentColor'
  };
  var CloseIcon = function CloseIcon() {
    return _react2.default.createElement(
      'i',
      { className: 'px-icon px-icon-utl px-utl-chevron', style: styles },
      _react2.default.createElement(
        'svg',
        { viewBox: '0 0 16 16', preserveAspectRatio: 'xMidYMid meet', style: svgStyles },
        _react2.default.createElement(
          'g',
          { id: 'px-utl-chevron-right' },
          _react2.default.createElement('path', { strokeLinejoin: 'round', d: 'M6.2 13.2l5.4-5.5-5.5-5.5' })
        )
      )
    );
  };
  var OpenIcon = function OpenIcon() {
    return _react2.default.createElement(
      'i',
      { className: 'px-icon px-icon-utl px-utl-chevron-down', style: styles },
      _react2.default.createElement(
        'svg',
        { viewBox: '0 0 16 16', preserveAspectRatio: 'xMidYMid meet', style: svgStyles },
        _react2.default.createElement(
          'g',
          { id: 'px-utl-chevron' },
          _react2.default.createElement('path', { d: 'M2.4 6.2l5.5 5.5 5.5-5.5' })
        )
      )
    );
  };

  var AccordionHeader = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionHeader'
  })(['font-family:"GE Inspira Sans";padding:.5rem;margin-bottom:0.3333rem;cursor:pointer;user-select:none;background-color:var(--px-accordion-header-background-color,whitesmoke);color:var(--px-accordion-header-color,black);color:var(--px-headings-heading-subsection-color);background-color:var(--px-headings-heading-subsection-background);display:flex;justify-content:space-between;> *{user-select:none;}', ''], function (props) {
    return props.disabled && (0, _styledComponents.css)(['cursor:not-allowed;pointerEvents:none;']);
  });
  AccordionHeader.displayName = 'AccordionHeader';
  AccordionHeader.defaultProps = {
    className: 'px-accordion__header'
  };

  var AccordionHeaderText = _styledComponents2.default.span.withConfig({
    displayName: 'Accordion__AccordionHeaderText'
  })(['text-transform:uppercase;margin-left:.2rem;']);
  AccordionHeaderText.displayName = 'AccordionHeaderText';

  var AccordionContainer = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionContainer'
  })(['display:flex;flex-direction:column;']);
  AccordionContainer.displayName = 'AccordionContainer';
  AccordionContainer.defaultProps = {
    className: 'px-accordion__container'
  };

  var AccordionSection = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionSection'
  })(['display:flex;flex-direction:column;']);
  AccordionSection.displayName = 'AccordionSection';
  AccordionSection.defaultProps = {
    className: 'px-accordion__section'
  };

  var AccordionBody = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionBody'
  })(['margin:0;overflow:auto;padding:.5rem;']);
  AccordionBody.displayName = 'AccordionBody';
  AccordionBody.defaultProps = {
    className: 'px-accordion__body'
  };

  var AccordionIcon = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionIcon'
  })(['display:flex;justify-content:center;align-items:center;width:1rem;height:1rem;']);
  AccordionIcon.displayName = 'AccordionIcon';

  var AccordionStatus = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionStatus'
  })(['margin-right:1rem;text-transform:none;']);
  AccordionStatus.displayName = 'AccordionStatus';

  var AccordionAction = _styledComponents2.default.div.withConfig({
    displayName: 'Accordion__AccordionAction'
  })(['cursor:pointer;color:var(--px-actionable-alt-text-color,blue);background:transparent;border:transparent;outline:none;--iron-icon-width:1rem;--iron-icon-height:1rem;']);
  AccordionAction.displayName = 'AccordionAction';

  var Accordion = function (_React$Component) {
    _inherits(Accordion, _React$Component);

    function Accordion(props) {
      _classCallCheck(this, Accordion);

      var _this = _possibleConstructorReturn(this, (Accordion.__proto__ || Object.getPrototypeOf(Accordion)).call(this, props));

      _this.state = {
        open: props.opened
      };
      _this.onClick = _this.onClick.bind(_this);
      return _this;
    }

    _createClass(Accordion, [{
      key: 'onClick',
      value: function onClick() {
        if (!this.props.disabled) {
          this.setState(function (prevState) {
            return {
              open: !prevState.open
            };
          });
        }
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        var _props = this.props,
            onCollapsed = _props.onCollapsed,
            onExpanded = _props.onExpanded;

        if (this.state.open) {
          onExpanded ? onExpanded(this.state) : null;
        } else {
          onCollapsed ? onCollapsed(this.state) : null;
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.setState({ open: nextProps.opened });
      }
    }, {
      key: 'render',
      value: function render() {
        var open = this.state.open;
        var _props2 = this.props,
            headerText = _props2.headerText,
            headerValue = _props2.headerValue,
            status = _props2.status,
            disabled = _props2.disabled,
            actions = _props2.actions,
            showAction = _props2.showAction,
            onActionClick = _props2.onActionClick,
            icons = _props2.icons,
            children = _props2.children;
        var action = icons.action;


        var baseClasses = (0, _classnames2.default)('px-accordion', { 'px-accordion--disabled': disabled }, { 'px-accordion--open': open });
        var headerClasses = (0, _classnames2.default)('px-accordion__header');

        return _react2.default.createElement(
          AccordionContainer,
          { className: baseClasses },
          _react2.default.createElement(
            AccordionHeader,
            { disabled: disabled, className: headerClasses },
            _react2.default.createElement(
              _flex2.default,
              { item: true, onClick: this.onClick },
              _react2.default.createElement(
                'span',
                null,
                open && _react2.default.createElement(OpenIcon, null),
                !open && _react2.default.createElement(CloseIcon, null)
              ),
              _react2.default.createElement(
                AccordionHeaderText,
                null,
                headerText || headerValue
              )
            ),
            _react2.default.createElement(
              _flex2.default,
              { middle: true },
              status && _react2.default.createElement(
                AccordionStatus,
                null,
                status
              ),
              showAction && _react2.default.createElement(
                AccordionAction,
                { onClick: onActionClick },
                _react2.default.createElement(_Icon2.default, { icon: action, size: 16 })
              ),
              actions && _react2.default.createElement(
                AccordionAction,
                null,
                actions()
              )
            )
          ),
          _react2.default.createElement(
            _IronCollapse2.default,
            { opened: open },
            _react2.default.createElement(
              AccordionBody,
              null,
              children
            )
          )
        );
      }
    }]);

    return Accordion;
  }(_react2.default.Component);

  Accordion.displayName = 'Accordion';

  Accordion.propTypes = process.env.NODE_ENV !== "production" ? {
    headerText: _propTypes2.default.string,
    headerValue: _propTypes2.default.string,
    status: _propTypes2.default.string,
    opened: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    actions: _propTypes2.default.node,
    showAction: _propTypes2.default.bool,
    onExpanded: _propTypes2.default.func,
    onCollapsed: _propTypes2.default.func,
    onActionClick: _propTypes2.default.func,
    icons: _propTypes2.default.shape({
      more: _propTypes2.default.string,
      left: _propTypes2.default.string,
      action: _propTypes2.default.string
    }),
    children: _propTypes2.default.node
  } : {};

  Accordion.defaultProps = {
    headerText: null,
    headerValue: null,
    status: null,
    opened: true,
    disabled: null,
    actions: null,
    showAction: null,
    onCollapsed: null,
    onExpanded: null,
    onActionClick: null,
    icons: {
      more: 'px-utl:chevron-right',
      left: 'px-utl:chevron',
      action: 'px-utl:edit'
    },
    children: null
  };

  exports.default = Accordion;
});