(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var AlertLabel = _styledComponents2.default.div.withConfig({
    displayName: 'AlertLabel'
  })(['display:inline-block;position:relative;padding:5px;text-transform:uppercase;text-align:center;font-size:0.8rem;line-height:0.8rem;background-color:var(--px-alert-label-background-color--unknown,gray);color:var(--px-alert-label-text-color--unknown,white);border:1px solid var(--px-alert-label-border-color,transparent);', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.type === 'info' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--information,blue);color:var(--px-alert-label-text-color--information,white);']);
  }, function (props) {
    return props.type === 'error' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--error,yellow);color:var(--px-alert-label-text-color--error,black);']);
  }, function (props) {
    return props.type === 'unknown' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--unknown,gray);color:var(--px-alert-label-text-color--unknown,white);']);
  }, function (props) {
    return props.type === 'important' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--important,red);color:var(--px-alert-label-text-color--important,white);']);
  }, function (props) {
    return props.type === 'warning' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--warning,orange);color:var(--px-alert-label-text-color--warning,white);']);
  }, function (props) {
    return props.type === 'healthy' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--healthy,green);color:var(--px-alert-label-text-color--healthy,white);']);
  }, function (props) {
    return props.type === 'success' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--healthy,green);color:var(--px-alert-label-text-color--healthy,white);']);
  });

  var Component = function Component(_ref) {
    var label = _ref.label,
        type = _ref.type;
    return _react2.default.createElement(
      AlertLabel,
      { type: type },
      _react2.default.createElement(
        'span',
        { className: 'label__text' },
        label
      )
    );
  };

  Component.defaultProps = {
    label: null,
    type: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    label: _propTypes2.default.string,
    type: _propTypes2.default.string
  } : {};

  Component.displayName = 'AlertLabel';

  exports.default = Component;
});