(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'styled-components', 'prop-types', '../Button'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('styled-components'), require('prop-types'), require('../Button'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.styledComponents, global.propTypes, global.Button);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _styledComponents, _propTypes, _Button) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _Button2 = _interopRequireDefault(_Button);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var fadeIn = (0, _styledComponents.keyframes)(['from{opacity:0;left:4rem;}to{opacity:1;left:0;}']);
  var fadeOut = (0, _styledComponents.keyframes)(['from{opacity:1;max-height:6.66667rem;min-height:0px;}to{opacity:0;max-height:0px;min-height:0px;padding-top:0px;padding-bottom:0px;}']);

  var AlertMessage = _styledComponents2.default.div.withConfig({
    displayName: 'AlertMessage'
  })(['visibility:hidden;display:none;width:var(--px-alert-message-width,auto);margin:0.33333rem;padding:0.66667rem;min-height:4rem;word-wrap:break-word;word-break:break-word;background-color:var(--px-alert-message-background-color,white);position:relative;min-height:0px;opacity:0;max-height:0px;padding-top:0px;padding-bottom:0px;box-shadow:0px 4px 8px var(--px-shadow-notification,rgba(0,0,0,0.2));animation:', ' 0.4s cubic-bezier(0.78,0.13,0.16,0.87);align-items:center;', ' button{color:var(--px-alert-message-dismiss-icon-color,gray);outline:none;max-width:50px;svg{height:1.33333rem;width:1.33333rem;fill:var(--px-alert-message-dismiss-icon-color,gray);stroke:var(--px-alert-message-dismiss-icon-color,gray);}}'], fadeOut, function (props) {
    return props.visible && (0, _styledComponents.css)(['overflow:hidden;height:4rem;visibility:visible;display:flex;opacity:1;max-height:none;padding-top:0.66667rem;padding-bottom:0.66667rem;animation:', ' 0.4s cubic-bezier(0.78,0.13,0.16,0.87);'], fadeIn);
  });

  var AlertMessageContainer = _styledComponents2.default.div.withConfig({
    displayName: 'AlertMessage__AlertMessageContainer'
  })(['display:flex;align-items:center;flex:2;margin-left:0.66667rem;margin-right:0.66667rem;']);

  var AlertMessageActions = _styledComponents2.default.div.withConfig({
    displayName: 'AlertMessage__AlertMessageActions'
  })(['display:flex;align-items:center;position:relative;.dismiss{width:44px;height:44px;min-width:auto;}']);

  var AlertMessageSeverity = _styledComponents2.default.div.withConfig({
    displayName: 'AlertMessage__AlertMessageSeverity'
  })(['min-height:4rem;width:4rem;margin-left:-0.6666rem;margin-top:-0.6666rem;margin-bottom:-0.6666rem;padding-top:1rem;', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.type === 'important' && (0, _styledComponents.css)(['background-color:var(--px-alert-message-color--important,red);']);
  }, function (props) {
    return (props.type === 'information' || props.type === 'info') && (0, _styledComponents.css)(['background-color:var(--px-alert-message-color--information,blue);']);
  }, function (props) {
    return props.type === 'warning' && (0, _styledComponents.css)(['background-color:var(--px-alert-message-color--warning,orange);']);
  }, function (props) {
    return props.type === 'error' && (0, _styledComponents.css)(['background-color:var(--px-alert-message-color--error,yellow);']);
  }, function (props) {
    return props.type === 'unknown' && (0, _styledComponents.css)(['background-color:var(--px-alert-message-color--unknown,gray);']);
  }, function (props) {
    return props.type === 'healthy' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--healthy,green);']);
  }, function (props) {
    return props.type === 'success' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--healthy,green);']);
  });

  var Message = _styledComponents2.default.div.withConfig({
    displayName: 'AlertMessage__Message'
  })(['color:var(--px-alert-message-text-color,black);line-height:1.06667rem;font-size:0.8rem;padding:0;margin:0;']);

  var Component = function Component(_ref) {
    var messageTitle = _ref.messageTitle,
        message = _ref.message,
        action = _ref.action,
        visible = _ref.visible,
        actions = _ref.actions,
        onActionClick = _ref.onActionClick,
        onDismiss = _ref.onDismiss,
        type = _ref.type,
        children = _ref.children;
    return _react2.default.createElement(
      AlertMessage,
      { visible: visible },
      _react2.default.createElement(AlertMessageSeverity, { type: type }),
      _react2.default.createElement(
        AlertMessageContainer,
        null,
        _react2.default.createElement(
          Message,
          null,
          _react2.default.createElement(
            'strong',
            null,
            messageTitle,
            ' '
          ),
          _react2.default.createElement(
            'span',
            null,
            message
          ),
          _react2.default.createElement(
            'div',
            null,
            children
          )
        )
      ),
      _react2.default.createElement(
        AlertMessageActions,
        null,
        !actions && action === 'dismiss' && _react2.default.createElement(
          _Button2.default,
          { onClick: onDismiss, theme: 'bare', className: 'dismiss' },
          _react2.default.createElement(
            'svg',
            { viewBox: '0 0 22 22', preserveAspectRatio: 'xMidYMid meet', focusable: 'false' },
            _react2.default.createElement(
              'g',
              null,
              _react2.default.createElement('path', { strokeMiterlimit: '10', d: 'M3 19L19 3M3 3l16 16' })
            )
          )
        ),
        actions && actions(),
        !actions && action === 'acknowledge' && _react2.default.createElement(
          _Button2.default,
          {
            id: 'actionButton',
            onClick: onActionClick,
            theme: 'tertiary'
          },
          'OK'
        )
      )
    );
  };

  Component.defaultProps = {
    action: null,
    type: 'information',
    message: null,
    messageTitle: null,
    visible: false,
    actions: null,
    children: null,
    onActionClick: null,
    onDismiss: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    action: _propTypes2.default.string,
    type: _propTypes2.default.string,
    message: _propTypes2.default.string,
    messageTitle: _propTypes2.default.string,
    visible: _propTypes2.default.bool,
    actions: _propTypes2.default.func,
    onActionClick: _propTypes2.default.func,
    onDismiss: _propTypes2.default.func,
    children: _propTypes2.default.node
  } : {};

  Component.displayName = 'AlertMessage';

  exports.default = Component;
});