(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', '../AppNav', '../BrandingBar'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('../AppNav'), require('../BrandingBar'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.AppNav, global.BrandingBar);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _AppNav, _BrandingBar) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _AppNav2 = _interopRequireDefault(_AppNav);

  var _BrandingBar2 = _interopRequireDefault(_BrandingBar);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var AppHeader = function AppHeader(_ref) {
    var title = _ref.title,
        selected = _ref.selected,
        onChange = _ref.onChange,
        items = _ref.items,
        children = _ref.children;
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(_BrandingBar2.default, { title: title }),
      items && _react2.default.createElement(_AppNav2.default, { items: items, selected: selected, onChange: onChange }),
      children && _react2.default.createElement(
        'div',
        null,
        children
      )
    );
  };

  AppHeader.defaultProps = {
    title: null,
    selected: null,
    onChange: null,
    items: null,
    children: null
  };

  AppHeader.propTypes = process.env.NODE_ENV !== "production" ? {
    title: _propTypes2.default.string,
    selected: _propTypes2.default.number,
    onChange: _propTypes2.default.func,
    items: _propTypes2.default.arrayOf([_propTypes2.default.shape({
      id: _propTypes2.default.string,
      label: _propTypes2.default.string,
      icon: _propTypes2.default.string
    })]),
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
  } : {};

  AppHeader.displayName = 'AppHeader';

  exports.default = AppHeader;
});