(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'classnames', 'styled-components', './px-app-nav-item', './px-app-nav-sub-group'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('classnames'), require('styled-components'), require('./px-app-nav-item'), require('./px-app-nav-sub-group'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.classnames, global.styledComponents, global.pxAppNavItem, global.pxAppNavSubGroup);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _classnames, _styledComponents, _pxAppNavItem, _pxAppNavSubGroup) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _pxAppNavItem2 = _interopRequireDefault(_pxAppNavItem);

  var _pxAppNavSubGroup2 = _interopRequireDefault(_pxAppNavSubGroup);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var AppNav = _styledComponents2.default.div.withConfig({
    displayName: 'AppNav'
  })(['height:var(--px-app-nav-height,4rem);background-color:var(--px-app-nav-background-color,whitesmoke);box-shadow:var(--px-app-nav-box-shadow,0px 2px 4px var(--px-shadow-navigation,rgba(0,0,0,0.2)));display:block;width:100%;text-size-adjust:100%;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;', ''], function (props) {
    return props.vertical && (0, _styledComponents.css)(['overflow-x:hidden;overflow-y:hidden;position:var(--px-app-nav-vertical-position,absolute);height:var(--px-app-nav-vertical-height,100%);left:0;top:0;min-width:var(--px-app-nav-vertical-width,4rem);max-width:var(--px-app-nav-vertical-width,4rem);transition:var(--px-app-nav-vertical-transition,max-width 250ms ease);', ''], props.verticalOpened && (0, _styledComponents.css)(['overflow-y:auto;max-width:var(--px-app-nav-vertical-width--opened,21.33333rem);']));
  });

  var AppNavItems = _styledComponents2.default.div.withConfig({
    displayName: 'AppNav__AppNavItems'
  })(['flex:1 1 auto;display:flex;max-width:100%;', ''], function (props) {
    return props.vertical && (0, _styledComponents.css)(['flex-direction:column;height:100%;']);
  });

  var AppNavComponent = function (_React$Component) {
    _inherits(AppNavComponent, _React$Component);

    function AppNavComponent(props) {
      _classCallCheck(this, AppNavComponent);

      var _this = _possibleConstructorReturn(this, (AppNavComponent.__proto__ || Object.getPrototypeOf(AppNavComponent)).call(this, props, { displayName: 'AppNav' }));

      _this.state = {
        selected: props.selected || 0,
        onlyShowIcon: props.onlyShowIcon || props.vertical,

        vertical: props.vertical || false,
        verticalOpened: props.verticalOpened || !props.vertical

      };
      _this._items = [];
      _this._keys = [];

      _this._handleRef = _this._handleRef.bind(_this);
      _this._handleMouseEnter = _this._handleMouseEnter.bind(_this);
      _this._handleMouseExit = _this._handleMouseExit.bind(_this);
      return _this;
    }

    _createClass(AppNavComponent, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.base && this.vertical) {
          this.base.addEventListener('mouseleave', this._handleMouseExit);
          this.base.addEventListener('mouseenter', this._handleMouseEnter);
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (this.state.selected !== nextProps.selected) {
          this.setState(nextProps);
        }
        this.setState(nextProps);
      }
    }, {
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _this2 = this;

        if (this.props.items) {
          this.props.items.map(function (item, index) {
            _this2._keys.push(_this2.props.propForSelect ? item[_this2.props.propForSelect] : index);
            _this2._items.push(item);
            return item;
          });
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (this.base && this.vertical) {
          this.base.removeEventListener('mouseleave', this._handleMouseExit);
          this.base.removeEventListener('mouseenter', this._handleMouseEnter);
        }
      }
    }, {
      key: '_handleRef',
      value: function _handleRef(el) {
        this.base = el;
      }
    }, {
      key: '_handleMouseEnter',
      value: function _handleMouseEnter() {
        if (!this.state.vertical) {
          return;
        }
        this._mouseIsOverNav = true;
        if (this._mouseIsOverNav && !this.state.verticalOpened) {
          this._setVerticalOpened(true);
        }
      }
    }, {
      key: '_handleMouseExit',
      value: function _handleMouseExit() {
        if (!this.state.vertical) {
          return;
        }
        this._mouseIsOverNav = false;
        if (!this._mouseIsOverNav && this.state.verticalOpened) {
          this._setVerticalOpened(false);
        }
      }
    }, {
      key: '_setVerticalOpened',
      value: function _setVerticalOpened(bool) {
        this.setState({
          verticalOpened: bool,
          onlyShowIcon: !bool
        });
      }
    }, {
      key: '_getIndexForValue',
      value: function _getIndexForValue(val) {
        return this._keys.indexOf(val);
      }
    }, {
      key: '_getValueForIndex',
      value: function _getValueForIndex(index) {
        return this._items[index];
      }
    }, {
      key: '_getItemFromValue',
      value: function _getItemFromValue(index) {
        return this._getValueForIndex(this._getIndexForValue(index));
      }
    }, {
      key: 'handleClick',
      value: function handleClick(val, child, isSubItem) {
        var c = child;
        var propForSelect = this.props.propForSelect ? child[this.props.propForSelect] : val;
        var index = this.props.propForSelect ? child[this.props.propForSelect] : this._getIndexForValue(propForSelect);
        var item = this._getValueForIndex(index);

        if (c && c.children && !isSubItem) {
          c.selected = true;

          return;
        }
        if (isSubItem) {
          item = val;
        }

        var state = {
          selected: propForSelect,
          selectedIndex: this._getIndexForValue(propForSelect),
          selectedItem: child
        };

        this.setState(state);
        if (this.props.onChange) {
          this.props.onChange(state);
        }
      }
    }, {
      key: '_reset',
      value: function _reset() {
        this._items = [];
        this._keys = [];
      }
    }, {
      key: '_getItemFromPropForSelect',
      value: function _getItemFromPropForSelect(value) {
        var _this3 = this;

        var item = this.props.items.filter(function (val) {
          return val[_this3.props.propForSelect] === value;
        });
        return item ? item[0] : null;
      }
    }, {
      key: '_renderItem',
      value: function _renderItem(child, index) {
        var propForSelect = this.props.propForSelect ? child[this.props.propForSelect] : index;
        this._keys.push(propForSelect);
        this._items.push(child);
        var selected = this.state.selected === this._getIndexForValue(propForSelect);
        if (!child.children) {
          return _react2.default.createElement(_pxAppNavItem2.default, {
            key: index,
            item: child,
            id: child.id,
            icon: child.icon,
            label: child.label,
            selected: selected,
            onlyShowIcon: this.state.onlyShowIcon,
            onClick: this.handleClick.bind(this, propForSelect, child) });
        }
        return _react2.default.createElement(_pxAppNavSubGroup2.default, {
          key: index,
          id: child.id,
          item: child,
          icon: child.icon,
          label: child.label,
          onlyShowIcon: this.state.onlyShowIcon,
          selected: selected,
          onClick: this.handleClick.bind(this, propForSelect, child) });
      }
    }, {
      key: '_renderItems',
      value: function _renderItems(items) {
        this._reset();
        return items.map(this._renderItem.bind(this));
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            items = _props.items,
            children = _props.children,
            collapseAll = _props.collapseAll,
            collapseAt = _props.collapseAt,
            opened = _props.opened,
            selectedIndex = _props.selectedIndex,
            collapseWithIcon = _props.collapseWithIcon,
            collapseOpened = _props.collapseOpened;
        var _state = this.state,
            vertical = _state.vertical,
            verticalOpened = _state.verticalOpened;


        var baseClasses = (0, _classnames2.default)('px-app-nav', { vertical: vertical }, { 'vertical-opened': vertical && verticalOpened });

        return _react2.default.createElement(
          AppNav,
          {
            className: baseClasses,
            ref: this._handleRef,
            vertical: vertical,
            collapseAll: collapseAll,
            collapseWithIcon: collapseWithIcon,
            selectedIndex: selectedIndex,
            collapseAt: collapseAt,
            collapseOpened: collapseOpened,
            verticalOpened: verticalOpened
          },
          _react2.default.createElement(
            AppNavItems,
            { vertical: vertical, opened: opened },
            this._renderItems(items, selectedIndex)
          ),
          children
        );
      }
    }]);

    return AppNavComponent;
  }(_react2.default.Component);

  AppNavComponent.defaultProps = {
    vertical: false,
    collapseAll: false,
    collapseAt: null,
    collapseWithIcon: false,
    onlyShowIcon: false,
    collapseOpened: false,
    verticalOpened: false,
    selected: 0,
    selectedItem: null,
    selectedIndex: null,
    visibleItems: null,
    items: null,
    propForSelect: null,
    children: null,
    onChange: null,
    opened: null
  };
  AppNavComponent.propTypes = process.env.NODE_ENV !== "production" ? {
    onChange: _propTypes2.default.func,
    vertical: _propTypes2.default.bool,
    collapseAll: _propTypes2.default.bool,
    collapseAt: _propTypes2.default.number,
    collapseWithIcon: _propTypes2.default.bool,
    onlyShowIcon: _propTypes2.default.bool,
    collapseOpened: _propTypes2.default.bool,
    verticalOpened: _propTypes2.default.bool,
    selected: _propTypes2.default.number,
    selectedIndex: _propTypes2.default.number,
    selectedItem: _propTypes2.default.object,
    visibleItems: _propTypes2.default.any,
    items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      id: _propTypes2.default.string,
      label: _propTypes2.default.string,
      icon: _propTypes2.default.string
    })),
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func, _propTypes2.default.element]),
    propForSelect: _propTypes2.default.string,
    opened: _propTypes2.default.bool
  } : {};

  exports.default = AppNavComponent;
});