(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'classnames', 'styled-components', './px-app-nav-item', './px-app-nav-sub-item'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('classnames'), require('styled-components'), require('./px-app-nav-item'), require('./px-app-nav-sub-item'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.classnames, global.styledComponents, global.pxAppNavItem, global.pxAppNavSubItem);
    global.pxAppNavGroup = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _classnames, _styledComponents, _pxAppNavItem, _pxAppNavSubItem) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _pxAppNavItem2 = _interopRequireDefault(_pxAppNavItem);

  var _pxAppNavSubItem2 = _interopRequireDefault(_pxAppNavSubItem);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var AppNavGroup = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-group__AppNavGroup'
  })(['color:var(--px-base-text-color,#2c404c);line-height:1.33333;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;position:relative;display:flex;height:auto;overflow:hidden;.px-app-nav-item{flex:1 1 auto;}']);
  AppNavGroup.displayName = 'AppNavGroup';

  var AppNavSubGroup = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-group__AppNavSubGroup'
  })(['line-height:1.33333;text-size-adjust:100%;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;display:block;height:auto;.px-app-nav-item{flex:1 1 auto;}']);
  AppNavSubGroup.displayName = 'AppNavSubGroup';

  var AppNavGroupDropdown = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-group__AppNavGroupDropdown'
  })(['display:block;height:calc(100vh - var(--px-app-nav-height,4rem));z-index:399;box-shadow:0 1px 3px 0 rgba(0,0,0,0.3);', ''], function (props) {
    return props.opened && (0, _styledComponents.css)(['height:auto;overflow:auto;']);
  });
  AppNavGroupDropdown.displayName = 'AppNavGroupDropdown';

  var AppNavGroupDropdownContent = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-group__AppNavGroupDropdownContent'
  })(['background-color:var(--px-app-nav-subitem-background-color,white);max-width:inherit;margin:1px;position:relative;top:-1px;']);
  AppNavGroupDropdownContent.displayName = 'AppNavGroupDropdownContent';

  var AppNavSubGroupDropdown = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-group__AppNavSubGroupDropdown'
  })(['height:0px;overflow:hidden;', ''], function (props) {
    return props.opened && (0, _styledComponents.css)(['height:auto;overflow:auto;']);
  });
  AppNavSubGroupDropdown.displayName = 'AppNavSubGroupDropdown';

  var AppNavSubGroupComponent = function (_React$Component) {
    _inherits(AppNavSubGroupComponent, _React$Component);

    function AppNavSubGroupComponent(props) {
      _classCallCheck(this, AppNavSubGroupComponent);

      var _this = _possibleConstructorReturn(this, (AppNavSubGroupComponent.__proto__ || Object.getPrototypeOf(AppNavSubGroupComponent)).call(this, props));

      _this.state = {
        opened: props.opened || false
      };
      return _this;
    }

    _createClass(AppNavSubGroupComponent, [{
      key: '_handleClick',
      value: function _handleClick(e, item, isChild) {
        this.setState({ opened: !this.state.opened });
        if (this.props.onClick) {
          this.props.onClick(item, isChild);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var opened = this.props.opened;

        var subgroupClasses = (0, _classnames2.default)('px-app-nav-sub-group', { 'px-app-nav-sub-group--opened': opened });

        var _props = this.props,
            item = _props.item,
            selected = _props.selected,
            overflowed = _props.overflowed,
            collapsed = _props.collapsed,
            onlyShowIcon = _props.onlyShowIcon,
            emptyIcon = _props.emptyIcon;


        return _react2.default.createElement(
          AppNavSubGroup,
          { className: subgroupClasses },
          _react2.default.createElement(_pxAppNavItem2.default, _extends({
            dropdown: true,
            onClick: this._handleClick.bind(this, item) }, item, {
            item: item,
            selected: selected,
            overflowed: overflowed,
            collapsed: collapsed,
            onlyShowIcon: onlyShowIcon,
            emptyIcon: emptyIcon
          })),
          _react2.default.createElement(
            AppNavSubGroupDropdown,
            { opened: opened },
            _react2.default.createElement(
              AppNavGroupDropdownContent,
              null,
              item.children && item.children.map(function (child) {
                return _react2.default.createElement(_pxAppNavSubItem2.default, _extends({
                  selected: item.selected,
                  onClick: _this2._handleClick.bind(_this2, child, true),
                  key: child.label,
                  item: child
                }, child));
              })
            )
          )
        );
      }
    }]);

    return AppNavSubGroupComponent;
  }(_react2.default.Component);

  AppNavSubGroupComponent.displayName = 'AppNavGroup';
  AppNavSubGroupComponent.defaultProps = {
    selected: false,
    collapsed: false,
    overflowed: false,
    onClick: null,
    item: null,
    emptyIcon: false,
    opened: false,
    onlyShowIcon: false
  };

  AppNavSubGroupComponent.propTypes = process.env.NODE_ENV !== "production" ? {
    onClick: _propTypes2.default.func,
    selected: _propTypes2.default.bool,
    collapsed: _propTypes2.default.bool,
    overflowed: _propTypes2.default.bool,
    item: _propTypes2.default.shape({
      id: _propTypes2.default.string,
      label: _propTypes2.default.string,
      icon: _propTypes2.default.string
    }),
    emptyIcon: _propTypes2.default.bool,
    opened: _propTypes2.default.bool,
    onlyShowIcon: _propTypes2.default.bool
  } : {};

  exports.default = AppNavSubGroupComponent;
});