(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'classnames', 'styled-components', '../IconSet/Icon'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('classnames'), require('styled-components'), require('../IconSet/Icon'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.classnames, global.styledComponents, global.Icon);
    global.pxAppNavItem = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _classnames, _styledComponents, _Icon) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Icon2 = _interopRequireDefault(_Icon);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var AppNavItem = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-item__AppNavItem'
  })(['line-height:1.33333;text-size-adjust:100%;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;position:relative;display:flex;align-items:center;height:var(--px-app-nav-height,4rem);padding-left:var(--px-app-nav-item-padding,1rem);padding-right:var(--px-app-nav-item-padding,1rem);cursor:pointer;color:var(--px-app-nav-item-text-color,darkgray);background-color:var(--px-app-nav-item-background-color,lightgray);--iron-icon-stroke-color:var(--px-app-nav-item-text-color,darkgray);user-select:none;outline:none;&:hover{color:var(--px-app-nav-item-text-color--hover,lightgray);background-color:var(--px-app-nav-item-background-color--hover,darkgray);--iron-icon-stroke-color:var(--px-app-nav-item-text-color--hover,lightgray);}&:active{color:var(--px-app-nav-item-text-color--pressed,darkgray);background-color:var(--px-app-nav-item-background-color--pressed,lightgray);--iron-icon-stroke-color:var(--px-app-nav-item-text-color--hover,darkgray);}', ''], function (props) {
    return props.selected && (0, _styledComponents.css)(['color:var(--px-app-nav-item-text-color--selected,darkgray);background-color:var(--px-app-nav-item-background-color--selected,white);--iron-icon-stroke-color:var(--px-app-nav-item-text-color--selected,darkgray);&:before{content:\'\';position:absolute;top:0;left:0;right:0;display:block;width:100%;height:var(--px-app-nav-item-stripe-size--selected,0.13333rem);background-color:var(--px-app-nav-item-stripe-color--selected,blue);}', ''], props.collapsed && (0, _styledComponents.css)(['color:var(--px-app-nav-item-text-color--collapsed,darkgray);background-color:var(--px-app-nav-item-background-color--collapsed,white);&:before{top:0;left:0;bottom:0;right:auto;height:100%;width:var(--px-app-nav-item-stripe-size--selected,0.13333rem);}']));
  });
  AppNavItem.displayName = 'AppNavItem';

  var AppNavItemLabel = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-item__AppNavItemLabel'
  })(['margin:0;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;display:flex;flex:1;', ' ', ' ', ' ', ''], function (props) {
    return props.onlyShowIcon && (0, _styledComponents.css)(['display:none;']);
  }, function (props) {
    return props.collapsed && (0, _styledComponents.css)(['flex:1 1 auto;&:before{}']);
  }, function (props) {
    return props.overflowed && (0, _styledComponents.css)(['&:before{}']);
  }, function (props) {
    return props.empty && (0, _styledComponents.css)(['display:block;width:6.66667rem;height:0.66667rem;background-color:var(--px-app-nav-item-background-color--empty,lightgray);&:before{}']);
  });
  AppNavItemLabel.displayName = 'AppNavItemLabel';

  var AppNavItemIcon = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-item__AppNavItemIcon'
  })(['max-width:32px;', ' ', ' ', ''], function (props) {
    return props.empty && (0, _styledComponents.css)(['display:block;width:var(--px-app-nav-item-icon-size,2rem);height:var(--px-app-nav-item-icon-size,2rem);background-color:var(--px-app-nav-item-background-color--empty,lightgray);flex:none;&:before{}']);
  }, function (props) {
    return props.withLabel && (0, _styledComponents.css)(['margin-right:0.33333rem;']);
  }, function (props) {
    return props.dropdownIcon && (0, _styledComponents.css)(['margin-left:0.2rem;']);
  });
  AppNavItemIcon.displayName = 'AppNavItemIcon';

  var AppNavItemComponent = function (_React$Component) {
    _inherits(AppNavItemComponent, _React$Component);

    function AppNavItemComponent(props) {
      _classCallCheck(this, AppNavItemComponent);

      var _this = _possibleConstructorReturn(this, (AppNavItemComponent.__proto__ || Object.getPrototypeOf(AppNavItemComponent)).call(this, props));

      _this._handleClick = _this._handleClick.bind(_this);
      return _this;
    }

    _createClass(AppNavItemComponent, [{
      key: '_handleClick',
      value: function _handleClick(e) {
        if (!this.props.cancelSelect && this.props.onClick) {
          this.props.onClick(e);
        }
      }
    }, {
      key: '_shouldComponentUpdate',
      value: function _shouldComponentUpdate(nextProps) {
        return nextProps.selected !== this.props.selected || nextProps.onlyShowIcon !== this.props.onlyShowIcon;
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            label = _props.label,
            icon = _props.icon,
            id = _props.id,
            items = _props.items,
            selected = _props.selected,
            collapsed = _props.collapsed,
            emptyIcon = _props.emptyIcon,
            emptyLabel = _props.emptyLabel,
            withLabel = _props.withLabel,
            empty = _props.empty,
            dropdown = _props.dropdown,
            onlyShowIcon = _props.onlyShowIcon;


        var baseClasses = (0, _classnames2.default)('px-app-nav-item', { selected: selected });

        var itemProps = {
          label: label, icon: icon, id: id, items: items, selected: selected, dropdown: dropdown, collapsed: collapsed
        };

        return _react2.default.createElement(
          AppNavItem,
          _extends({
            onClick: this._handleClick,
            className: baseClasses,
            dropdown: items,
            'data-id': id
          }, itemProps),
          icon && !empty && !emptyIcon && _react2.default.createElement(
            AppNavItemIcon,
            {
              withLabel: label
            },
            _react2.default.createElement(_Icon2.default, { icon: icon })
          ),
          label && !emptyLabel && !emptyIcon && !empty && _react2.default.createElement(
            AppNavItemLabel,
            {
              withLabel: withLabel,
              onlyShowIcon: onlyShowIcon
            },
            label
          ),
          emptyIcon && _react2.default.createElement(AppNavItemIcon, { empty: true, withLabel: label }),
          emptyLabel && _react2.default.createElement(AppNavItemLabel, { empty: true }),
          empty && _react2.default.createElement(AppNavItemIcon, { empty: true, withLabel: label }),
          empty && _react2.default.createElement(AppNavItemLabel, { empty: true }),
          dropdown && _react2.default.createElement(
            AppNavItemIcon,
            { dropdownIcon: true },
            _react2.default.createElement(_Icon2.default, { icon: 'px-utl:chevron', size: 16 })
          )
        );
      }
    }]);

    return AppNavItemComponent;
  }(_react2.default.Component);

  AppNavItemComponent.defaultProps = {
    collapsed: false,

    cancelSelect: false,

    icon: null,

    item: null,

    label: null,

    selected: false,

    dropdown: false,
    empty: false,

    emptyIcon: false,

    emptyLabel: false,

    overflowed: false,

    subitem: false,
    onlyShowIcon: false,
    onClick: null,
    fixedWidth: null,
    id: null,
    items: null,
    hideDropdownIcon: false,
    withLabel: false
  };

  AppNavItemComponent.propTypes = process.env.NODE_ENV !== "production" ? {
    collapsed: _propTypes2.default.bool,
    withLabel: _propTypes2.default.bool,
    cancelSelect: _propTypes2.default.bool,
    icon: _propTypes2.default.string,
    item: _propTypes2.default.shape({
      id: _propTypes2.default.string,
      label: _propTypes2.default.string,
      icon: _propTypes2.default.string
    }),
    items: _propTypes2.default.arrayOf(_propTypes2.default.any),
    id: _propTypes2.default.string,
    label: _propTypes2.default.string,
    selected: _propTypes2.default.bool,
    dropdown: _propTypes2.default.bool,
    empty: _propTypes2.default.bool,
    onlyShowIcon: _propTypes2.default.bool,
    emptyIcon: _propTypes2.default.bool,
    emptyLabel: _propTypes2.default.bool,
    overflowed: _propTypes2.default.bool,
    subitem: _propTypes2.default.bool,
    onClick: _propTypes2.default.func,
    fixedWidth: _propTypes2.default.bool,
    hideDropdownIcon: _propTypes2.default.bool
  } : {};

  AppNavItemComponent.displayName = 'AppNavItemComponent';

  exports.default = AppNavItemComponent;
});