(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.pxAppNavSubItem = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var SubItem = _styledComponents2.default.div.withConfig({
    displayName: 'px-app-nav-sub-item__SubItem'
  })(['position:relative;display:flex;align-items:center;padding-left:1rem;padding-right:1rem;cursor:pointer;height:var(--px-app-nav-subitem-height,2rem);color:var(--px-app-nav-subitem-text-color,darkgray);background-color:var(--px-app-nav-subitem-background-color,white);&:hover{color:var(--px-app-nav-subitem-text-color--hover,darkgray);background-color:var(--px-app-nav-subitem-background-color--hover,lightgray);}', ' ', ''], function (props) {
    return props.selected && (0, _styledComponents.css)(['color:var(--px-app-nav-subitem-text-color--selected,white);background-color:var(--px-app-nav-subitem-background-color--selected,blue);&:hover{color:var(--px-app-nav-subitem-text-color--selected,white);background-color:var(--px-app-nav-subitem-background-color--selected,blue);}']);
  }, function (props) {
    return props.collapsed && (0, _styledComponents.css)(['color:var(--px-app-nav-subitem-text-color--collapsed,darkgray);background-color:var(--px-app-nav-subitem-background-color--collapsed,darkgray);padding-left:3.66667rem;&:hover{background-color:var(--px-app-nav-subitem-background-color--collapsed-hover,darkgray);}']);
  });

  var AppNavSubItem = function AppNavSubItem(_ref) {
    var item = _ref.item,
        selected = _ref.selected,
        collapsed = _ref.collapsed,
        onClick = _ref.onClick;
    return _react2.default.createElement(
      SubItem,
      {
        collapsed: collapsed,
        selected: selected,
        'data-id': item.id,
        onClick: onClick },
      _react2.default.createElement(
        'p',
        { className: 'app-nav-subitem__label' },
        item.label
      )
    );
  };

  AppNavSubItem.defaultProps = {
    item: null,
    selected: null,
    collapsed: null,
    onClick: null
  };

  AppNavSubItem.propTypes = process.env.NODE_ENV !== "production" ? {
    item: _propTypes2.default.shape({
      id: _propTypes2.default.string,
      label: _propTypes2.default.string,
      icon: _propTypes2.default.string
    }),
    selected: _propTypes2.default.bool,
    collapsed: _propTypes2.default.bool,
    onClick: _propTypes2.default.func
  } : {};

  exports.default = AppNavSubItem;
});