(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components', './px-predix-svg-logo', './px-ge-svg-logo', '../../../styles/flex'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'), require('./px-predix-svg-logo'), require('./px-ge-svg-logo'), require('../../../styles/flex'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents, global.pxPredixSvgLogo, global.pxGeSvgLogo, global.flex);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents, _pxPredixSvgLogo, _pxGeSvgLogo, _flex) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _pxPredixSvgLogo2 = _interopRequireDefault(_pxPredixSvgLogo);

  var _pxGeSvgLogo2 = _interopRequireDefault(_pxGeSvgLogo);

  var _flex2 = _interopRequireDefault(_flex);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var BrandingBar = _styledComponents2.default.div.withConfig({
    displayName: 'BrandingBar'
  })(['display:flex;align-items:center;width:inherit;justify-content:space-between;height:var(--px-branding-bar-height,30px);max-height:67px;min-height:30px;background-color:var(--px-branding-bar-background-color,black);font-size:var(--px-branding-bar-font-size,15px);color:var(--px-branding-bar-logo-and-title-text-color,gray);padding:0 1rem;', ''], function (props) {
    return props.responsiveWidth && (0, _styledComponents.css)(['@media (max-width:', '){display:none !important;visibility:hidden;}'], props.responsiveWidth);
  });
  BrandingBar.displayName = 'BrandingBar';
  BrandingBar.defaultProps = {
    responsiveWidth: '768px'
  };

  var BrandingBarTitle = _styledComponents2.default.div.withConfig({
    displayName: 'BrandingBar__BrandingBarTitle'
  })(['margin-left:.5rem;']);
  BrandingBarTitle.displayName = 'BrandingBarTitle';

  var BrandingBarPoweredBy = _styledComponents2.default.div.withConfig({
    displayName: 'BrandingBar__BrandingBarPoweredBy'
  })(['font-size:12px;margin-right:.3rem;']);
  BrandingBarPoweredBy.displayName = 'BrandingBarPoweredBy';

  var Component = function Component(_ref) {
    var title = _ref.title,
        powered = _ref.powered,
        hideLogo = _ref.hideLogo,
        customLogo = _ref.customLogo,
        hidePowered = _ref.hidePowered,
        responsiveWidth = _ref.responsiveWidth,
        children = _ref.children;
    return _react2.default.createElement(
      BrandingBar,
      { responsiveWidth: responsiveWidth },
      _react2.default.createElement(
        _flex2.default,
        { middle: true, flex: 1 },
        _react2.default.createElement(
          _flex2.default,
          { middle: true },
          !customLogo && !hideLogo && _react2.default.createElement(_pxGeSvgLogo2.default, null),
          customLogo && customLogo()
        ),
        _react2.default.createElement(
          _flex2.default,
          { middle: true },
          _react2.default.createElement(
            BrandingBarTitle,
            null,
            title
          )
        )
      ),
      children && _react2.default.createElement(
        'div',
        null,
        children
      ),
      !hidePowered && _react2.default.createElement(
        _flex2.default,
        { middle: true },
        _react2.default.createElement(
          BrandingBarPoweredBy,
          null,
          powered
        ),
        _react2.default.createElement(_pxPredixSvgLogo2.default, { size: 10 })
      )
    );
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    title: _propTypes2.default.string,
    powered: _propTypes2.default.string,
    responsiveWidth: _propTypes2.default.string,
    hideLogo: _propTypes2.default.bool,
    hidePowered: _propTypes2.default.bool,
    customLogo: _propTypes2.default.func,
    children: _propTypes2.default.node
  } : {};

  Component.defaultProps = {
    title: 'App Name',
    responsiveWidth: '500px',
    powered: 'Powered by React',
    hideLogo: false,
    hidePowered: false,
    customLogo: null,
    children: null
  };

  Component.displayName = 'BrandingBarComponent';

  exports.default = Component;
});