(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', '../IconSet/Icon', '../../../styles/flex'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('../IconSet/Icon'), require('../../../styles/flex'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.Icon, global.flex);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _Icon, _flex) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _Icon2 = _interopRequireDefault(_Icon);

  var _flex2 = _interopRequireDefault(_flex);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var BreadcrumbsComponent = function (_React$Component) {
    _inherits(BreadcrumbsComponent, _React$Component);

    function BreadcrumbsComponent(props) {
      _classCallCheck(this, BreadcrumbsComponent);

      var _this = _possibleConstructorReturn(this, (BreadcrumbsComponent.__proto__ || Object.getPrototypeOf(BreadcrumbsComponent)).call(this, props));

      _this.clickOnlyMode = props.clickOnlyMode || false;


      _this.keys = props.keys;

      _this.handleRef = _this.handleRef.bind(_this);
      _this._getItemProp = _this._getItemProp.bind(_this);
      _this._isLabel = _this._isLabel.bind(_this);
      _this._isDropdown = _this._isDropdown.bind(_this);
      _this._doesItemHaveSiblings = _this._doesItemHaveSiblings.bind(_this);
      _this._isNotFirstItemInData = _this._isNotFirstItemInData.bind(_this);
      _this.handleClick = _this.handleClick.bind(_this);
      return _this;
    }

    _createClass(BreadcrumbsComponent, [{
      key: 'handleClick',
      value: function handleClick(e, index, item) {
        if (this.props.onClick) {
          this.props.onClick(e, index, item);
        }
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.root) {}
      }
    }, {
      key: 'handleRef',
      value: function handleRef(el) {
        this.root = el;
      }
    }, {
      key: '_getItemProp',
      value: function _getItemProp(item, key) {
        if (item && (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && typeof key === 'string' && item[key]) {
          return item[key];
        }
        return null;
      }
    }, {
      key: '_isNotFirstItemInData',
      value: function _isNotFirstItemInData(index) {
        return index !== 0;
      }
    }, {
      key: '_doesItemHaveSiblings',
      value: function _doesItemHaveSiblings(itemInPath) {
        var graph = this._assetGraph;
        var source = itemInPath.source ? itemInPath.source : itemInPath;
        var isItemOverflow = this._getItemProp(itemInPath, this.keys.label) === '...';
        return isItemOverflow ? true : graph.hasSiblings(source);
      }
    }, {
      key: '_isLabel',
      value: function _isLabel(item, clickOnlyMode) {
        return clickOnlyMode && this._getItemProp(item, this.keys.label) !== '...' || !clickOnlyMode && !this._doesItemHaveSiblings(item);
      }
    }, {
      key: '_isDropdown',
      value: function _isDropdown(item, clickOnlyMode) {
        return !clickOnlyMode && this._getItemProp(item, this.keys.label) !== '...' && this._doesItemHaveSiblings(item);
      }
    }, {
      key: '_isOverflow',
      value: function _isOverflow(item) {
        return this._getItemProp(item, this.keys.label) === '...';
      }
    }, {
      key: '_getSeparatorSize',
      value: function _getSeparatorSize(clickOnlyMode) {
        return clickOnlyMode ? 'small' : 'large';
      }
    }, {
      key: '_getDisabled',
      value: function _getDisabled(item) {
        return item.isSelectable === false ? 'disabled' : '';
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var selectedRoute = this.props.selectedRoute;


        return _react2.default.createElement(
          'div',
          { ref: this.handleRef },
          _react2.default.createElement(
            _flex2.default,
            { middle: true },
            selectedRoute && selectedRoute.map(function (label, index) {
              return _react2.default.createElement(
                'div',
                { 'data-index': index, className: 'breadcrumbTopItem', key: label },
                _react2.default.createElement(
                  _flex2.default,
                  { middle: true },
                  _this2._isNotFirstItemInData(index, selectedRoute) && _react2.default.createElement(_Icon2.default, { icon: 'px-utl:chevron-right', size: 24, viewBox: '0 0 16 16' }),
                  _react2.default.createElement(
                    'span',
                    {
                      className: 'actionable actionable--action u-ph-',
                      onClick: _this2.handleClick.bind(_this2, index, selectedRoute) },
                    label
                  )
                )
              );
            })
          )
        );
      }
    }]);

    return BreadcrumbsComponent;
  }(_react2.default.Component);

  BreadcrumbsComponent.defaultProps = {
    clickOnlyMode: false,
    onClick: null,
    selectedRoute: null,
    keys: {
      id: 'id',
      label: 'label',
      children: 'children'
    }
  };

  var shape = _propTypes2.default.shape({
    id: _propTypes2.default.string,
    label: _propTypes2.default.string,
    children: _propTypes2.default.arrayOf(shape)
  });

  BreadcrumbsComponent.propTypes = process.env.NODE_ENV !== "production" ? {
    clickOnlyMode: _propTypes2.default.bool,
    onClick: _propTypes2.default.func,
    selectedRoute: _propTypes2.default.arrayOf(_propTypes2.default.string),
    keys: _propTypes2.default.shape({
      id: _propTypes2.default.string,
      label: _propTypes2.default.string,
      children: _propTypes2.default.string
    })
  } : {};

  exports.default = BreadcrumbsComponent;
});