(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'styled-components', 'prop-types'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('styled-components'), require('prop-types'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.styledComponents, global.propTypes);
    global.index = mod.exports;
  }
})(this, function (exports, _styledComponents, _propTypes) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Button = _styledComponents2.default.button.withConfig({
    displayName: 'Button'
  })(['font-family:"GE Inspira Sans";outline:none;user-select:none;display:inline-block;overflow:visible;height:var(--px-btn-height,auto);min-height:var(--px-btn-min-height,2rem);min-width:var(--px-btn-min-width,4.66667em);margin:0;border:1px solid var(--px-btn-border-color,transparent);border-radius:0 !important;padding:calc(var(--px-btn-height,2em) / 10) calc(var(--px-btn-height,2em) / 2);box-shadow:var(--px-btn-shadow--light,none);font:inherit;line-height:calc(var(--px-btn-height,2em) - 2px);cursor:pointer;text-align:center;text-decoration:none;text-transform:none;white-space:nowrap;background-color:var(--px-btn-background,#d8e0e5);transition:background .4s,border-color .4s,color .4s;-webkit-appearance:button;-webkit-font-smoothing:antialiased;color:var(--px-btn-color,#2c404c);display:flex;justify-content:center;align-items:center;&:link,&:visited,&:hover,&:active{color:var(--px-btn-color,#2c404c);}&:hover,&:focus{border-color:var(--px-btn-border-color--hover,transparent);box-shadow:var(--px-btn-shadow,none);background-color:var(--px-btn-background--hover,#a3b5bf);}&:active{outline:none;border-color:var(--px-btn-border-color--pressed,transparent);box-shadow:none;background-color:var(--px-btn-background--pressed,#889aa5);}', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.icon && (0, _styledComponents.css)(['height:var(--px-btn-height,2em);width:var(--px-btn-height,2em);min-width:var(--px-btn-height,2em);padding-right:0;padding-left:0;border:var(--px-btn-icon-border,0px solid) !important;color:var(--btn-color,black);background-color:var(--px-btn-icon-background,transparent);']);
  }, function (props) {
    return props.size === 'large' && (0, _styledComponents.css)(['font-size:1.33333rem;']);
  }, function (props) {
    return props.size === 'small' && (0, _styledComponents.css)(['height:1.66667em;font-size:0.8rem;line-height:calc(1.66667em - 2px);']);
  }, function (props) {
    return props.size === 'large' && (0, _styledComponents.css)(['font-size:1.33333rem;']);
  }, function (props) {
    return props.size === 'huge' && (0, _styledComponents.css)(['font-size:2rem;']);
  }, function (props) {
    return props.size === 'full' && (0, _styledComponents.css)(['width:100%;padding-right:0;padding-left:0;']);
  }, function (props) {
    return props.theme === 'primary' && (0, _styledComponents.css)(['color:var(--px-btn-primary-color,white);border-color:var(--px-btn-primary-border-color,transparent);box-shadow:var(--px-btn-shadow,none);background-color:var(--px-btn-primary-background,#364c59);&:link,&:visited,&:hover,&:active{color:var(--px-btn-primary-color,white);}&:hover,&:focus{border-color:transparent;background-color:var(--px-btn-primary-background--hover,#23343f);}&:active{border-color:transparent;background-color:var(--px-btn-primary-background--pressed,#121f26);}']);
  }, function (props) {
    return props.theme === 'error' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--error,yellow);color:var(--px-alert-label-text-color--error,black);']);
  }, function (props) {
    return props.theme === 'unknown' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--unknown,gray);color:var(--px-alert-label-text-color--unknown,white);']);
  }, function (props) {
    return props.theme === 'important' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--important,red);color:var(--px-alert-label-text-color--important,white);']);
  }, function (props) {
    return props.theme === 'warning' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--warning,orange);color:var(--px-alert-label-text-color--warning,white);']);
  }, function (props) {
    return props.theme === 'healthy' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--healthy,green);color:var(--px-alert-label-text-color--healthy,white);']);
  }, function (props) {
    return (props.theme === 'information' || props.theme === 'info') && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--info,blue);color:var(--px-alert-label-text-color--info,white);']);
  }, function (props) {
    return props.theme === 'tertiary' && (0, _styledComponents.css)(['border-color:var(--px-btn-tertiary-border-color,#889aa5);border:1px solid;box-shadow:none;background-color:var(--px-btn-tertiary-background,white);&:link,&:visited,&:hover,&:active{border-color:var(--px-btn-tertiary-border-color,#889aa5);color:var(--px-btn-tertiary-color,#007acc);}&:hover,&:focus{color:var(--px-btn-tertiary-color--hover,#005c99);border-color:var(--px-btn-tertiary-border-color,#889aa5);box-shadow:none;background-color:var(--px-btn-tertiary-background--hover,#c5d1d8);}&:active{color:var(--px-btn-tertiary-color--pressed,#003d66);border-color:var(--px-btn-tertiary-border-color,#889aa5);box-shadow:none;background-color:var(--px-btn-tertiary-background--pressed,#96a8b2);}']);
  }, function (props) {
    return props.theme === 'bare' && (0, _styledComponents.css)(['border:0 !important;border-radius:0 !important;line-height:inherit;padding-left:0;padding-right:0;box-shadow:none;background:none;outline:none;&:link,&:visited{box-shadow:none;background:none;outline:none;color:var(--px-btn-bare-color,#2c404c);}&:hover,&:focus{color:var(--px-btn-bare-color--hover,#007acc);background-color:transparent;}&:active{color:var(--px-btn-bare-color--pressed,#003d66);background-color:transparent;}']);
  }, function (props) {
    return props.theme === 'bare-primary' && (0, _styledComponents.css)(['border:0 !important;border-radius:0 !important;line-height:inherit;padding-left:0;padding-right:0;box-shadow:none;background:none;outline:none;color:var(--px-btn-primary-bare-color--visited,#007acc);&:disabled{color:var(--px-btn-disabled-color,rgba(0,0,0,0.2));}&:link,&:visited,&:hover,&:active{box-shadow:none;background:none;outline:none;}&:hover,&:focus{color:var(--px-btn-primary-bare-color--hover,#005c99);}&:active,{&:focus{color:var(--px-btn-primary-bare-color--pressed,#003d66);}']);
  }, function (props) {
    return props.theme === 'call-to-action' && (0, _styledComponents.css)(['color:var(--px-btn-call-to-action-color,white);border-color:var(--px-btn-call-to-action-border-color,transparent);box-shadow:var(--px-btn-shadow,none);background-color:var(--px-btn-call-to-action-background,#007acc);&:link,&:visited,&:hover,&:active{color:var(--px-btn-call-to-action-color,white);}&:hover,&:focus{background-color:var(--px-btn-call-to-action-background--hover,#005c99);}&:active{background-color:var(--px-btn-call-to-action-background--pressed,#003d66);}']);
  }, function (props) {
    return props.disabled && (0, _styledComponents.css)(['color:var(--px-btn-disabled-color,rgba(0,0,0,0.2));border:1px solid;border-color:var(--px-btn-disabled-border-color,rgba(0,0,0,0.2));box-shadow:none;background-color:var(--px-btn-disabled-background,transparent);pointer-events:none;']);
  });

  Button.displayName = 'Button';

  Button.defaultProps = {
    className: 'px-button',
    type: null,
    theme: null,
    size: null,
    icon: null
  };

  Button.propTypes = {
    theme: _propTypes2.default.string,
    type: _propTypes2.default.string,
    size: _propTypes2.default.string
  };

  exports.default = Button;
});