(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Chip = _styledComponents2.default.div.withConfig({
    displayName: 'Chip'
  })(['display:inline-block;align-items:center;height:20px;padding-left:10px;padding-right:10px;background-color:var(--px-chip-background-color,white);border:1px solid var(--px-chip-border-color,gray);&:hover{cursor:pointer;background-color:var(--px-chip-background-color--hover,rgba(gray,0.2));border:1px solid var(--px-chip-border-color--hover,gray);}', ''], function (props) {
    return props.selected && (0, _styledComponents.css)(['background-color:var(--px-chip-background-color--selected,white);border:1px solid var(--px-chip-border-color--selected,blue);']);
  });

  var ChipContent = _styledComponents2.default.div.withConfig({
    displayName: 'Chip__ChipContent'
  })(['line-height:18px;display:inline-block;min-width:0;max-width:var(--px-chip-max-width,120px);color:var(--px-chip-text-color,gray);']);

  var ChipIcon = _styledComponents2.default.div.withConfig({
    displayName: 'Chip__ChipIcon'
  })(['height:12px;width:12px;&:hover{color:var(--px-chip-icon-color--hover,blue);}']);

  var Component = function Component(_ref) {
    var icon = _ref.icon,
        selected = _ref.selected,
        showIcon = _ref.showIcon,
        children = _ref.children;
    return _react2.default.createElement(
      Chip,
      { selected: selected },
      _react2.default.createElement(
        ChipContent,
        null,
        children,
        showIcon && _react2.default.createElement(
          ChipIcon,
          null,
          icon
        )
      )
    );
  };

  Component.defaultProps = {
    icon: null,
    selected: null,
    showIcon: false,
    children: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    icon: _propTypes2.default.string,
    selected: _propTypes2.default.bool,
    showIcon: _propTypes2.default.bool,
    children: _propTypes2.default.node
  } : {};

  exports.default = Component;
});