(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'classnames', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('classnames'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.classnames, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _classnames, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var ContextBrowser = _styledComponents2.default.div.withConfig({
    displayName: 'ContextBrowser'
  })(['display:inline-block;align-items:center;height:20px;padding-left:10px;padding-right:10px;background-color:var(--px-chip-background-color,white);border:1px solid var(--px-chip-border-color,gray);&:hover{cursor:pointer;background-color:var(--px-chip-background-color--hover,rgba(gray,0.2));border:1px solid var(--px-chip-border-color--hover,gray);}', ''], function (props) {
    return props.selected && (0, _styledComponents.css)(['background-color:var(--px-chip-background-color--selected,white);border:1px solid var(--px-chip-border-color--selected,blue);']);
  });

  var ContextBrowserContent = _styledComponents2.default.div.withConfig({
    displayName: 'ContextBrowser__ContextBrowserContent'
  })(['line-height:18px;display:inline-block;min-width:0;max-width:var(--px-chip-max-width,120px);color:var(--px-chip-text-color,gray);']);

  var ContextBrowserIcon = _styledComponents2.default.div.withConfig({
    displayName: 'ContextBrowser__ContextBrowserIcon'
  })(['height:12px;width:12px;&:hover{color:var(--px-chip-icon-color--hover,blue);}']);

  exports.default = function (_ref) {
    var style = _ref.style,
        _ref$label = _ref.label,
        label = _ref$label === undefined ? 'Chip' : _ref$label,
        icon = _ref.icon,
        selected = _ref.selected,
        showIcon = _ref.showIcon,
        children = _ref.children;
    return _react2.default.createElement(
      ContextBrowser,
      { selected: selected },
      _react2.default.createElement(
        ContextBrowserContent,
        null,
        children
      )
    );
  };
});