(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'classnames', 'prop-types', 'styled-components', '../IconSet/Icon', '../Button'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('classnames'), require('prop-types'), require('styled-components'), require('../IconSet/Icon'), require('../Button'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.classnames, global.propTypes, global.styledComponents, global.Icon, global.Button);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _classnames, _propTypes, _styledComponents, _Icon, _Button) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Icon2 = _interopRequireDefault(_Icon);

  var _Button2 = _interopRequireDefault(_Button);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var DropdownLabel = _styledComponents2.default.div.withConfig({
    displayName: 'Dropdown__DropdownLabel'
  })(['overflow:hidden;flex-grow:1;text-overflow:ellipsis;text-align:left;~ i{margin-left:.5rem;}']);
  DropdownLabel.displayName = 'DropdownLabel';
  DropdownLabel.defaultProps = {
    className: 'px-dropdown__label'
  };

  var DropdownContent = _styledComponents2.default.div.withConfig({
    displayName: 'Dropdown__DropdownContent'
  })(['z-index:10;position:absolute;background-color:var(--px-dropdown-bg-color,#fff);border:1px solid var(--px-dropdown-border-color,gray);max-height:var(--px-dropdown-max-height,300px);max-width:var(--px-dropdown-max-width,400px);min-width:var(--px-dropdown-min-width);min-height:var(--px-dropdown-min-height);display:flex;flex-direction:column;display:none;', ' ', ''], function (props) {
    return props.opened && (0, _styledComponents.css)(['display:block;']);
  }, function (props) {
    return props.width && (0, _styledComponents.css)(['width:width;']);
  });
  DropdownContent.displayName = 'DropdownContent';
  DropdownContent.defaultProps = {
    className: 'px-dropdown__content'
  };

  var DropdownOption = _styledComponents2.default.div.withConfig({
    displayName: 'Dropdown__DropdownOption'
  })(['padding-left:var(--px-dropdown-item-padding,.66667rem);padding-right:var(--px-dropdown-item-padding,.66667rem);padding-top:var(--px-dropdown-item-padding);padding-bottom:var(--px-dropdown-item-padding);height:var(--px-dropdown-item-height,2rem);cursor:pointer;display:flex;align-items:center;&:hover{background-color:var(--px-dropdown-bg-color--hover,#d3d3d3);}&.selected,&:active{background-color:var(--px-dropdown-bg-color--selected,#00f);color:var(--px-dropdown-text-color--selected,#fff);}', ' ', ''], function (props) {
    return props.disabled && (0, _styledComponents.css)(['color:var(--px-dropdown-text-color--disabled,gray);background-color:var(--px-dropdown-bg-color--disabled,transparent);cursor:not-allowed;pointer-events:none;']);
  }, function (props) {
    return props.selected && (0, _styledComponents.css)(['background-color:var(--px-dropdown-bg-color--selected,#00f);color:var(--px-dropdown-text-color--selected,#fff);&:hover{background-color:var(--px-dropdown-bg-color--selected,#00f);color:var(--px-dropdown-text-color--selected,#fff);}']);
  });
  DropdownOption.displayName = 'DropdownOption';
  DropdownOption.defaultProps = {
    className: 'px-dropdown__option'
  };

  var DropdownTrigger = _styledComponents2.default.div.withConfig({
    displayName: 'Dropdown__DropdownTrigger'
  })(['max-width:inherit;width:inherit;display:flex;justify-content:center;align-items:center;outline:0;font-weight:var(--px-dropdown-font-weight,normal);height:auto;']);
  DropdownTrigger.displayName = 'DropdownTrigger';
  DropdownTrigger.defaultProps = {
    className: 'px-dropdown__trigger'
  };

  var Dropdown = function (_React$Component) {
    _inherits(Dropdown, _React$Component);

    function Dropdown(props) {
      _classCallCheck(this, Dropdown);

      var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

      _this.displayName = 'Dropdown';
      _this._handleClear = _this._handleClear.bind(_this);
      _this._handleClick = _this._handleClick.bind(_this);
      _this.state = {
        dropdownContentWidth: props.dropdownContentWidth,
        selected: props.selected,
        selectedItems: props.selectedItems || null,
        selectedValues: props.selectedValues || null,
        opened: props.opened || false,
        items: props.items || null
      };
      return _this;
    }

    _createClass(Dropdown, [{
      key: '_handleClick',
      value: function _handleClick(e) {
        if (e && e.target && e.target.classList.contains('px-utl-close')) {
          this._clearSelected();
          this.setState({
            selectedItem: null
          });
        } else {
          this.setState({ opened: !this.state.opened });
        }
      }
    }, {
      key: '_clearSelected',
      value: function _clearSelected() {
        var items = this.state.items;

        items.forEach(function (item) {
          var i = item;
          i.selected = false;
          return i;
        });
        this.setState({ items: items });
      }
    }, {
      key: '_handleChange',
      value: function _handleChange(item, index, e) {
        if (item.disabled) {
          return;
        }
        this.setState({
          selectedItem: item
        });

        if (!this.props.multi) {
          this._clearSelected();
          this._handleClick();
        }

        if (this.props.onChange) {
          this.props.onChange(item, index, e);
        }
      }
    }, {
      key: '_handleClear',
      value: function _handleClear() {
        this.setState({
          selectedItem: null
        });
      }
    }, {
      key: '_handleDropdownContentRef',
      value: function _handleDropdownContentRef(el) {
        this.dropdownContent = el;
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props,
            _props$keys = _props.keys,
            keys = _props$keys === undefined ? {
          key: 'key',
          val: 'val'
        } : _props$keys,
            className = _props.className,
            disabled = _props.disabled,
            disableClear = _props.disableClear,
            icon = _props.icon,
            triggerHeight = _props.triggerHeight,
            hideChevron = _props.hideChevron,
            buttonStyle = _props.buttonStyle,
            displayValue = _props.displayValue,
            children = _props.children;


        var triggerStyle = {
          height: triggerHeight
        };

        var _state = this.state,
            opened = _state.opened,
            items = _state.items,
            selectedItem = _state.selectedItem,
            dropdownContentWidth = _state.dropdownContentWidth;


        var baseClasses = (0, _classnames2.default)('px-dropdown', className);
        return _react2.default.createElement(
          'div',
          { className: baseClasses },
          _react2.default.createElement(
            _Button2.default,
            {
              theme: buttonStyle,
              disabled: disabled,
              style: triggerStyle,
              onClick: this._handleClick
            },
            children && children,
            !children && _react2.default.createElement(
              DropdownTrigger,
              null,
              selectedItem && _react2.default.createElement(
                DropdownLabel,
                null,
                selectedItem[keys.val]
              ),
              !selectedItem && _react2.default.createElement(
                DropdownLabel,
                null,
                displayValue
              ),
              !hideChevron && !opened && !selectedItem && _react2.default.createElement(_Icon2.default, { icon: icon, size: 16 }),
              !disableClear && selectedItem && opened && _react2.default.createElement(_Icon2.default, { icon: 'px-utl:close', size: 16, onClick: this._handleClear })
            )
          ),
          _react2.default.createElement(
            DropdownContent,
            { opened: opened, width: dropdownContentWidth },
            items && items.map(function (item, index) {
              return _react2.default.createElement(
                DropdownOption,
                {
                  key: item[keys.key],
                  'data-key': item[keys.key],
                  'data-val': item[keys.val],
                  disabled: item.disabled,
                  selected: item.selected,
                  onClick: _this2._handleChange.bind(_this2, item, index) },
                item[keys.val]
              );
            })
          )
        );
      }
    }]);

    return Dropdown;
  }(_react2.default.Component);

  Dropdown.defaultProps = {
    keys: {
      key: 'key',
      val: 'val'
    },
    className: null,
    disabled: null,
    disableClear: null,
    triggerHeight: null,
    selected: null,
    hideChevron: null,
    buttonStyle: null,
    dropdownContentWidth: null,
    displayValue: null,
    multi: null,
    opened: null,
    children: null,
    items: null,
    onChange: null,
    selectedItems: null,
    selectedValues: null,
    icon: 'px-utl:chevron'
  };

  Dropdown.propTypes = process.env.NODE_ENV !== "production" ? {
    keys: _propTypes2.default.shape({
      key: _propTypes2.default.string,
      val: _propTypes2.default.string
    }),
    items: _propTypes2.default.arrayOf(_propTypes2.default.any),
    selectedItems: _propTypes2.default.arrayOf(_propTypes2.default.any),
    selectedValues: _propTypes2.default.arrayOf(_propTypes2.default.any),
    selected: _propTypes2.default.string,
    className: _propTypes2.default.string,
    disabled: _propTypes2.default.bool,
    disableClear: _propTypes2.default.bool,
    dropdownContentWidth: _propTypes2.default.number,
    triggerHeight: _propTypes2.default.number,
    hideChevron: _propTypes2.default.bool,
    buttonStyle: _propTypes2.default.string,
    displayValue: _propTypes2.default.string,
    opened: _propTypes2.default.bool,
    multi: _propTypes2.default.bool,
    children: _propTypes2.default.node,
    onChange: _propTypes2.default.func,
    icon: _propTypes2.default.string
  } : {};

  Dropdown.displayName = 'Dropdown';

  exports.default = Dropdown;
});