(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Grid = _styledComponents2.default.div.withConfig({
    displayName: 'Grid'
  })(['display:grid;', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.inline && (0, _styledComponents.css)(['display:inline-grid;']);
  }, function (props) {
    return props.template && (0, _styledComponents.css)(['grid-template:', ';'], props.template);
  }, function (props) {
    return props.columns && (0, _styledComponents.css)(['grid-template-columns:', ';'], props.columns);
  }, function (props) {
    return props.rows && (0, _styledComponents.css)(['grid-template-rows:', ';'], props.rows);
  }, function (props) {
    return props.columnGap && (0, _styledComponents.css)(['grid-column-gap:', ';'], props.columnGap);
  }, function (props) {
    return props.rowGap && (0, _styledComponents.css)(['grid-row-gap:', ';'], props.rowGap);
  }, function (props) {
    return props.justifyItems && (0, _styledComponents.css)(['justify-items:', ';'], props.justifyItems);
  }, function (props) {
    return props.item && (0, _styledComponents.css)(['display:inline-block;', ''], props.alignSelf && (0, _styledComponents.css)(['align-self:', ';'], props.alignSelf));
  });

  exports.default = Grid;
});