(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.pxIconSetUtility = mod.exports;
  }
})(this, function (exports) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var utl = {
    'px-utl-add': '<g id="px-utl-add"><path stroke-linejoin="round" d="M7.5 16V1m0 15V1M0 8.5h15"/></g>',
    'px-utl-alert': '<g id="px-utl-alert"><path stroke-linejoin="round" d="M13.5 6.32v6.18H9.17L7 15l-2.17-2.5H.5v-10h8.86M3 6.5h5m-5 2h8"/><circle cx="12.5" cy="3.5" r="3" stroke-linejoin="round"/></g>',
    'px-utl-app-settings': '<g id="px-utl-app-settings"><circle cx="8" cy="8" r="2.5" stroke-linejoin="round"/><path d="M13.53 6.6a5.67 5.67 0 0 0-.63-1.53l1.22-1.56-.81-.81-.82-.82-1.57 1.22a5.67 5.67 0 0 0-1.52-.63L9.16.5H6.84l-.24 2a5.67 5.67 0 0 0-1.53.63L3.51 1.88l-.81.81-.82.82L3.1 5.08a5.67 5.67 0 0 0-.63 1.52l-2 .24v2.31l2 .24a5.67 5.67 0 0 0 .63 1.53l-1.22 1.57.81.81.82.82 1.57-1.22a5.67 5.67 0 0 0 1.53.63l.24 2h2.31l.24-2a5.67 5.67 0 0 0 1.53-.63l1.56 1.22.81-.81.82-.82-1.22-1.57a5.67 5.67 0 0 0 .63-1.53l2-.24v-2.3z" stroke-linejoin="round"/></g>',
    'px-utl-calculation': '<g id="px-utl-calculation"><path stroke-linejoin="round" d="M1.5.5h13v15h-13z"/><path stroke-linejoin="round" d="M4.5 8.5h1v1h-1zm3 0h1v1h-1zm3 0h1v1h-1zm-6 3h1v1h-1zm3 0h1v1h-1zm3 0h1v1h-1zm-7-9h9v3h-9z"/></g>',
    'px-utl-calendar': '<g id="px-utl-calendar"><path stroke-linejoin="round" d="M.5 1.5h15v12H.5z"/><path stroke-miterlimit="10" d="M3.5 3V0m9 3V0M1 4.5h15m-15 3h15m-15 3h15m-12.5 3v-9m3 9.5V5m3 9V5m3 9V5"/></g>',
    'px-utl-camera': '<g id="px-utl-camera"><path stroke-linejoin="round" d="M15.5 13.5H.5v-9h3l2-3h5l2 3h3v9z"/><circle cx="8" cy="8" r="2.5" stroke-linejoin="round"/></g>',
    'px-utl-check': '<g id="px-utl-check"><path stroke-linejoin="round" d="M2.04 9.74l3.67 3.66L13.5 2.5"/></g>',
    'px-utl-chevron': '<g id="px-utl-chevron"><path d="M2.4 6.2l5.5 5.5 5.5-5.5"/></g>',
    'px-utl-chevron-left': '<g id="px-utl-chevron-left"><path stroke-linejoin="round" d="M10.6 2.2L5.1 7.7l5.5 5.5"/></g>',
    'px-utl-chevron-right': '<g id="px-utl-chevron-right"><path stroke-linejoin="round" d="M6.2 13.2l5.4-5.5-5.5-5.5"/></g>',
    'px-utl-chevron-up': '<g id="px-utl-chevron-up"><path stroke-linejoin="round" d="M13.4 10.4L7.9 4.9l-5.5 5.5"/></g>',
    'px-utl-clock': '<g id="px-utl-clock"><circle cx="8" cy="8" r="7.5" stroke-linejoin="round"/><path stroke-linejoin="round" d="M7.5 4v5l3.53-2.03"/></g>',
    'px-utl-close': '<g id="px-utl-close"><path stroke-miterlimit="10" d="M2.3 2.3l11.4 11.4m0-11.4L2.3 13.7"/></g>',
    'px-utl-confirmed': '<g id="px-utl-confirmed"><circle cx="8" cy="8" r="7.5" stroke-linejoin="round"/><path stroke-linejoin="round" d="M4.25 7.9l2.6 2.6 5.09-5.08"/></g>',
    'px-utl-copy': '<g id="px-utl-copy"><path d="M10.5 15.5H.5v-10h7l3 3z" stroke-linejoin="round"/><path stroke-linejoin="round" d="M6.5 5.5v4h4M5.5 4V.5h7l3 3v7H12"/><path stroke-linejoin="round" d="M11.5.5v4h4"/></g>',
    'px-utl-delete': '<g id="px-utl-delete"><path d="M2.5 5v9.5a1 1 0 0 0 1 1h9a1 1 0 0 0 1-1V5M0 3.5h16M4.5 3.45L5.5.5h5l1.02 3.05M6.5 7v5m3-5v5" stroke-linejoin="round"/></g>',
    'px-utl-desktop-computer': '<g id="px-utl-desktop-computer"><path stroke-linejoin="round" d="M.5.5h15v10H.5zm11 14c-1.11 0-2-1.57-2-3.5v-.5m-5 4c1.11 0 2-1.57 2-3.5v-.5m-3 4h9m-12-7h15"/></g>',
    'px-utl-download': '<g id="px-utl-download"><path stroke-linejoin="round" d="M.5 11v4.5h14V11m-7-11v10m-4-3.5l4 4 4-4"/></g>',
    'px-utl-edit': '<g id="px-utl-edit"><path stroke-linejoin="round" d="M.5 3.66l10.26 10.26 4.74 1.58-1.58-4.74L3.66.5.5 3.66zm2.37 2.37l3.16-3.16M5.5 5.5l6 6"/></g>',
    'px-utl-failure': '<g id="px-utl-failure"><path d="M7.11 2.45L.63 13.12a1 1 0 0 0 .89 1.52h13a1 1 0 0 0 .89-1.52L8.89 2.45a1 1 0 0 0-1.78 0zm-1.36 5.3l4.5 4.5m0-4.5l-4.5 4.5" stroke-linejoin="round"/></g>',
    'px-utl-filter': '<g id="px-utl-filter"><path stroke-linejoin="round" d="M1.5 1.5l5 6V14l3 1.5v-8l5-6M0 1.5h16"/></g>',
    'px-utl-flag': '<g id="px-utl-flag"><path stroke-linejoin="round" d="M1.5 16V0m.08 2.15c4.59-2.6 6.46 3.74 13-.48V8c-6.58 4.23-8.4-2.11-13 .49"/></g>',
    'px-utl-folder-closed': '<g id="px-utl-folder-closed"><path stroke-linejoin="round" d="M7.5 4.5l-2-3h-5v13h15v-10h-8zm0 0h-7"/></g>',
    'px-utl-folder-open': '<g id="px-utl-folder-open"><path stroke-linejoin="round" d="M13.5 7.5v-3h-6l-2-3h-5v14l3-8h12l-2 8H.5"/></g>',
    'px-utl-formula': '<g id="px-utl-formula"><g><path stroke-linejoin="round" d="M9 7.5h1.5l1 4 2.5-8h5m-4.5 3l4 4m0-4l-4 4M5 7.5h3m-3 2h3"/></g><g><text transform="translate(.68 10.23)" font-size="8" font-weight="700" letter-spacing=".03em">y</text></g></g>',
    'px-utl-help': '<g id="px-utl-help"><circle cx="8.5" cy="8.5" r="7" stroke-linejoin="round"/><path d="M6.5 6.5a2 2 0 1 1 2.89 1.79 1.51 1.51 0 0 0-.89 1.34V10" stroke-linejoin="round"/><circle cx="8.5" cy="12" r=".5" stroke-linejoin="round"/></g>',
    'px-utl-information': '<g id="px-utl-information"><circle cx="7.5" cy="8.5" r="7" stroke-linejoin="round"/><circle cx="7.5" cy="6" r=".5" stroke-linejoin="round"/><path stroke-linejoin="round" d="M7.5 8v4"/></g>',
    'px-utl-link': '<g id="px-utl-link"><path d="M7.67 5.61a1 1 0 0 1 0-1.41l3.4-3.4a1 1 0 0 1 1.41 0l2.72 2.72a1 1 0 0 1 0 1.41l-3.4 3.4a1 1 0 0 1-1.41 0m-2.06 2.06a1 1 0 0 1 0 1.41l-3.4 3.4a1 1 0 0 1-1.41 0L.79 12.49a1 1 0 0 1 0-1.41l3.4-3.4a1 1 0 0 1 1.41 0m5.84-3.12l-6.88 6.88" stroke-linejoin="round"/></g>',
    'px-utl-location': '<g id="px-utl-location"><path d="M13.5 6.11C13.5 10.7 8 15.5 8 15.5s-5.5-4.8-5.5-9.39A5.56 5.56 0 0 1 8 .5a5.56 5.56 0 0 1 5.5 5.61z" stroke-linejoin="round"/><circle cx="8" cy="6" r="2.5" stroke-linejoin="round"/></g>',
    'px-utl-locked': '<g id="px-utl-locked"><path stroke-linejoin="round" d="M1.5 7.5h12v8h-12zm6-7a4 4 0 0 1 4 4v3h-8v-3a4 4 0 0 1 4-4zm0 12.5v-3"/></g>',
    'px-utl-map': '<g id="px-utl-map"><path stroke-linejoin="round" d="M15.5 14.5l-5-2-5 2-5-2v-11l5 2 5-2 5 2v11zm-10-11v11m5-13v11"/></g>',
    'px-utl-module-settings': '<g id="px-utl-module-settings"><path stroke-linejoin="round" d="M16 4.5h-3.5m-4 0H0m16 7H7.5m-4 0H0"/><rect x="8.5" y="2.5" width="4" height="4" rx="1" ry="1" stroke-linejoin="round"/><rect x="3.5" y="9.5" width="4" height="4" rx="1" ry="1" stroke-linejoin="round"/></g>',
    'px-utl-overflow': '<g id="px-utl-overflow"><path d="M.35 14.35l7-7-7-7"/><path d="M5.35 14.35l7-7-7-7"/></g>',
    'px-utl-phone': '<g id="px-utl-phone"><path stroke-linejoin="round" d="M3.5.5h9v15h-9zm3 13h3m-6-2h9"/></g>',
    'px-utl-remove': '<g id="px-utl-remove"><path stroke-linejoin="round" d="M0 8.5h15"/></g>',
    'px-utl-reply': '<g id="px-utl-reply"><path d="M14.5 14.5V9.32A4.82 4.82 0 0 0 9.68 4.5H6.5v-3l-6 5 6 5v-3h3.1a4.9 4.9 0 0 1 4.9 4.9z" stroke-linejoin="round"/></g>',
    'px-utl-save': '<g id="px-utl-save"><path d="M14.5 14.5h-13v-13h10l3 3z" stroke-linejoin="round"/><path stroke-linejoin="round" d="M4.5 8.5h7v6h-7zm1-7h5v4h-5z"/></g>',
    'px-utl-search': '<g id="px-utl-search"><circle cx="6" cy="6" r="5.5" stroke-linejoin="round"/><path stroke-linejoin="round" d="M15.5 15.5L10 10"/></g>',
    'px-utl-share': '<g id="px-utl-share"><path stroke-linejoin="round" d="M5 6.5H2.5v9h10v-9H10M7.5 12V1m-3 2.75l3-3 3 3"/></g>',
    'px-utl-tablet': '<g id="px-utl-tablet"><path stroke-linejoin="round" d="M1.5.5h13v15h-13zm5 13h3"/><path stroke-linejoin="round" d="M3.5 2.5h9v9h-9z"/></g>',
    'px-utl-unlink': '<g id="px-utl-unlink"><path d="M7.67 4.2l3.4-3.4a1 1 0 0 1 1.41 0l2.72 2.72a1 1 0 0 1 0 1.41l-3.4 3.4M8.33 11.8l-3.4 3.4a1 1 0 0 1-1.41 0L.79 12.49a1 1 0 0 1 0-1.41l3.4-3.4m9.31 5.82l-11-11" stroke-linejoin="round"/></g>',
    'px-utl-unlocked': '<g id="px-utl-unlocked"><path stroke-linejoin="round" d="M1.5 7.5h12v8h-12zm2 0v-3a4 4 0 0 1 4-4 4 4 0 0 1 4 4m-5.5 7h3"/></g>',
    'px-utl-upload': '<g id="px-utl-upload"><path stroke-linejoin="round" d="M.5 12v3.5h14V12m-7 0V2m4 3.5l-4-4-4 4"/></g>',
    'px-utl-zoom': '<g id="px-utl-zoom"><circle cx="6" cy="6" r="5.5" stroke-linejoin="round"/><path stroke-linejoin="round" d="M15.5 15.5L10 10"/></g>'
  };
  exports.default = utl;
});