(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components', './Label'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'), require('./Label'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents, global.Label);
    global.FormField = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents, _Label) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Label2 = _interopRequireDefault(_Label);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var FormFieldStyled = _styledComponents2.default.div.withConfig({
    displayName: 'FormField__FormFieldStyled'
  })(['margin-bottom:1.3rem;&:last-child{margin-bottom:2.6rem;}']);

  var FormField = function FormField(_ref) {
    var label = _ref.label,
        htmlFor = _ref.htmlFor,
        children = _ref.children;
    return _react2.default.createElement(
      FormFieldStyled,
      null,
      label && _react2.default.createElement(
        _Label2.default,
        { htmlFor: htmlFor },
        label
      ),
      children
    );
  };

  FormField.displayName = 'FormField';

  FormField.defaultProps = {
    label: null,
    htmlFor: null,
    children: null
  };

  FormField.propTypes = process.env.NODE_ENV !== "production" ? {
    label: _propTypes2.default.string,
    htmlFor: _propTypes2.default.string,
    children: _propTypes2.default.node
  } : {};

  exports.default = FormField;
});