(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _templateObject = _taggedTemplateLiteral(['\n  font: inherit;\n  outline: 0;\n  background-color: var(--px-input-background-color, transparent);\n  transition: background .4s, border-color .4s, color .4s;\n\n\n  &:focus::placeholder,\n  &:disabled::placeholder{\n    color: var(--px-input-text-color--placeholder--focused, rgba(0, 0, 0, 0.3));\n  }\n\n  &::placeholder{\n    color: var(--px-input-text-color--placeholder, rgba(0, 0, 0, 0.3));\n  }\n\n  &:disabled::placeholder{\n    color: var(--px-input-text-color--disabled, rgba(0, 0, 0, 0.2));\n  }\n\n  &::-ms-clear {\n    display: none;\n  }\n\n  &:readonly,\n  &:disabled {\n    border-color: var(--px-input-border-color--disabled, rgba(0, 0, 0, 0.2));\n    color: var(--px-input-text-color--disabled, rgba(0, 0, 0, 0.2));\n    cursor: not-allowed;\n    background-color: var(--px-input-background-color--disabled, transparent);\n  }\n\n  &:hover{\n    background-color: var(--px-input-background-color--hover, #d8e0e5);\n  }\n\n  &:focus{\n    border-color: var(--px-input-border-color--outer--focused, #007acc);\n    background-color: var(--px-input-background-color--focused, #eefbff);\n    color: var(--px-input-text-color--focused, inherit);\n  }\n\n  &::placeholder {\n    padding-top: 1px;\n  }\n\n\n  &[type=checkbox] + label {\n    padding-left: 5px;\n  }\n  &[type=radio] + label {\n    padding-left: 3px;\n  }\n\n  &[type=checkbox],\n  &[type=radio]{\n    margin: 0;\n    padding: 0;\n    font-size: 1.05em;\n    cursor: pointer;\n    outline: none;\n    width: auto;\n    height: auto;\n    &[disabled]{\n      cursor: not-allowed;\n    }\n  }\n\n  ', '\n\n  ', '\n\n  ', '\n\n  ', '\n\n  ', '\n\n  ', '\n\n   ', '\n'], ['\n  font: inherit;\n  outline: 0;\n  background-color: var(--px-input-background-color, transparent);\n  transition: background .4s, border-color .4s, color .4s;\n\n\n  &:focus::placeholder,\n  &:disabled::placeholder{\n    color: var(--px-input-text-color--placeholder--focused, rgba(0, 0, 0, 0.3));\n  }\n\n  &::placeholder{\n    color: var(--px-input-text-color--placeholder, rgba(0, 0, 0, 0.3));\n  }\n\n  &:disabled::placeholder{\n    color: var(--px-input-text-color--disabled, rgba(0, 0, 0, 0.2));\n  }\n\n  &::-ms-clear {\n    display: none;\n  }\n\n  &:readonly,\n  &:disabled {\n    border-color: var(--px-input-border-color--disabled, rgba(0, 0, 0, 0.2));\n    color: var(--px-input-text-color--disabled, rgba(0, 0, 0, 0.2));\n    cursor: not-allowed;\n    background-color: var(--px-input-background-color--disabled, transparent);\n  }\n\n  &:hover{\n    background-color: var(--px-input-background-color--hover, #d8e0e5);\n  }\n\n  &:focus{\n    border-color: var(--px-input-border-color--outer--focused, #007acc);\n    background-color: var(--px-input-background-color--focused, #eefbff);\n    color: var(--px-input-text-color--focused, inherit);\n  }\n\n  &::placeholder {\n    padding-top: 1px;\n  }\n\n\n  &[type=checkbox] + label {\n    padding-left: 5px;\n  }\n  &[type=radio] + label {\n    padding-left: 3px;\n  }\n\n  &[type=checkbox],\n  &[type=radio]{\n    margin: 0;\n    padding: 0;\n    font-size: 1.05em;\n    cursor: pointer;\n    outline: none;\n    width: auto;\n    height: auto;\n    &[disabled]{\n      cursor: not-allowed;\n    }\n  }\n\n  ', '\n\n  ', '\n\n  ', '\n\n  ', '\n\n  ', '\n\n  ', '\n\n   ', '\n']);

  function _taggedTemplateLiteral(strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  }

  var sizes = {
    tiny: '7.06667rem',
    small: '14.13333rem',
    regular: '21.2rem',
    large: '28.26667rem',
    huge: '35.33333rem'
  };

  var BaseInput = _styledComponents2.default.input.withConfig({
    displayName: 'Input__BaseInput'
  })(['box-sizing:border-box;height:2em;width:100%;border:none;border-radius:0;border-bottom:1px solid var(--px-input-border-color--outer,#889aa5);padding:0 0.33333rem;color:var(--px-input-text-color,#2c404c);']);

  var Input = BaseInput.extend(_templateObject, function (props) {
    return props.auto && (0, _styledComponents.css)(['max-width:auto;']);
  }, function (props) {
    return props.tiny && (0, _styledComponents.css)(['max-width:7.06667rem;']);
  }, function (props) {
    return props.small && (0, _styledComponents.css)(['max-width:14.13333rem;']);
  }, function (props) {
    return props.regular && (0, _styledComponents.css)(['max-width:21.2rem;']);
  }, function (props) {
    return props.large && (0, _styledComponents.css)(['max-width:28.26667rem;']);
  }, function (props) {
    return props.huge && (0, _styledComponents.css)(['max-width:35.33333rem;']);
  }, function (props) {
    return props.size && (0, _styledComponents.css)(['max-width:', ';'], sizes[props.size]);
  });

  Input.displayName = 'Input';

  exports.default = Input;
});