(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var KvpLabel = _styledComponents2.default.div.withConfig({
    displayName: 'KeyValuePair__KvpLabel'
  })(['font-size:.8rem;line-height:1.66667;color:var(--px-headings-label-color,gray);']);
  KvpLabel.displayName = 'KvpLabel';
  KvpLabel.defaultProps = {
    className: 'kvp-label',
    size: null
  };
  KvpLabel.propTypes = {
    className: _propTypes2.default.string,
    size: _propTypes2.default.string
  };

  var KvpValue = _styledComponents2.default.span.withConfig({
    displayName: 'KeyValuePair__KvpValue'
  })(['color:var(--px-headings-value-color,black);margin-top:-4px;', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.size === 'alpha' && (0, _styledComponents.css)(['margin-top:-10px;']);
  }, function (props) {
    return props.size === 'beta' && (0, _styledComponents.css)(['margin-top:-6px;']);
  }, function (props) {
    return props.size === 'gamma' && (0, _styledComponents.css)(['margin-top:-12px;']);
  }, function (props) {
    return props.size === 'delta' && (0, _styledComponents.css)(['margin-top:-8px;']);
  }, function (props) {
    return props.size === 'epsilon' && (0, _styledComponents.css)(['margin-top:-2px;']);
  });
  KvpValue.displayName = 'KvpValue';
  KvpValue.defaultProps = {
    className: 'kvp-value',
    size: null
  };
  KvpValue.propTypes = {
    className: _propTypes2.default.string,
    size: _propTypes2.default.string
  };

  var KvpUom = _styledComponents2.default.span.withConfig({
    displayName: 'KeyValuePair__KvpUom'
  })(['margin-left:0px;', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.size === 'value' && (0, _styledComponents.css)(['font-size:1rem;']);
  }, function (props) {
    return props.size === 'alpha' && (0, _styledComponents.css)(['margin-left:-12px;']);
  }, function (props) {
    return props.size === 'beta' && (0, _styledComponents.css)(['margin-left:-10px;']);
  }, function (props) {
    return props.size === 'gamma' && (0, _styledComponents.css)(['margin-left:-8px;']);
  }, function (props) {
    return props.size === 'delta' && (0, _styledComponents.css)(['margin-left:-4px;']);
  }, function (props) {
    return props.size === 'epsilon' && (0, _styledComponents.css)(['margin-left:-2px;']);
  });
  KvpUom.displayName = 'KvpUom';
  KvpUom.defaultProps = {
    className: 'kvp-uom',
    size: null
  };
  KvpUom.propTypes = {
    className: _propTypes2.default.string,
    size: _propTypes2.default.string
  };

  var _getAdjustedSize = function _getAdjustedSize(s) {
    return s === 'alpha' ? 'delta' : s === 'beta' ? 'epsilon' : s === 'gamma' ? 'value' : s === 'delta' ? 'value' : 'zeta';
  };


  var Component = function Component(_ref) {
    var label = _ref.label,
        value = _ref.value,
        size = _ref.size,
        uom = _ref.uom,
        children = _ref.children;
    return _react2.default.createElement(
      'div',
      { className: 'px-key-value-pair' },
      _react2.default.createElement(
        KvpLabel,
        null,
        label
      ),
      _react2.default.createElement(
        KvpValue,
        { size: _getAdjustedSize(size), className: size },
        value,
        uom && _react2.default.createElement(
          KvpUom,
          { size: _getAdjustedSize(size), className: _getAdjustedSize(size) },
          uom
        )
      ),
      children
    );
  };

  Component.defaultProps = {
    label: null,
    value: null,
    size: null,
    uom: null,
    children: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    label: _propTypes2.default.string,
    value: _propTypes2.default.string,
    size: _propTypes2.default.string,
    uom: _propTypes2.default.string,
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
  } : {};

  exports.default = Component;
});