(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Layout = _styledComponents2.default.div.withConfig({
    displayName: 'Layout'
  })(['display:flex;flex-wrap:wrap;list-style:none;margin:0;padding:0;', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.tiny && (0, _styledComponents.css)(['  margin-left:-0.33333rem;> div{padding-left:0.33333rem;}']);
  }, function (props) {
    return props.small && (0, _styledComponents.css)(['  margin-left:-0.66667rem;> div{padding-left:0.66667rem;}']);
  }, function (props) {
    return props.large && (0, _styledComponents.css)(['  margin-left:-1.33333rem;> div{padding-left:1.33333rem;}']);
  }, function (props) {
    return props.huge && (0, _styledComponents.css)(['  margin-left:-2rem;> div{padding-left:2rem;}']);
  }, function (props) {
    return props.rev && (0, _styledComponents.css)([' flex-direction:row-reverse;']);
  }, function (props) {
    return props.col && (0, _styledComponents.css)([' flex-direction:column;']);
  }, function (props) {
    return props.colrev && (0, _styledComponents.css)([' flex-direction:column-reverse;']);
  }, function (props) {
    return props.inline && (0, _styledComponents.css)(['display:inline-flex;']);
  }, function (props) {
    return props.wrap && (0, _styledComponents.css)(['flex-wrap:wrap;']);
  }, function (props) {
    return props.wraprev && (0, _styledComponents.css)(['flex-wrap:wrap-reverse;']);
  }, function (props) {
    return props.nowrap && (0, _styledComponents.css)(['flex-wrap:nowrap;']);
  }, function (props) {
    return props.left && (0, _styledComponents.css)(['justify-content:flex-start;']);
  }, function (props) {
    return props.center && (0, _styledComponents.css)(['justify-content:center;']);
  }, function (props) {
    return props.right && (0, _styledComponents.css)(['justify-content:flex-end;']);
  }, function (props) {
    return props.justify && (0, _styledComponents.css)(['justify-content:space-between;']);
  }, function (props) {
    return props.spaced && (0, _styledComponents.css)(['justify-content:space-around;']);
  }, function (props) {
    return props.top && (0, _styledComponents.css)(['align-items:flex-start;']);
  }, function (props) {
    return props.middle && (0, _styledComponents.css)(['align-items:center;']);
  }, function (props) {
    return props.bottom && (0, _styledComponents.css)(['align-items:flex-end;']);
  }, function (props) {
    return props.stretch && (0, _styledComponents.css)(['align-items:stretch;']);
  }, function (props) {
    return props.baseline && (0, _styledComponents.css)(['align-items:baseline;']);
  }, function (props) {
    return props.item && (0, _styledComponents.css)(['padding-left:1rem;flex:1;flex-basis:13.33333rem;&:nth-last-child(-n+3):first-child,&:nth-last-child(-n+3):first-child~.layout__item{flex-basis:26.66667rem;}&:nth-last-child(-n+4):first-child,&:nth-last-child(-n+4):first-child ~ .layout__item{flex-basis:20rem;}@media screen and (min-width:64em){flex-basis:0;}@media screen and (min-width:64em){&:nth-last-child(-n+3):first-child,&:nth-last-child(-n+3):first-child ~  .layout__item{flex-basis:0;}}']);
  });

  Layout.displayName = 'Layout';
  Layout.defaultProps = {
    className: 'layout'
  };
  exports.default = Layout;
});