(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components', '../IconSet/Icon'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'), require('../IconSet/Icon'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents, global.Icon);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents, _Icon) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Icon2 = _interopRequireDefault(_Icon);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Navbar = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar'
  })(['position:absolute;top:0;left:0;right:0;-webkit-touch-callout:none;user-select:none;transform:translate3d(0,0,0);transition:var(--px-navbar-transition,transform 0.4s cubic-bezier(0.215,0.61,0.355,1));font-size:15px;border-bottom:1px solid gray;border-bottom:var(--px-navbar-border-bottom,1px solid gray);background-color:var(--px-navbar-background-color,white);color:var(--px-navbar-color,black);box-shadow:0 2px 2px 0 rgba(0,0,0,0.15);svg{stroke:none;fill:var(--px-navbar-color,currentColor);color:currentColor;}button{padding:0.33333rem;letter-spacing:0;line-height:20px;padding:0.33333rem;min-width:2.93333rem;min-height:2.93333rem;transition:none;vertical-align:middle;-webkit-box-shadow:none;box-shadow:none;display:flex;align-items:center;align-content:center;justify-content:center;box-sizing:border-box;min-width:2.93333rem;height:2.93333rem;border:0 !important;border-radius:0 !important;line-height:inherit;padding-left:0;padding-right:0;box-shadow:none;background:none;outline:none;cursor:pointer;&:disabled{opacity:0.3;cursor:default;pointer-events:none;}&:focus{outline:none;transition:none;}&:hover{box-shadow:none;transition:none;}&:link,&:visited{box-shadow:none;background:none;outline:none;color:var(--px-btn-bare-color,#2c404c);}&:hover,&:focus{background-color:transparent;}&:active{background-color:var(--px-btn-background-color--pressed,rgba(0,0,0,0.23));}}']);
  Navbar.defaultProps = {
    className: 'px-navbar'
  };

  var NavbarInner = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar__NavbarInner'
  })(['box-sizing:border-box;white-space:nowrap;align-items:center;justify-content:space-between;height:56px;padding:0.33333rem;display:flex;overflow:hidden;']);

  var NavbarCenter = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar__NavbarCenter'
  })(['order:2;flex:1 0 auto;align-self:center;margin-left:0.33333rem;']);

  var NavbarLeft = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar__NavbarLeft'
  })(['order:0;align-self:center;display:flex;align-content:center;']);

  var NavbarRight = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar__NavbarRight'
  })(['order:3;align-self:center;display:flex;align-content:center;']);

  var NavbarTitle = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar__NavbarTitle'
  })(['display:block;margin:0;padding:0;user-select:none;']);

  var NavbarSubTitle = _styledComponents2.default.div.withConfig({
    displayName: 'Navbar__NavbarSubTitle'
  })(['display:block;']);

  var Component = function Component(_ref) {
    var _ref$backButtonLabel = _ref.backButtonLabel,
        backButtonLabel = _ref$backButtonLabel === undefined ? '<' : _ref$backButtonLabel,
        title = _ref.title,
        subtitle = _ref.subtitle,
        onTitleClick = _ref.onTitleClick,
        showBackButton = _ref.showBackButton,
        showMenuButton = _ref.showMenuButton,
        onBackButtonClick = _ref.onBackButtonClick,
        onMenuButtonClick = _ref.onMenuButtonClick,
        iconNameLeft = _ref.iconNameLeft,
        iconNameRight = _ref.iconNameRight,
        iconElementLeft = _ref.iconElementLeft,
        iconElementRight = _ref.iconElementRight,
        onLeftIconButtonClick = _ref.onLeftIconButtonClick,
        onRightIconButtonClick = _ref.onRightIconButtonClick;
    return _react2.default.createElement(
      Navbar,
      null,
      _react2.default.createElement(
        NavbarInner,
        null,
        _react2.default.createElement(
          NavbarLeft,
          null,
          showMenuButton && _react2.default.createElement(
            'button',
            { className: 'navbar__button flex flex--center toggle__menu', onClick: onMenuButtonClick },
            _react2.default.createElement(
              'svg',
              { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
              _react2.default.createElement('path', { d: 'M0 0h24v24h-24z', fill: 'none' }),
              _react2.default.createElement('path', { d: 'M3 18h18v-2h-18v2zm0-5h18v-2h-18v2zm0-7v2h18v-2h-18z' })
            )
          ),
          showBackButton && _react2.default.createElement(
            'button',
            { className: 'navbar__button', onClick: onBackButtonClick },
            backButtonLabel
          ),
          iconNameLeft && _react2.default.createElement(
            'button',
            { onClick: onLeftIconButtonClick },
            _react2.default.createElement(_Icon2.default, { icon: iconNameLeft, size: 22 })
          ),
          iconElementLeft && iconElementLeft
        ),
        _react2.default.createElement(
          NavbarCenter,
          null,
          _react2.default.createElement(
            NavbarTitle,
            { onClick: onTitleClick },
            title
          ),
          _react2.default.createElement(
            NavbarSubTitle,
            null,
            subtitle
          )
        ),
        _react2.default.createElement(
          NavbarRight,
          null,
          iconNameRight && _react2.default.createElement(
            'button',
            { onClick: onRightIconButtonClick },
            _react2.default.createElement(_Icon2.default, { icon: iconNameRight, size: 22 })
          ),
          iconElementRight && iconElementRight
        )
      )
    );
  };

  Component.defaultProps = {
    title: null,
    subtitle: null,
    backButtonLabel: null,
    onTitleClick: null,
    showBackButton: null,
    showMenuButton: null,
    onBackButtonClick: null,
    onMenuButtonClick: null,
    iconNameLeft: null,
    iconNameRight: null,
    iconElementLeft: null,
    iconElementRight: null,
    onLeftIconButtonClick: null,
    onRightIconButtonClick: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    title: _propTypes2.default.string,
    subtitle: _propTypes2.default.string,
    backButtonLabel: _propTypes2.default.string,
    onTitleClick: _propTypes2.default.func,
    showBackButton: _propTypes2.default.bool,
    showMenuButton: _propTypes2.default.bool,
    onBackButtonClick: _propTypes2.default.func,
    onMenuButtonClick: _propTypes2.default.func,
    iconNameLeft: _propTypes2.default.string,
    iconNameRight: _propTypes2.default.string,
    iconElementLeft: _propTypes2.default.node,
    iconElementRight: _propTypes2.default.node,
    onLeftIconButtonClick: _propTypes2.default.func,
    onRightIconButtonClick: _propTypes2.default.func
  } : {};

  Component.displayName = 'Navbar';

  exports.default = Component;
});