(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components', '../IconSet/Icon'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'), require('../IconSet/Icon'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents, global.Icon);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents, _Icon) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Icon2 = _interopRequireDefault(_Icon);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _templateObject = _taggedTemplateLiteral(['\n  margin-right: 0;\n  margin-left: 1rem;\n  cursor: pointer;\n'], ['\n  margin-right: 0;\n  margin-left: 1rem;\n  cursor: pointer;\n']);

  function _taggedTemplateLiteral(strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  }

  var NotificationIcon = _styledComponents2.default.div.withConfig({
    displayName: 'Notification__NotificationIcon'
  })(['color:white;width:1.06667rem;height:1.06667rem;--iron-icon-width:100%;--iron-icon-height:100%;']);
  var NotificationLeft = _styledComponents2.default.div.withConfig({
    displayName: 'Notification__NotificationLeft'
  })(['flex:0 0 auto;display:flex;align-items:center;margin-right:.33333rem;']);
  var NotificationRight = NotificationLeft.extend(_templateObject);
  var NotificationContent = _styledComponents2.default.div.withConfig({
    displayName: 'Notification__NotificationContent'
  })(['flex:1 1 auto;display:flex;align-items:center;min-width:0;margin-top:0.66667rem;margin-bottom:0.66667rem;']);
  var Notification = _styledComponents2.default.div.withConfig({
    displayName: 'Notification'
  })(['display:flex;align-items:center;padding-left:1rem;padding-right:1rem;width:inherit;opacity:0;height:0;transition:var(--px-notification-transition,height .3s ease-in-out,opacity .3s ease-in-out);box-sizing:border-box;font-size:1rem;', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.type === 'error' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--error,yellow);color:var(--px-alert-label-text-color--error,black);']);
  }, function (props) {
    return props.type === 'important' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--important,red);color:var(--px-alert-label-text-color--important,white);']);
  }, function (props) {
    return props.type === 'warning' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--warning,orange);color:var(--px-alert-label-text-color--warning,white);']);
  }, function (props) {
    return props.type === 'info' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--information,blue);color:var(--px-alert-label-text-color--information,white);']);
  }, function (props) {
    return props.type === 'healthy' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--healthy,green);color:var(--px-alert-label-text-color--healthy,white);']);
  }, function (props) {
    return props.type === 'unknown' && (0, _styledComponents.css)(['background-color:var(--px-alert-label-background-color--unknown,gray);color:var(--px-alert-label-text-color--unknown,white);']);
  }, function (props) {
    return props.opened && (0, _styledComponents.css)(['opacity:1;height:var(--px-notification-height,5.33333rem);@media screen and (min-width:45em){height:var(--px-notification-height,2.66667rem);}']);
  }, function (props) {
    return props.small && (0, _styledComponents.css)(['font-size:0.8rem !important;height:var(--px-notification-height,2.66667rem) !important;@media screen and (min-width:45em){height:var(--px-notification-height,1.33333rem) !important;}']);
  });

  var Component = function Component(_ref) {
    var opened = _ref.opened,
        type = _ref.type,
        actionIcon = _ref.actionIcon,
        statusIcon = _ref.statusIcon,
        slotRight = _ref.slotRight,
        onClick = _ref.onClick,
        small = _ref.small,
        children = _ref.children;
    return _react2.default.createElement(
      Notification,
      { opened: opened, type: type, small: small },
      statusIcon && _react2.default.createElement(
        NotificationLeft,
        null,
        _react2.default.createElement(_Icon2.default, { size: 16, icon: statusIcon })
      ),
      _react2.default.createElement(
        NotificationContent,
        null,
        children
      ),
      _react2.default.createElement(
        NotificationRight,
        null,
        slotRight && slotRight,
        actionIcon && _react2.default.createElement(
          NotificationIcon,
          { onClick: onClick },
          _react2.default.createElement(_Icon2.default, { size: 16, viewBox: '0 0 22 22', icon: actionIcon })
        )
      )
    );
  };

  Component.defaultProps = {
    opened: false,
    type: 'info',
    actionIcon: null,
    statusIcon: null,
    slotRight: null,
    onClick: null,
    small: false,
    children: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    opened: _propTypes2.default.bool,
    type: _propTypes2.default.string,
    actionIcon: _propTypes2.default.string,
    statusIcon: _propTypes2.default.string,
    slotRight: _propTypes2.default.node,
    onClick: _propTypes2.default.func,
    small: _propTypes2.default.bool,
    children: _propTypes2.default.node
  } : {};

  exports.default = Component;
});