(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Panel = _styledComponents2.default.div.withConfig({
    displayName: 'Panel'
  })(['overflow:hidden;display:block;position:absolute;z-index:var(--px-panel-z-index,100);box-shadow:var(--px-panel-box-shadow,-1px -1px 3px rgba(0,0,0,0.2),1px  1px 3px rgba(0,0,0,0.2));background:var(--px-panel-background-color,white);border:var(--px-panel-border,none);transition:var(--px-panel-transition,none);', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.background === 'light' && (0, _styledComponents.css)(['background:var(--px-panel-bg-color--light,#fff);']);
  }, function (props) {
    return props.background === 'medium' && (0, _styledComponents.css)(['background:var(--px-panel-bg-color--medium,#eee);']);
  }, function (props) {
    return props.background === 'dark' && (0, _styledComponents.css)(['background:var(--px-panel-bg-color--dark,#ddd);']);
  }, function (props) {
    return props.light && (0, _styledComponents.css)(['position:fixed;']);
  }, function (props) {
    return props.fixed && (0, _styledComponents.css)(['position:fixed;']);
  }, function (props) {
    return props.minimizable && (0, _styledComponents.css)(['width:var(--px-panel-size--minimized,4rem);']);
  }, function (props) {
    return props.persistent && (0, _styledComponents.css)(['position:relative;flex:0 1 320px;']);
  }, function (props) {
    return (props.position === 'left' || props.position === 'right') && (0, _styledComponents.css)(['height:auto;width:0;top:0;bottom:0;transition:var(--px-panel-transition,width 0.4s cubic-bezier(.78,.13,.16,.87));white-space:nowrap;', ''], props.opened && (0, _styledComponents.css)(['width:var(--px-panel-size,320px);overflow-y:auto;', ''], props.fullSize && (0, _styledComponents.css)(['width:100%;overflow-y:auto;'])));
  }, function (props) {
    return props.position === 'left' && (0, _styledComponents.css)(['left:0;border-right:1px solid var(--px-panel-border-color,gray);', ''], props.floating && (0, _styledComponents.css)(['border-right:none;left:var(--px-panel-offset--left,2rem);top:var(--px-panel-offset--top,2rem);bottom:var(--px-panel-offset--bottom,2rem);']));
  }, function (props) {
    return props.position === 'right' && (0, _styledComponents.css)(['right:0;border-left:1px solid var(--px-panel-border-color,gray);', ''], props.floating && (0, _styledComponents.css)(['border-left:none;right:var(--px-panel-offset--right,2rem);top:var(--px-panel-offset--top,2rem);bottom:var(--px-panel-offset--bottom,2rem);']));
  }, function (props) {
    return (props.position === 'top' || props.position === 'bottom') && (0, _styledComponents.css)(['width:auto;height:0;right:0;left:0;transition:var(--px-panel-transition,height 0.4s cubic-bezier(.78,.13,.16,.87));', ''], props.opened && (0, _styledComponents.css)(['height:var(--px-panel-size,320px);overflow-y:auto;']));
  }, function (props) {
    return props.position === 'top' && (0, _styledComponents.css)(['top:0;border-bottom:1px solid var(--px-panel-border-color,gray);', ''], props.fullSize && (0, _styledComponents.css)(['right:var(--px-panel-offset--right,2rem);left:var(--px-panel-offset--left,2rem);top:var(--px-panel-offset--bottom,2rem);']));
  }, function (props) {
    return props.position === 'bottom' && (0, _styledComponents.css)(['bottom:0;border-top:1px solid var(--px-panel-border-color,gray);', ''], props.fullSize && (0, _styledComponents.css)(['right:var(--px-panel-offset--right,2rem);left:var(--px-panel-offset--left,2rem);bottom:var(--px-panel-offset--bottom,2rem);']));
  });

  Panel.displayName = 'Panel';
  Panel.defaultProps = {
    className: 'px-panel'
  };

  var PanelContent = _styledComponents2.default.div.withConfig({
    displayName: 'Panel__PanelContent'
  })(['display:block;', ''], function (props) {
    return props.opened && (0, _styledComponents.css)(['display:block;height:100%;']);
  });
  PanelContent.displayName = 'PanelContent';
  PanelContent.defaultProps = {
    className: 'px-panel-content'
  };

  var Component = function Component(_ref) {
    var style = _ref.style,
        className = _ref.className,
        background = _ref.background,
        position = _ref.position,
        fullSize = _ref.fullSize,
        opened = _ref.opened,
        fixed = _ref.fixed,
        persistent = _ref.persistent,
        floating = _ref.floating,
        minimizable = _ref.minimizable,
        children = _ref.children;
    return _react2.default.createElement(
      Panel,
      {
        persistent: persistent,
        background: background,
        style: style,
        className: className,
        position: position,
        minimizable: minimizable,
        fullSize: fullSize,
        floating: floating,
        opened: opened,
        fixed: fixed
      },
      _react2.default.createElement(
        PanelContent,
        null,
        children
      )
    );
  };

  Component.defaultProps = {
    style: null,
    className: null,
    background: 'light',
    position: 'right',
    fullSize: false,
    opened: false,
    fixed: false,
    persistent: false,
    floating: false,
    minimizable: false,
    children: null
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    style: _propTypes2.default.objectOf(_propTypes2.default.string),
    className: _propTypes2.default.string,
    background: _propTypes2.default.string,
    position: _propTypes2.default.string,
    fullSize: _propTypes2.default.bool,
    opened: _propTypes2.default.bool,
    fixed: _propTypes2.default.bool,
    persistent: _propTypes2.default.bool,
    floating: _propTypes2.default.bool,
    minimizable: _propTypes2.default.bool,
    children: _propTypes2.default.node
  } : {};

  exports.default = Component;
});