(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'react-dom', 'prop-types', 'classnames', 'react-popper', 'styled-components', '../utils'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('react-dom'), require('prop-types'), require('classnames'), require('react-popper'), require('styled-components'), require('../utils'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.reactDom, global.propTypes, global.classnames, global.reactPopper, global.styledComponents, global.utils);
    global.PopperContent = mod.exports;
  }
})(this, function (exports, _react, _reactDom, _propTypes, _classnames, _reactPopper, _styledComponents, _utils) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _reactDom2 = _interopRequireDefault(_reactDom);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _objectWithoutProperties(obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var PopoverInner = _styledComponents2.default.div.withConfig({
    displayName: 'PopperContent__PopoverInner'
  })(['top:0;left:0;z-index:1060;max-width:276px;font-style:normal;font-weight:400;line-height:1.5;text-align:left;text-decoration:none;text-shadow:none;text-transform:none;letter-spacing:normal;word-break:normal;word-spacing:normal;white-space:normal;line-break:auto;font-size:1rem;word-wrap:break-word;background-clip:padding-box;border:1px solid var(--px-popover-border-color,#000);background:var(--px-popover-background-color,#fff);color:var(--px-popover-text-color,#000);box-shadow:0 1px 3px 0 var(--px-popover-shadow-color,#000);position:absolute;display:block;']);

  PopoverInner.displayName = 'PopoverInner';

  var PopperContent = function (_React$Component) {
    _inherits(PopperContent, _React$Component);

    function PopperContent(props) {
      _classCallCheck(this, PopperContent);

      var _this = _possibleConstructorReturn(this, (PopperContent.__proto__ || Object.getPrototypeOf(PopperContent)).call(this, props));

      _this.handlePlacementChange = _this.handlePlacementChange.bind(_this);
      _this.setTargetNode = _this.setTargetNode.bind(_this);
      _this.getTargetNode = _this.getTargetNode.bind(_this);
      _this.state = {};
      return _this;
    }

    _createClass(PopperContent, [{
      key: 'getChildContext',
      value: function getChildContext() {
        return {
          popperManager: {
            setTargetNode: this.setTargetNode,
            getTargetNode: this.getTargetNode
          }
        };
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.handleProps();
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate(prevProps) {
        if (this.props.isOpen !== prevProps.isOpen) {
          this.handleProps();
        } else if (this._element) {
          this.renderIntoSubtree();
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.hide();
      }
    }, {
      key: 'setTargetNode',
      value: function setTargetNode(node) {
        this.targetNode = node;
      }
    }, {
      key: 'getTargetNode',
      value: function getTargetNode() {
        return this.targetNode;
      }
    }, {
      key: 'getContainerNode',
      value: function getContainerNode() {
        return (0, _utils.getTarget)(this.props.container);
      }
    }, {
      key: 'handlePlacementChange',
      value: function handlePlacementChange(data) {
        if (this.state.placement !== data.placement) {
          this.setState({ placement: data.placement });
        }
        return data;
      }
    }, {
      key: 'handleProps',
      value: function handleProps() {
        if (this.props.container !== 'inline') {
          if (this.props.isOpen) {
            this.show();
          } else {
            this.hide();
          }
        }
      }
    }, {
      key: 'hide',
      value: function hide() {
        if (this._element) {
          this.getContainerNode().removeChild(this._element);
          _reactDom2.default.unmountComponentAtNode(this._element);
          this._element = null;
        }
      }
    }, {
      key: 'show',
      value: function show() {
        this._element = document.createElement('div');
        this.getContainerNode().appendChild(this._element);
        this.renderIntoSubtree();
        if (this._element.childNodes && this._element.childNodes[0] && this._element.childNodes[0].focus) {
          this._element.childNodes[0].focus();
        }
      }
    }, {
      key: 'renderIntoSubtree',
      value: function renderIntoSubtree() {
        _reactDom2.default.unstable_renderSubtreeIntoContainer(this, this.renderChildren(), this._element);
      }
    }, {
      key: 'renderChildren',
      value: function renderChildren() {
        var _props = this.props,
            cssModule = _props.cssModule,
            children = _props.children,
            isOpen = _props.isOpen,
            flip = _props.flip,
            target = _props.target,
            offset = _props.offset,
            fallbackPlacement = _props.fallbackPlacement,
            placementPrefix = _props.placementPrefix,
            hideArrow = _props.hideArrow,
            className = _props.className,
            tag = _props.tag,
            container = _props.container,
            modifiers = _props.modifiers,
            attrs = _objectWithoutProperties(_props, ['cssModule', 'children', 'isOpen', 'flip', 'target', 'offset', 'fallbackPlacement', 'placementPrefix', 'hideArrow', 'className', 'tag', 'container', 'modifiers']);

        var arrowClassName = (0, _utils.mapToCssModules)('arrow', cssModule);
        var placement = (this.state.placement || attrs.placement).split('-')[0];
        var popperClassName = (0, _utils.mapToCssModules)((0, _classnames2.default)(className, placementPrefix ? placementPrefix + '-' + placement : placement), this.props.cssModule);

        var extendedModifiers = _extends({
          offset: { offset: offset },
          flip: { enabled: flip, behavior: fallbackPlacement },
          update: {
            enabled: true,
            order: 950,
            fn: this.handlePlacementChange
          }
        }, modifiers);

        return _react2.default.createElement(
          _reactPopper.Popper,
          _extends({
            modifiers: extendedModifiers
          }, attrs, {
            component: tag,
            className: popperClassName
          }),
          children,
          !hideArrow && _react2.default.createElement(_reactPopper.Arrow, { className: arrowClassName })
        );
      }
    }, {
      key: 'render',
      value: function render() {
        this.setTargetNode((0, _utils.getTarget)(this.props.target));
        if (this.props.container === 'inline') {
          return this.props.isOpen ? this.renderChildren() : null;
        }

        return null;
      }
    }]);

    return PopperContent;
  }(_react2.default.Component);

  PopperContent.childContextTypes = {
    popperManager: _propTypes2.default.object.isRequired
  };

  PopperContent.defaultProps = {
    placement: 'auto',
    hideArrow: false,
    isOpen: false,
    offset: 0,
    fallbackPlacement: 'flip',
    flip: true,
    container: 'body',
    modifiers: {},
    cssModule: {},
    children: null,
    placementPrefix: null,
    tag: 'div',
    target: null,
    className: null
  };

  PopperContent.propTypes = process.env.NODE_ENV !== "production" ? {
    placement: _propTypes2.default.oneOf(['auto-start', 'auto', 'auto-end', 'top-start', 'top', 'top-end', 'right-start', 'right', 'right-end', 'bottom-end', 'bottom', 'bottom-start', 'left-end', 'left', 'left-start']),
    hideArrow: _propTypes2.default.bool,
    isOpen: _propTypes2.default.bool,
    offset: _propTypes2.default.number,
    fallbackPlacement: _propTypes2.default.string,
    flip: _propTypes2.default.bool,
    placementPrefix: _propTypes2.default.string,
    className: _propTypes2.default.string,
    container: _propTypes2.default.string,
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
    tag: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),
    target: _propTypes2.default.oneOfType([_propTypes2.default.instanceOf(Element), _reactPopper.Popper]),
    cssModule: _propTypes2.default.objectOf(_propTypes2.default.string),
    modifiers: _propTypes2.default.objectOf(_propTypes2.default.string)
  } : {};

  exports.default = PopperContent;
});