(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'prop-types', '../utils'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('prop-types'), require('../utils'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.propTypes, global.utils);
    global.PopperTargetHelper = mod.exports;
  }
})(this, function (exports, _propTypes, _utils) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _propTypes2 = _interopRequireDefault(_propTypes);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var PopperTargetHelper = function PopperTargetHelper(props, context) {
    context.popperManager.setTargetNode((0, _utils.getTarget)(props.target));
    return null;
  };

  PopperTargetHelper.contextTypes = {
    popperManager: _propTypes2.default.object.isRequired
  };

  PopperTargetHelper.propTypes = {
    target: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func, _utils.DOMElement]).isRequired
  };
  exports.default = PopperTargetHelper;
});