(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var ProgressAnimation = (0, _styledComponents.keyframes)(['0%{left:0;right:100%;transform:scaleX(0);}50%{left:0;right:0;transform:scaleX(1);}100%{left:100%;right:0;transform:scaleX(0);}']);

  var _computeRatio = function _computeRatio(v) {
    return v < 0 ? 0 : v > 100 ? 1 : v / 100;
  };

  var ProgressFill = _styledComponents2.default.div.withConfig({
    displayName: 'ProgressBar__ProgressFill'
  })(['background-color:var(--px-progress-bar-fill-color,black);height:var(--px-progress-bar-height,5px);transition:transform 1s cubic-bezier(.78,.13,.16,.87);-webkit-transform-origin:left center;transform-origin:left center;-webkit-transform:scaleX(0);transform:scaleX(0);overflow:hidden;', ' ', ''], function (props) {
    return props.value && (0, _styledComponents.css)(['transform:scaleX(', ');'], _computeRatio(props.value));
  }, function (props) {
    return props.infinite && (0, _styledComponents.css)(['position:relative;animation:', ' 2s cubic-bezier(.78,.13,.16,.87) infinite;'], ProgressAnimation);
  });
  var ProgressBackground = _styledComponents2.default.div.withConfig({
    displayName: 'ProgressBar__ProgressBackground'
  })(['background-color:var(--px-progress-bar-background-color,lightgray);height:var(--px-progress-bar-height,5px);']);

  var ProgressBar = _styledComponents2.default.div.withConfig({
    displayName: 'ProgressBar'
  })(['height:var(--px-progress-bar-height,5px);']);

  var Component = function Component(_ref) {
    var value = _ref.value,
        max = _ref.max,
        min = _ref.min,
        infinite = _ref.infinite;
    return _react2.default.createElement(
      'div',
      { 'aria-valuemin': min, 'aria-valuemax': max },
      _react2.default.createElement(
        ProgressBar,
        null,
        _react2.default.createElement(
          ProgressBackground,
          null,
          _react2.default.createElement(ProgressFill, { value: value, infinite: infinite })
        )
      )
    );
  };

  Component.defaultProps = {
    value: 0,
    max: 100,
    min: 0,
    infinite: false
  };
  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    value: _propTypes2.default.number,
    max: _propTypes2.default.number,
    min: _propTypes2.default.number,
    infinite: _propTypes2.default.bool
  } : {};

  exports.default = Component;
});