(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var SpinnerRotateAnimation = (0, _styledComponents.keyframes)(['to{stroke-dashoffset:0;}']);


  var SpinnerCircle1 = _styledComponents2.default.circle.withConfig({
    displayName: 'Spinner__SpinnerCircle1'
  })(['fill:none;stroke:var(--px-spinner-background-color,gray);stroke-width:5px;']);

  var SpinnerCircle2 = _styledComponents2.default.circle.withConfig({
    displayName: 'Spinner__SpinnerCircle2'
  })(['fill:none;stroke:var(--px-spinner-fill-color,black);stroke-width:5px;stroke-dasharray:283;stroke-dashoffset:566;animation:', ' 1.5s infinite cubic-bezier(0.78,0.13,0.16,0.87);'], SpinnerRotateAnimation);

  var Component = function Component(_ref) {
    var size = _ref.size,
        finished = _ref.finished;
    return _react2.default.createElement(
      'div',
      null,
      !finished && _react2.default.createElement(
        'svg',
        { viewBox: '0 0 100 100', height: size, width: size },
        _react2.default.createElement(SpinnerCircle1, { cx: '50', cy: '50', r: '45' }),
        _react2.default.createElement(SpinnerCircle2, { cx: '50', cy: '50', r: '45', transform: 'rotate(-45,50,50)' })
      )
    );
  };

  Component.defaultProps = {
    size: 100,
    finished: false
  };

  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    size: _propTypes2.default.number,
    finished: _propTypes2.default.bool
  } : {};

  Component.displayName = 'Spinner';

  exports.default = Component;
});