(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components', '../IconSet/Icon'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'), require('../IconSet/Icon'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents, global.Icon);
    global.TableRow = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents, _Icon) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Icon2 = _interopRequireDefault(_Icon);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var TableRow = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow'
  })(['user-select:none;min-height:var(--px-table-row-min-height,2.93333rem);line-height:var(--px-table-row-line-height,15px);color:var(--px-table-row-color,inherit);font-size:var(--px-table-row-font-size,15px);background-color:var(--px-table-row-background-color,white);border-bottom-width:var(--px-table-row-separator-width,1px);border-bottom-style:var(--px-table-row-separator-style,solid);border-bottom-color:var(--px-table-row-separator-color,black);user-select:none;align-items:center;box-sizing:border-box;position:relative;overflow:hidden;display:flex;flex-direction:row;appearance:normal;flex:1;&:after,&:before{display:table;content:\' \';}', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.tappable && (0, _styledComponents.css)(['cursor:pointer;&:active{color:var(--px-table-row-selected-color,white) !important;background:var(--px-table-row-selected-background-color,black);}']);
  }, function (props) {
    return props.selected && (0, _styledComponents.css)(['background-color:var(--px-table-row-selected-background-color,black) !important;color:var(--px-table-row-selected-color,white) !important;.px-table-row-body{color:inherit;}']);
  }, function (props) {
    return props.header && (0, _styledComponents.css)(['padding:var(--px-table-row-header-padding,0.33333rem);font-size:var(--px-table-row-header-font-size,15px);color:var(--px-table-row-header-color,inherit);background-color:var(--px-table-row-header-background-color,black);text-transform:var(--px-table-row-header-text-transform,uppercase);min-height:var(--px-table-row-header-min-height,24px);line-height:var(--px-table-row-header-line-height,24px);border-top:none;border-bottom:none;']);
  }, function (props) {
    return props.swipeable && (0, _styledComponents.css)(['background-color:var(--px-table-row-background-color,white);overflow:hidden;transform-style:preserve-3d;transition:transform cubic-bezier(0.55,0,0.1,1) 0.3s;z-index:10;']);
  }, function (props) {
    return props.size === 'flush' && (0, _styledComponents.css)(['padding:0;']);
  }, function (props) {
    return props.size === 'tiny' && (0, _styledComponents.css)(['padding:0.33333rem;']);
  }, function (props) {
    return props.size === 'small' && (0, _styledComponents.css)(['padding:0.66667rem;']);
  }, function (props) {
    return props.size === 'regular' && (0, _styledComponents.css)(['padding:1rem;']);
  }, function (props) {
    return props.size === 'large' && (0, _styledComponents.css)(['padding:1.33333rem;']);
  }, function (props) {
    return props.size === 'huge' && (0, _styledComponents.css)(['padding:2rem;']);
  });
  TableRow.displayName = 'TableRow';

  var TableRowTitle = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowTitle'
  })(['user-select:none;line-height:normal;flex:1 0 auto;align-items:center;align-self:stretch;display:flex;white-space:nowrap;font-size:var(--px-table-row-title-font-size,15px);color:var(--px-table-row-title-color,inherit);']);
  TableRowTitle.displayName = 'TableRowTitle';

  var TableRowBody = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowBody'
  })(['font-size:var(--px-table-row-body-font-size,15px);order:5;align-self:stretch;flex:1 0 auto;white-space:normal;line-height:normal;']);
  TableRowBody.displayName = 'TableRowBody';

  var TableRowMedia = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowMedia'
  })(['flex:0 1 auto;order:0;display:flex;align-self:stretch;justify-content:center;align-content:center;flex-direction:column;margin-left:var(--px-table-row-media-margin,0);margin-right:var(--px-table-row-media-margin,0.66667rem);img{display:block;max-width:80px;max-height:80px;}']);
  TableRowMedia.displayName = 'TableRowMedia';

  var TableRowLabel = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowLabel'
  })(['-webkit-touch-callout:none;user-select:none;order:0;align-self:center;white-space:nowrap;position:relative;top:2px;', ' ', ''], function (props) {
    return props.labelLeft && (0, _styledComponents.css)(['flex:0 1 0;text-align:right;']);
  }, function (props) {
    return props.labelRight && (0, _styledComponents.css)(['text-align:left;order:4;']);
  });
  TableRowLabel.displayName = 'TableRowLabel';

  var TableRowSubtitle = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowSubtitle'
  })(['font-size:var(--px-table-row-subtitle-font-size,15px);color:var(--px-table-row-subtitle-color,black);']);

  var TableRowContent = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowContent'
  })(['user-select:none;display:flex;flex-direction:column;align-self:stretch;flex:1;user-select:none;']);
  TableRowContent.displayName = 'TableRowContent';

  var TableRowActions = _styledComponents2.default.div.withConfig({
    displayName: 'TableRow__TableRowActions'
  })(['overflow:hidden;transform-style:preserve-3d;position:absolute;top:0;bottom:0;display:flex;flex-direction:row;justify-content:space-between;width:auto;align-self:stretch;align-items:stretch;', ' ', ''], function (props) {
    return props.opened && (0, _styledComponents.css)(['z-index:50;']);
  }, function (props) {
    return props.actionsLeft && (0, _styledComponents.css)(['order:0;left:0;', ''], props.opened && (0, _styledComponents.css)(['width:auto;transform:translateX(0%);']));
  });

  var TableRowComponent = function TableRowComponent(_ref) {
    var title = _ref.title,
        subtitle = _ref.subtitle,
        body = _ref.body,
        image = _ref.image,
        icon = _ref.icon,
        selected = _ref.selected,
        labelLeft = _ref.labelLeft,
        labelRight = _ref.labelRight,
        editMode = _ref.editMode,
        size = _ref.size,
        tappable = _ref.tappable,
        swipeable = _ref.swipeable,
        header = _ref.header,
        underlayContent = _ref.underlayContent,
        rowContent = _ref.rowContent,
        actions = _ref.actions,
        children = _ref.children;
    return _react2.default.createElement(
      TableRow,
      {
        className: 'px-table-row',
        size: size,
        tappable: tappable,
        selected: selected,
        swipeable: swipeable,
        header: header
      },
      labelLeft && _react2.default.createElement(
        TableRowLabel,
        { labelLeft: true, className: 'table-row__label table-row__label--left' },
        labelLeft
      ),
      image && _react2.default.createElement(
        TableRowMedia,
        null,
        _react2.default.createElement('img', { src: image, alt: title })
      ),
      icon && _react2.default.createElement(
        TableRowMedia,
        null,
        _react2.default.createElement(_Icon2.default, { icon: icon })
      ),
      editMode && _react2.default.createElement(
        'div',
        { className: 'table-row__media table-row__media--icon table-row__media--right' },
        _react2.default.createElement(
          'button',
          { className: 'btn btn--bare table-row__handle' },
          'hamburger'
        )
      ),
      title && _react2.default.createElement(
        TableRowContent,
        null,
        title && _react2.default.createElement(
          TableRowTitle,
          null,
          title
        ),
        subtitle && _react2.default.createElement(
          TableRowSubtitle,
          null,
          subtitle
        ),
        body && _react2.default.createElement(
          TableRowBody,
          null,
          body
        ),
        rowContent
      ),
      labelRight && _react2.default.createElement(
        TableRowLabel,
        { labelRight: true, className: 'table-row__label table-row__label--right' },
        labelRight
      ),
      children && _react2.default.createElement(
        TableRowContent,
        null,
        children
      ),
      actions && _react2.default.createElement(
        TableRowActions,
        null,
        actions
      ),
      _react2.default.createElement(
        'div',
        { id: 'underlay', className: 'flex flex--stretch' },
        underlayContent
      )
    );
  };

  TableRowComponent.propTypes = process.env.NODE_ENV !== "production" ? {
    tappable: _propTypes2.default.bool,
    swipeable: _propTypes2.default.bool,
    selected: _propTypes2.default.bool,
    header: _propTypes2.default.bool,
    editMode: _propTypes2.default.bool,
    size: _propTypes2.default.string,
    title: _propTypes2.default.string,
    subtitle: _propTypes2.default.string,
    icon: _propTypes2.default.string,
    image: _propTypes2.default.string,
    body: _propTypes2.default.string,
    labelLeft: _propTypes2.default.string,
    labelRight: _propTypes2.default.string,
    children: _propTypes2.default.node,
    actions: _propTypes2.default.node,
    underlayContent: _propTypes2.default.node,
    rowContent: _propTypes2.default.node
  } : {};

  TableRowComponent.defaultProps = {
    tappable: null,
    swipeable: null,
    selected: null,
    editMode: null,
    header: null,
    image: null,
    size: null,
    title: null,
    subtitle: null,
    body: null,
    icon: null,
    children: null,
    labelLeft: null,
    labelRight: null,
    actions: null,
    underlayContent: null,
    rowContent: null
  };

  exports.default = TableRowComponent;
});