(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'prop-types', 'react', 'styled-components', './TableRow'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('prop-types'), require('react'), require('styled-components'), require('./TableRow'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.propTypes, global.react, global.styledComponents, global.TableRow);
    global.index = mod.exports;
  }
})(this, function (exports, _propTypes, _react, _styledComponents, _TableRow) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _react2 = _interopRequireDefault(_react);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _TableRow2 = _interopRequireDefault(_TableRow);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var TableView = _styledComponents2.default.ul.withConfig({
    displayName: 'TableView'
  })(['margin:0;padding:0;list-style:none;.px-table-row{', ' ', ' ', ' ', ' ', '}'], function (props) {
    return props.size === 'flush' && (0, _styledComponents.css)(['padding:0 !important;']);
  }, function (props) {
    return props.size === 'tiny' && (0, _styledComponents.css)(['padding:0.33333rem !important;']);
  }, function (props) {
    return props.size === 'small' && (0, _styledComponents.css)(['padding:0.66667rem !important;']);
  }, function (props) {
    return props.size === 'large' && (0, _styledComponents.css)(['padding:1.33333rem !important;']);
  }, function (props) {
    return props.size === 'huge' && (0, _styledComponents.css)(['padding:2rem !important;']);
  });

  var TableViewComponent = function TableViewComponent(_ref) {
    var items = _ref.items,
        tappable = _ref.tappable,
        size = _ref.size,
        onSelect = _ref.onSelect,
        children = _ref.children;
    return _react2.default.createElement(
      TableView,
      { size: size },
      children,
      items && items.map(function (item) {
        return _react2.default.createElement(_TableRow2.default, _extends({
          tappable: tappable,
          size: size,
          key: item.id
        }, item, {
          onClick: onSelect
        }));
      })
    );
  };

  TableViewComponent.propTypes = process.env.NODE_ENV !== "production" ? {
    tappable: _propTypes2.default.bool,
    size: _propTypes2.default.string,
    onSelect: _propTypes2.default.func,
    children: _propTypes2.default.node,
    items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      id: _propTypes2.default.string,
      title: _propTypes2.default.string,
      icon: _propTypes2.default.string,
      body: _propTypes2.default.string
    }))
  } : {};

  TableViewComponent.defaultProps = {
    tappable: null,
    size: null,
    onSelect: null,
    children: null,
    items: null
  };

  exports.default = TableViewComponent;
});