(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'classnames', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('classnames'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.classnames, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _classnames, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _classnames2 = _interopRequireDefault(_classnames);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var TabsContainer = _styledComponents2.default.div.withConfig({
    displayName: 'Tabs__TabsContainer'
  })(['color:var(--px-tabs-color,black);border:0;padding:0;&:focus{outline:var(--px-tab-outline-style,none);}']);
  TabsContainer.displayName = 'TabsContainer';

  var TabsContainerNav = _styledComponents2.default.ul.withConfig({
    displayName: 'Tabs__TabsContainerNav'
  })(['font:inherit;margin:0;border-bottom:1px solid var(--px-tab-border-color,gray);padding:0 1rem 0;display:flex;']);
  TabsContainerNav.displayName = 'TabsContainerNav';

  var TabTitle = _styledComponents2.default.span.withConfig({
    displayName: 'Tabs__TabTitle'
  })(['color:var(--px-tab-color,black);cursor:pointer;text-decoration:none;user-select:none;&:hover{color:var(--px-tab-color--hover,black);}&:active{color:var(--px-tab-color--active,black);}']);

  TabTitle.displayName = 'TabTitle';

  var TabItem = _styledComponents2.default.li.withConfig({
    displayName: 'Tabs__TabItem'
  })(['list-style-type:none;line-height:1.3;font:inherit;text-align:center;vertical-align:middle;padding-bottom:10px;margin:1px 20px 0 0;color:var(--px-tab-color,black);', ''], function (props) {
    return props.active && (0, _styledComponents.css)(['color:var(--px-tab-color--selected,black);border-bottom:2px solid var(--px-tab-color--selected,black);font-weight:bold;']);
  });

  var Tabs = function (_React$Component) {
    _inherits(Tabs, _React$Component);

    function Tabs(props) {
      _classCallCheck(this, Tabs);

      var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

      _this.state = {
        selected: props.selected || 0
      };

      _this._items = [];
      _this._keys = [];
      return _this;
    }

    _createClass(Tabs, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.selected !== undefined) {
          var selected = this._getIndexForValue(nextProps.selected);
          this.setState({
            selected: selected
          });
        }
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(nextProps, nextState) {
        if (nextProps.selected !== this.props.selected || nextState.selected !== this.state.selected) {
          return true;
        }
        return false;
      }
    }, {
      key: '_getIndexForValue',
      value: function _getIndexForValue(val) {
        var index = this._keys.indexOf(val);
        return index;
      }
    }, {
      key: '_getValueForIndex',
      value: function _getValueForIndex(index) {
        var val = this._keys[index];
        return val;
      }
    }, {
      key: 'handleClick',
      value: function handleClick(i, event) {
        var index = this._getIndexForValue(i);

        this.setState({
          selected: index
        });
        if (this.props.onChange) {
          this.props.onChange(i, event);
        }
      }
    }, {
      key: '_renderTitles',
      value: function _renderTitles() {
        this._keys = [];

        function labels(child, index) {
          var propForSelect = index;
          this._items[index] = child;
          if (this.props.propForSelect) {
            propForSelect = child.props[this.props.propForSelect];
          }
          this._keys[index] = propForSelect;
          var selected = this.state.selected === (this.props.propForSelect ? this._getIndexForValue(propForSelect) : index);
          var baseClasses = (0, _classnames2.default)({ 'iron-selected': selected });
          return _react2.default.createElement(
            TabItem,
            {
              key: index,
              className: baseClasses,
              active: selected,
              'aria-controls': 'panel-' + index,
              role: 'tab'
            },
            _react2.default.createElement(
              TabTitle,
              _extends({}, child.props, {
                onClick: this.handleClick.bind(this, propForSelect) }),
              child.props.label
            )
          );
        }

        var children = this.props.children;

        return _react2.default.Children.map(children, labels.bind(this));
      }
    }, {
      key: '_renderContent',
      value: function _renderContent() {
        return this.props.children && this.props.children[this.state.selected];
      }
    }, {
      key: 'render',
      value: function render() {
        var style = this.props.style;

        return _react2.default.createElement(
          TabsContainer,
          { style: style, className: 'px-tabs__container' },
          _react2.default.createElement(
            TabsContainerNav,
            { className: 'px-tabs__nav', role: 'tablist' },
            this._renderTitles()
          ),
          this._renderContent()
        );
      }
    }]);

    return Tabs;
  }(_react2.default.Component);

  Tabs.defaultProps = {
    selected: 0,
    onChange: null,
    style: null,
    children: null,
    propForSelect: null
  };

  Tabs.propTypes = process.env.NODE_ENV !== "production" ? {
    selected: _propTypes2.default.number,
    onChange: _propTypes2.default.func,
    style: _propTypes2.default.objectOf(_propTypes2.default.string),
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
    propForSelect: _propTypes2.default.string
  } : {};

  Tabs.displayName = 'Tabs';

  exports.default = Tabs;
});