(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Tile = _styledComponents2.default.div.withConfig({
    displayName: 'Tile'
  })(['max-width:var(--px-tile-width,20rem);max-height:var(--px-tile-height,20rem);']);

  var TileContainer = _styledComponents2.default.div.withConfig({
    displayName: 'Tile__TileContainer'
  })(['position:relative;width:var(--px-tile-width,20rem);max-width:var(--px-tile-width,20rem);max-height:var(--px-tile-height,20rem);overflow:hidden;']);

  var TileOverlay = _styledComponents2.default.div.withConfig({
    displayName: 'Tile__TileOverlay'
  })(['max-width:var(--px-tile-width,20rem);max-height:var(--px-tile-height,20rem);position:absolute;top:0;background-color:var(--px-tile-overlay-background-color,black);color:var(--px-tile-overlay-text-color,white);opacity:0;transition:opacity 0.4s cubic-bezier(0.78,0.13,0.16,0.87);display:flex;flex-direction:column;justify-content:space-between;']);
  var TileTitle = _styledComponents2.default.div.withConfig({
    displayName: 'Tile__TileTitle'
  })(['']);
  var TileSubTitle = _styledComponents2.default.div.withConfig({
    displayName: 'Tile__TileSubTitle'
  })(['']);
  var TileThumbnail = _styledComponents2.default.div.withConfig({
    displayName: 'Tile__TileThumbnail'
  })(['width:var(--px-tile-thumbnail-width,100%);height:var(--px-tile-thumbnail-height,11.66667rem);background-color:var(--px-tile-thumbnail-background-color,white);']);

  var Component = function Component(_ref) {
    var title = _ref.title,
        subtitle = _ref.subtitle,
        description = _ref.description,
        overlayDescription = _ref.overlayDescription,
        image = _ref.image,
        className = _ref.className,
        actionButtons = _ref.actionButtons,
        children = _ref.children;
    return _react2.default.createElement(
      Tile,
      { className: className },
      _react2.default.createElement(
        TileContainer,
        { className: 'tile__container' },
        image && _react2.default.createElement(
          TileThumbnail,
          null,
          _react2.default.createElement('img', { src: image, alt: title })
        ),
        title && _react2.default.createElement(
          TileTitle,
          null,
          title
        ),
        subtitle && _react2.default.createElement(
          TileSubTitle,
          null,
          subtitle
        ),
        _react2.default.createElement(
          TileOverlay,
          { id: 'overlay', className: 'overlay' },
          _react2.default.createElement(
            'header',
            { className: 'title epsilon' },
            _react2.default.createElement(
              'span',
              { className: 'title-span truncate' },
              title
            )
          ),
          _react2.default.createElement(
            'section',
            { className: 'text' },
            overlayDescription && overlayDescription,
            description && description,
            children && children
          ),
          actionButtons && _react2.default.createElement(
            'footer',
            { className: 'footer' },
            actionButtons
          )
        )
      )
    );
  };

  Component.defaultProps = {
    title: null,
    subtitle: null,
    description: null,
    overlayDescription: null,
    image: null,
    className: null,
    actionButtons: null,
    children: null
  };
  Component.propTypes = process.env.NODE_ENV !== "production" ? {
    title: _propTypes2.default.string,
    subtitle: _propTypes2.default.string,
    description: _propTypes2.default.string,
    overlayDescription: _propTypes2.default.string,
    image: _propTypes2.default.string,
    className: _propTypes2.default.string,
    actionButtons: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
  } : {};

  exports.default = Component;
});