(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components', '../IconSet/Icon'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'), require('../IconSet/Icon'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents, global.Icon);
    global.TreeNode = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents, _Icon) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _Icon2 = _interopRequireDefault(_Icon);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var TreeNodeStyled = _styledComponents2.default.li.withConfig({
    displayName: 'TreeNode__TreeNodeStyled'
  })(['list-style:none;padding:0;margin:0;line-height:1.8rem;user-select:none;']);
  TreeNodeStyled.displayName = 'TreeNode';

  var TreeNodeIcon = _styledComponents2.default.span.withConfig({
    displayName: 'TreeNode__TreeNodeIcon'
  })(['align-items:center;display:flex;width:1rem;height:1rem;margin-left:0.25rem;margin-right:0.25rem;']);
  TreeNodeIcon.displayName = 'TreeNodeIcon';

  var TreeNodeContent = _styledComponents2.default.ul.withConfig({
    displayName: 'TreeNode__TreeNodeContent'
  })(['margin:0;list-style:none;padding-left:1.5rem !important;display:none;', ' ', ''], function (props) {
    return props.active && (0, _styledComponents.css)(['display:block;']);
  }, function (props) {
    return props.open && (0, _styledComponents.css)(['display:block;']);
  });
  TreeNodeContent.displayName = 'TreeNodeContent';

  var TreeNodeLabel = _styledComponents2.default.div.withConfig({
    displayName: 'TreeNode__TreeNodeLabel'
  })(['display:flex;align-items:center;cursor:pointer;&:hover{color:var(--px-tree-text-color--hover,black);background-color:var(--px-tree-background-color--hover,lightgray);}', ' ', ' ', ''], function (props) {
    return props.selected && (0, _styledComponents.css)(['color:var(--px-tree-text-color--selected,#fff);background-color:var(--px-tree-background-color--selected,gray);']);
  }, function (props) {
    return props.leaf && (0, _styledComponents.css)(['padding-left:1.75rem;&:hover{color:var(--px-tree-text-color--hover,#000);background-color:var(--px-tree-background-color--hover,#d3d3d3);}']);
  }, function (props) {
    return props.branch && (0, _styledComponents.css)(['padding-left:1.75rem;&:hover{color:var(--px-tree-text-color--hover,#000);background-color:var(--px-tree-background-color--hover,#d3d3d3);}']);
  });
  TreeNodeLabel.displayName = 'TreeNodeLabel';

  var TreeNode = function (_React$Component) {
    _inherits(TreeNode, _React$Component);

    function TreeNode(props) {
      _classCallCheck(this, TreeNode);

      var _this = _possibleConstructorReturn(this, (TreeNode.__proto__ || Object.getPrototypeOf(TreeNode)).call(this, props));

      _this.state = {
        children: [],
        data: props.data,
        selected: props.selected,
        isSelectable: props.isSelectable
      };
      _this.onCategorySelect = _this.onCategorySelect.bind(_this);
      _this.onChildDisplayToggle = _this.onChildDisplayToggle.bind(_this);
      return _this;
    }

    _createClass(TreeNode, [{
      key: 'onCategorySelect',
      value: function onCategorySelect(ev) {
        ev.preventDefault();
        ev.stopPropagation();
        if (this.props.onCategorySelect && !this.state.isSelectable) {
          this.props.onCategorySelect(this);
        }
      }
    }, {
      key: 'onChildDisplayToggle',
      value: function onChildDisplayToggle(ev) {
        if (this.props.data.children) {
          if (this.state.children && this.state.children.length) {
            this.setState({ children: null });
          } else {
            this.setState({ children: this.props.data.children });
          }
        }
        ev.preventDefault();
        ev.stopPropagation();
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var isOpen = !!(this.state.children && this.state.children.length);
        var hasChildren = this.props && this.props.data && this.props.data.children;
        var _state = this.state,
            data = _state.data,
            selected = _state.selected,
            children = _state.children;

        var _ref = data || this.props,
            id = _ref.id,
            label = _ref.label,
            icon = _ref.icon;

        var openIcon = isOpen ? 'px-utl:chevron' : 'px-utl:chevron-right';
        return _react2.default.createElement(
          TreeNodeStyled,
          {
            open: isOpen,
            closed: !children,
            leaf: !hasChildren,
            branch: !!hasChildren,
            'data-open': isOpen,
            'data-leaf': !hasChildren,
            'data-branch': !!hasChildren,
            selected: this.state.selected,
            ref: function ref(el) {
              _this2.node = el;
            },
            onClick: this.onChildDisplayToggle
          },
          _react2.default.createElement(
            TreeNodeLabel,
            {
              'data-id': id,
              selected: selected,
              leaf: !hasChildren,
              branch: !!hasChildren
            },
            hasChildren && _react2.default.createElement(
              TreeNodeIcon,
              null,
              _react2.default.createElement(_Icon2.default, { icon: openIcon, size: 16 })
            ),
            icon && _react2.default.createElement(
              TreeNodeIcon,
              null,
              _react2.default.createElement(_Icon2.default, { icon: icon, size: 16 })
            ),
            _react2.default.createElement(
              'span',
              { onClick: this.onCategorySelect },
              label
            ),
            ' '
          ),
          this.state.children && _react2.default.createElement(
            TreeNodeContent,
            { open: isOpen },
            this.state.children.map(function (child) {
              return _react2.default.createElement(TreeNode, _extends({
                key: child.id,
                data: child
              }, child, {
                onCategorySelect: _this2.props.onCategorySelect
              }));
            })
          )
        );
      }
    }]);

    return TreeNode;
  }(_react2.default.Component);

  TreeNode.defaultProps = {
    id: null,
    label: null,
    data: null,
    selected: false,
    onCategorySelect: null,
    isSelectable: true
  };
  TreeNode.propTypes = process.env.NODE_ENV !== "production" ? {
    id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    label: _propTypes2.default.string,
    onCategorySelect: _propTypes2.default.func,
    data: _propTypes2.default.shape({
      children: _propTypes2.default.arrayOf(_propTypes2.default.any)
    }),
    selected: _propTypes2.default.bool,
    isSelectable: _propTypes2.default.bool
  } : {};

  exports.default = TreeNode;
});