(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'prop-types', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('prop-types'), require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.styledComponents);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var VHeader = _styledComponents2.default.div.withConfig({
    displayName: 'ViewHeader__VHeader'
  })(['height:4rem;background-color:var(--px-view-header-background-color,whitesmoke);padding-left:1rem;padding-right:1rem;display:flex;align-items:center;flex-direction:row;position:relative;user-select:none;']);
  VHeader.displayName = 'ViewHeader';

  var VHeaderText = _styledComponents2.default.div.withConfig({
    displayName: 'ViewHeader__VHeaderText'
  })(['padding-left:1rem;padding-right:1rem;flex:initial;min-width:0;margin-left:auto;margin-right:auto;min-width:1px;']);
  VHeaderText.displayName = 'ViewHeaderText';

  var VHeaderTitle = _styledComponents2.default.div.withConfig({
    displayName: 'ViewHeader__VHeaderTitle'
  })(['text-align:center;color:var(--px-view-header-title-color,black);overflow:hidden;text-overflow:ellipsis;white-space:nowrap;']);
  VHeaderTitle.displayName = 'ViewHeaderTitle';

  var VHeaderSubTitle = _styledComponents2.default.div.withConfig({
    displayName: 'ViewHeader__VHeaderSubTitle'
  })(['text-align:center;color:var(--px-view-header-subtitle-color,gray);font-size:0.8rem;line-height:1.66667;font-weight:400;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;']);
  VHeaderSubTitle.displayName = 'ViewHeaderSubTitle';

  var VHeaderLeft = _styledComponents2.default.div.withConfig({
    displayName: 'ViewHeader__VHeaderLeft'
  })(['position:absolute;left:1rem;']);
  VHeaderLeft.displayName = 'ViewHeaderLeft';

  var VHeaderRight = _styledComponents2.default.div.withConfig({
    displayName: 'ViewHeader__VHeaderRight'
  })(['position:absolute;right:1rem;']);
  VHeaderRight.displayName = 'ViewHeaderRight';

  var ViewHeader = function ViewHeader(_ref) {
    var title = _ref.title,
        subtitle = _ref.subtitle,
        leftContent = _ref.leftContent,
        rightContent = _ref.rightContent,
        children = _ref.children;
    return _react2.default.createElement(
      VHeader,
      null,
      _react2.default.createElement(
        VHeaderLeft,
        null,
        leftContent,
        children && _react2.default.Children.map(children[0], function (child) {
          return child;
        })
      ),
      _react2.default.createElement(
        VHeaderText,
        null,
        _react2.default.createElement(
          VHeaderTitle,
          null,
          title
        ),
        subtitle && _react2.default.createElement(
          VHeaderSubTitle,
          null,
          subtitle
        )
      ),
      _react2.default.createElement(
        VHeaderRight,
        null,
        rightContent,
        children && _react2.default.Children.map(children[1], function (child) {
          return child;
        })
      )
    );
  };

  ViewHeader.propTypes = process.env.NODE_ENV !== "production" ? {
    title: _propTypes2.default.string,
    subtitle: _propTypes2.default.string,
    rightContent: _propTypes2.default.node,
    leftContent: _propTypes2.default.node,
    children: _propTypes2.default.node
  } : {};

  ViewHeader.defaultProps = {
    title: null,
    subtitle: null,
    rightContent: null,
    leftContent: null,
    children: null
  };

  exports.default = ViewHeader;
});