(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'styled-components'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('styled-components'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.styledComponents);
    global.flex = mod.exports;
  }
})(this, function (exports, _styledComponents) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Flex = _styledComponents2.default.div.withConfig({
    displayName: 'flex__Flex'
  })(['display:flex;', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ''], function (props) {
    return props.row && (0, _styledComponents.css)([' flex-direction:row;']);
  }, function (props) {
    return props.rowrev && (0, _styledComponents.css)([' flex-direction:row-reverse;']);
  }, function (props) {
    return props.col && (0, _styledComponents.css)([' flex-direction:column;']);
  }, function (props) {
    return props.colrev && (0, _styledComponents.css)([' flex-direction:column-reverse;']);
  }, function (props) {
    return props.inline && (0, _styledComponents.css)(['display:inline-flex;']);
  }, function (props) {
    return props.wrap && (0, _styledComponents.css)(['flex-wrap:wrap;']);
  }, function (props) {
    return props.wraprev && (0, _styledComponents.css)(['flex-wrap:wrap-reverse;']);
  }, function (props) {
    return props.nowrap && (0, _styledComponents.css)(['flex-wrap:nowrap;']);
  }, function (props) {
    return props.left && (0, _styledComponents.css)(['justify-content:flex-start;']);
  }, function (props) {
    return props.center && (0, _styledComponents.css)(['justify-content:center;']);
  }, function (props) {
    return props.right && (0, _styledComponents.css)(['justify-content:flex-end;']);
  }, function (props) {
    return props.justify && (0, _styledComponents.css)(['justify-content:space-between;']);
  }, function (props) {
    return props.spaced && (0, _styledComponents.css)(['justify-content:space-around;']);
  }, function (props) {
    return props.top && (0, _styledComponents.css)(['align-items:flex-start;']);
  }, function (props) {
    return props.middle && (0, _styledComponents.css)(['align-items:center;']);
  }, function (props) {
    return props.bottom && (0, _styledComponents.css)(['align-items:flex-end;']);
  }, function (props) {
    return props.stretch && (0, _styledComponents.css)(['align-items:stretch;']);
  }, function (props) {
    return props.baseline && (0, _styledComponents.css)(['align-items:baseline;']);
  }, function (props) {
    return props.item && (0, _styledComponents.css)(['flex:1;']);
  }, function (props) {
    return props.flex && (0, _styledComponents.css)(['flex:', ';'], props.flex);
  }, function (props) {
    return props.item && props.top && (0, _styledComponents.css)(['align-self:flex-start;']);
  }, function (props) {
    return props.item && props.middle && (0, _styledComponents.css)(['align-self:center;']);
  }, function (props) {
    return props.item && props.bottom && (0, _styledComponents.css)(['align-self:flex-end;']);
  }, function (props) {
    return props.item && props.baseline && (0, _styledComponents.css)(['align-self:baseline;']);
  });

  Flex.displayName = 'Flex';

  exports.default = Flex;
});