(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.index = mod.exports;
  }
})(this, function (exports) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });


  var $baseFontSize = '15px';

  function calculateRem($size) {
    var $remSize = $size / $baseFontSize;
    var $remUnit = '1rem';
    return $remSize * $remUnit;
  }

  function remToPx($size) {
    var $remUnit = '1rem';
    return $rem / $remUnit * $baseFontSize;
  }

  var helpers = { calculateRem: calculateRem, remToPx: remToPx };

  exports.default = helpers;
});